2011.11.07 ??:?? version 1.0
- Icy Lands
- ASCII graphics

2011.11.08 ??:?? version 1.1
- blog post: http://zenorogue.blogspot.com/2011/11/hyperrogue-11.html
- I have added some keys to control the visual presentation. 
- I have also added an option of a 3D view using red and cyan glasses. 

2012.03.12 ??:?? version 2.0
- blog post: http://zenorogue.blogspot.com/2012/03/7drlc-hyperrogue-ii.html
- There are seven types of lands for you to travel, each with specific monsters, treasures, and terrain features.
- You can also find some magical orbs, which give you temporary magical powers.
- The game also became more user friendly. You get tooltips and help, and a configuration screen, instead of having to press strange keys.

2012.03.16 ??:?? version 2.1
- The game should no longer crash when moving in certain directions while having mirror images.
- Living Caves now include Seeps and are thus now more challenging.
- You can no longer deactivate an ivy plant by cutting out an active branch next to the root.
- Shield protection from a sandworm is now less weird.
- Slime colors are now named correctly.
- Some sanity checks added just in case.

2012.04.23 ??:?? version 3.0
- blog post: http://zenorogue.blogspot.com/2012/04/hyperrogue-iii.html
- graphics
- the Land of Eternal Motion
- Graveyard
- R'Lyeh
- Hell
- Yendor Quest
- balance improvements

2012.05.03 ??:?? version 3.1
- This version contains many optimizations, which make the animations much smoother. 
- Android port
- "dead ivy" shows correctly
- necromancy bugfix
- restarting after finding the Orb of Yendor no longer crashes the game
- help fits better on the screen
- you can right click the framerate for hints about improving it

2012.05.04 ??:?? version 3.2
- blog post: http://zenorogue.blogspot.com/2012/05/hyperrogue-bugfix-32.html
- The big white X which appears during the final quest should no longer disappear randomly (thanks to ortoslon for reporting this).
- Using the anaglyph mode ("distance between eyes") no longer causes the letters to disappear. 

2012.05.05 ??:?? version 3.3
- blog post: http://zenorogue.blogspot.com/2012/05/7drl-reviews-and-hyperrogue-version-33.html
- This update is rather minor. Some descriptions are improved; they are now more accurate and detailed. Made it clear that there are actually many Orbs of Yendor. Cultists in the Icy Lands produce more heat now. HyperRogue should now work correctly in a resolutions with height greater than width (not only on Android).
- The Android version gets a "share" function, which allows you to share a short description of your character (together with a screenshot). Your characters are be no longer destined to be lost without any trace. 

2012.05.13 ??:?? version 3.5
- blog post: http://zenorogue.blogspot.com/2012/05/hyperrogue-35-and-osx.html
- a bug with the Cultists' ranged attack in R'Lyeh, which was not working as intended
- OSX binary by Konstantin Stupnik

2012.06.10 ??:?? version 3.6
- Ivy plants were supposed to be a prominent feature of Jungle, but they were rather something that you see from time to time, and you should run away from, because there was no reason to fight them. This is changed. Jungle got rebalanced.
- Wandering monsters. It is no longer safe to just stay in one place and wait for monsters. (As a counterbalance there are less "stationary" monsters)
- A high score list. Accessible via ESC-t. You no longer have to remember your best scores :) (it uses the same log file as previous versions, but unfortunately is unable to read their scores)
- The Land of Eternal Motion now has its own Orb (rather than pretending that it has falled through a huge hole). This new Orb is also expected to improve the performance on devices with low memory.
- You no longer get 1000 points for the Orb of Yendor, only 50. The motivation here is that you should be able to play HyperRogue in two ways: as a completionist (aim to get the Orb of Yendor to win the game) or as a perfectionist (get a high score), and the quest for Orb of Yendor should not get into the perfectionist's way.
- You can now switch places with golems (previously it was quite easy to kill them, or to lose because of being blocked by them... I have decided that the game would be better without such problems)
- I have tried to actually play with the wersdzxc keyboard layout and found it very awkward, so switched to qweadzxc; also the quit/restart keys got changed to prevent confusion
- removed the Rangers from crossroads (creatures native to all lands appear on the Crossroads, so there is no need to make it even harder by adding Rangers; the screenshot above still has them...)
- running dogs no longer look as if they appeared from nowhere (I think it got broken in some earlier version)
- you are now allowed to get an Orb of Shielding even if there are monsters nearby 

2012.06.28 ??:?? version 3.7
- HyperRogue looks better on Windows now, as it has an icon, and version information.
- You can now disable the red axes which show you where directional keys will take you. By default, they disappear automatically if using a mouse, and reappear when using keyboard (they are useful only for keyboard users). 
- In the Android version, there was a bug with panning ("DRAG"), which caused the display to disappear when trying to do panning. Also panning is faster now (i.e., more fps). 

2013.08.02 ??:?? version 3.8
- the window is resizable, instead of having a fixed list of resolutions
- exits cleanly in case of errors, such as the missing font file or unability to initialize SDL
- fixed a crash bug with wandering worms
- mousing over "help" in the config menu lists the hidden features, such as the graphics editor or the showoff mode
- some command line options are added (try --help)
- the SDL.dll file has been updated to a more recent version (screen size is now detected correctly) 

2013.10.11 ??:?? version 4.0
- music by Neon Corridor
- Ivies have been greatly improved: they shrink if an active branch sees no good move (except at the root), they are now active as long as there is at least one segment in view, and they no longer go to the Alchemist Lab (as this caused bugs). Also, if you cut an active Ivy just after root or another branching point, it immediately regrows and spins (previously it regrew without spinning at the root, and caused bugs at other branching points)
- Worms are now active as long as there is at least one segment in view, they now destroy walls and thumpers around them when they explode (so if you find a good place for killing worms, it is hard to use it more than once), and worms and tentacles can go to other lands now, except Motion and Alchemist (but worms produce spice on explosion only in the Desert)
- After getting 10 Demon Daisies, Crossroads get a unique treasure to be found (Hyperstones), so the player has some point to spend time there (should be fun, since you are likely to meet almost all monsters and orbs on the Crossroads)
- the cheat mode has been extended (press F2 F4 to start cheating, then press shift+letter for various effects)
- Cocytus works now (but is still available only via cheating or by getting an insane score)
- if you collect a lot of items in a single land, this increases the spawning rate of wandering monsters in all lands, so you are no longer relatively safe by walking at the edge
- when used on a location containing both an item and a monster, context help now shows information about the monster
- added some flavor messages, and replaced "ESC to quit" with "ESC for menu/quest", to make it more clear to the players that there is more about the game than hunting for treasure
- pressing F1 or right clicking while looking at the context help now displays the general help screen
- Fixed the Crossroads description (there are no longer Crossroad Rangers and big holes in the ground)
- improved the general help screen
- improved the handling of non-qwerty keyboards (movement is done according to the QWERTY layout as previously, but other menus take the layout into account correctly)
- Alchemist Lab: the description is more detailed now, killing lots of slimes no longer degenerates the Alchemist's Lab into pure treasure, slime beasts now destroy items around them when killed, and dead orbs no longer cause the slime to spill
- Living Caves: Foreign monsters and objects affect the Living Caves now, and cave trolls now destroy items around them when killed
- Graveyard: killing graveyard monsters slowly increases the initial monster rate in the graveyard (so grinding for Dead Orbs is harder), and necromancers can go outside the Graveyard now
- renamed Icy Lands and Living Caves to singular (for better grammar) 

2013.12.10 ??:?? version 4.1
- In the Android version, the Android-standard menu for user settings (which are saved now), and the game log is available from the menu. (This was actually done in version 4.0b, but not announced here.)
- Added tags to the OGG files. (Actually this was already done in "hyperrogue-40t.zip", but not announced here.)
- An option to reduce the framerate limit to conserve CPU energy. Also framerate is reduced in non-game screens and when the app is not in focus. (Thanks to Damyan Ivanov for suggesting this!) Unfortunately desktop only, for now (on Android the framerate is low even with full CPU usage, at least on my devices).
- Alchemist's lab fixes: all monsters (except eagles and ghosts) now adhere to the rules. Fixed a bug with pushing Thumpers through. Mimics and mirrors no longer damage the slime colors. Worms and Ivies can enter the Alchemist's Lab now. Flash/lightning spells now copy the slime color under PC when used in the Alchemist's Lab (thus allowing easy travel). (Thanks to Andrew Farnsley for mentioning this and several other bugs!)
- The Jungle is easier now. (Previously, either a single ivy with 7 branches, or two ivies next to each other with 5 and 4 branches, were generated; the ivy got less branches if the required cell was blocked. Now, the harder case only happens in 25% cases (instead of 50%), and the ivy is not generated at all if some of the locations for branches are blocked by other ivies.)
- The greater demon description now explains the mechanics is more detail. Mimics and mirrors no longer kill greater demons (they turn them to lesser demons instead).
- Fixed a minor bug with Thumper power draining incorrectly, and a bug with bonfire power draining twice as fast as stated.
- Eagles and ghosts no longer fall or collapse tiles in the Land of Eternal Motion. Also, Eagles now actually fly (i.e., can go through lakes, chasms, and slime).
- The Esc-screen now displays the last messages (scrollable with the arrow keys).
- Contributors are now listed in the Credits section in Help.
- Added missing license files to the package.
- Fixed the filename in hyperrogue-music.txt for Cocytus. 

2013.12.17 ??:?? version 4.2
- OpenGL
- fixed a crash bug with Ivy
- a better looking Wolf

2014.01.17 ??:?? version 4.3
- Pandora version
- You can now actually control the whole game with keyboard (well, except the graphical editor and the help which you get when you right-click the framerate). When panning with arrows, a cursor appears, and you can press F1 for more information about that location, or 't' to teleport (if allowed).
- Keys 't' and 'g' now display messages if you have no respective Orb.
- You can now use a joystick to move. If you have two joysticks, the second one can be used for panning. There are two modes of joystick movement (press 'p' to switch).
- Right Shift and Right Ctrl change the meaning of mouse presses (useful with touchscreens and mice with too few buttons).
- Anti-aliasing can be enabled/disabled in the config file.
- Window caption was missing.
- You can now press the middle button to pan (a quite fun feature that was previously available only on Android), or use the mousewheel for far movement (down) or panning (up). 

2014.03.02 ??:?? version 4.4
- Orb of Safety saving
- Orb of Lightning's animation has been moved to Orb of Safety
- Orbs of Lightning use a new sparkling animation

2014.08.04 ??:?? 
- HyperRogue for jailbroken iOS

2015.01.28 ??:?? version 5.0
- Cocytus
- Dry Forest
- localization 
- many other improvements to the user interface, game balance, and gameplay

2015.02.06 ??:?? version 5.3
- Euclidean mode

2015.02.22 ??:?? version 6.0
- Vineyard
- Dead Cave
- Hive
- Emerald Mine
- Land of Power
- One new achievement (not included ones related to the new lands).
- The Lightning spell now react a bit differently to some types of obstacles.
- Fixed anomalous Great Walls.
- Fixed slime spilling through monsters.
- Changed how Orb of Digging works, and renamed Orb of Earth.
- Worms explode on death, as they were supposed to.
- You no longer generate that much heat when entering a cold land.
- No more plus signs when slime spills into the Graveyard.
- The graphics editor supports 't', 'y' keys for moving and rotating shapes (not documented).
- Internal changes in the grammar/translation system. 

2015.??.?? ??:?? version 6.0x
- a bug with rings.
- better coloring of Emerald mines.
- "You can right click any element to get more information about it."
- Hives renamed to nests.
- Silver sign.
- Power is drained when teleporting out of the Land of Power.
- Bugs related to saving fixed. 

2015.??.?? ??:?? version 6.1
- most monsters now target your friends and hyperbugs (previously they only targetted you (unless invisible) and Thumpers), also fixed a bug with Invisibility
- running dogs (and other monsters in LoEM) now try to run away (in a roughly straight line) even if they have no target, instead of just falling
- some halfvine bugs should be fixed (both graphical and logical)
- changed the ASCII symbols a bit
- changed the colors a bit (Miner's pick axe and Hedgehog Warrior's body is brighter)
- you no longer produce chasms when using Orb of Aether in the LoEM
- ruby achievements should be working again 

2015.03.04 ??:?? version 6.2
- Camelot
- Temple of Cthulhu
- Distance calculated better in the logfile.
- Stabbing achievements are fixed.
- Extra messages when finding treasures.
- The display of the player changed a bit in the cheat mode.
- Better facing for Golems.
- Starting location has been fixed for the Vineyard, Land of Power, and Emerald Cave in the Euclidean mode (anyway, these three lands have maps which are strongly based on the hyperbolic geometry, so they don't look that interesting the Euclidean mode).
- Structure display cheat (ctrl+C). Treasure cheat (shift+T) improved. 

2015.??.?? ??:?? version 6.2a
- Russian translation.
- Added info about wandering Ghosts to the Ghost description.
- Worm explosion destroys big statues.
- Cult leaders appear in R'Lyeh now, to prevent the player from camping in Temples.
- No GAME OVER if you can still mindblast someone.
- time recount
- You can no longer use Knights for the Golem achievements.
- Fixed the message when Knights are killed by monsters.
- More cloak colors. Cloak color is saved.
- Removed the Thorn power when getting the Holy Grail (it was likely to cause you to kill Knights).
- Fixed a possible crash with Knight outside of Camelot (it seems very hard to make him leave Camelot, but anyway).

2015.??.?? ??:?? version 6.2b
- updated the Turkish translation, language is now also selectable in Steam. 

2015.??.?? ??:?? version 6.3
- new Orb types to the new lands (Temple and Camelot). Orb of Dragon allows one to throw fire just like the Cultists, while Orb of Trickery allows the player to place illusions of themselves. Additionally, more monsters now take invisibility/friends/illusions into account. Also, the Russian translation is ready (and French and German translations are coming). 

2015.??.?? ??:?? version 6.4
- Golems (and Knights) now act after enemies, not before them. This has been changed because previously sometimes a move was judged as invalid (i.e., lead to death) even though actually a Golem would kill the responsible enemy first. Additionally, Golems will follow the player again (they just go straight towards the player without any pathfinding, though).
- You can now press ESC in the GAME OVER screen to see the circumstances clearly (for example, to take a screenshot of your last epic battle).
- For items and monsters, there is a 'high contrast' option which adds a bright border to them. Rather ugly, but effective. You can also press ALT during the game to achieve the same effect.
- Since heptagons often give a tactical advantage, there is also an option to display heptagons darker.
- Finally, there is an option to require pressing Shift to target the Orbs with ranged powers (Teleport, Trickery, the Mind, and the Dragon). 

2015.??.?? ??:?? version 6.4a
- HyperRogue 6.4a disables the useless "ESC for menu/quest", and fixes the Miner/Slime interaction. 

2015.04.07 ??:?? version 6.5
- blog post: http://zenorogue.blogspot.com/2015/04/hyperrogue-65.html
- Hyperbugs no longer die on attack. Also, they are more likely to target you if you have collected lots of Royal Jellies. This should make it somewhat harder to achieve very high scores there (I think there is no need to remove any scores, but I can remove your score if you want).
- Fire Cultist attack now causes books to burn (not that it matters much...). On the other hand, some orbs are now invulnerable to fire (previously one specific orb did not burn, which was intentional, but it happened in one specific situation, which was misleading).
- Sometimes scores were not submitted to the Steam Leaderboards due to connection problems, hopefully it should be more robust now.
- The local scoreboard (ESC-t) has been improved: more types of scores can be checked, and you can press 't' to ask for a specific score type easily. Additionally, Miner kills and some Orbs are saved now (they were not saved previously).
- Some minor problems with the Euclidean mode have been fixed: Great Walls disappearing when using Orb of Safety on the Crossroads; Orb of Winter graphics; scrolling and rotation (arrows, Page Up, Page Down) are working correctly now.
- Using an Orb of Safety in Camelot/Temple no longer causes a crash (it was possible only in the Cheat mode, anyway).
- One bug in the Polish translation fixed. 

2015.05.13 ??:?? version 6.6
- blog post: http://zenorogue.blogspot.com/2015/05/hyperrogue-66-and-desura.html
- Some bugs related to Mimics (Mirages and Mirror Images) have been fixed: they are now destroyed when they stray too far away, when you teleport, or when they attack an Ivy. (If they were not destroyed in these situations, it could potentially lead to weird behavior.) Also, they no longer change their direction without a reason in the Alchemist Lab.
- Walls left by killed Vine Beasts are now more visible in the Hive.
- Shift-clicking on a cell now does nothing if it is impossible to cast a spell from a ranged Orb at the given location.
- HyperRogue's log file has been improved a bit. The implementation is much more clean, and it lists achievements gained, and data proving that the scores have been achieved in an official paid version of HyperRogue. This could be potentially used to prevent some forms of cheating by tampering with saved games (although it is possible to cheat anyway, just a bit harder). 

2015.06.04 18:11 version 7.0
- posted on the blog: http://zenorogue.blogspot.com/2015/06/hyperrogue-pirates-rocks-and-knives.html
- shoot'em up mode
- Caribbean
- Red Rock Valley
- Crossroads II
- Hardcore mode, which disables the checkmate rule. No achievements yet.
- Fixed the temperatures: melting points for Sages and Frozen Lakes are as expected now. Also, Wolves no longer leave Icy Lands/Cocytus, and heat is transferred correctly between Icy Lands and Cocytus (just a small effect, though).
- Refactored monster movement a bit, for the purpose of Shmup mode. Hopefully this does break anything (though that I see that Vine Spirits no longer camp near to Wines).
- Jungle and the Land of Mirrors will no longer appear next to the Land of Eternal Motion, to prevent Eagles from attacking you there by surprise.
- Demon Daisy generation rate is fixed.
- More monster types in the Crossroads.
- Pheromones restricted.
- You can no longer go over the cap with orb powers received from the Orb of Yendor/Holy Grail (otherwise Orb of Space could allow some exploits by bringing lots of Orb of Yendor together and unlocking them all at once).
- Talking to knights outside of Camelot no longer crashes the game.
- A message is now given when trying to attack an escaping Tentacle (just like for other cases of Tentacles).
- You can no longer drop Dead Orbs while moving through a wall.
- Headers should now be always shown in the local scoreboard.
- Local highscores are now available for other game modes (Euclidean, hardcore only, and Shmup).
- (technical) Stats for translations, some comments (just a few) added to the source.
- big statues are no longer so cold

2015.06.04 23:35 version 7.0a
- fixed Orb of Safety in the shmup mode
- fixed euclidean Camelot
- monsters now can drown in the sea
- Winter Witches and fire-resistant orbs should no longer burn in certain situations
- top text brighter in Red Rock Valley

2015.06.05 11:15 version 7.0b
- removed spam for snakes on water, they can no longer go over LoEM
- fixed the music file
- added the missing line "You are killed by..." to the translation

2015.06.06 11:57 version 7.0c
- Added some markers for heptagons
- Made Compasses not appear in there is another one in radius 2
- Fixed buggy Camelots appearing next to Caribbean.
- Fixed Orbs of Space not triggering the Game Over after you execute your only move which was moving a treasure.
- Fixed Orbs of Yendor not moved correctly with OoS/boats.

2015.06.08 10:03 version 7.0d
- Fixed the starting land.
- Fixed the mimics' target markers.
- Fixed the Hyperstone Quest message ordering.
- RRV was too dark in non-Escher modes; also brightened the Vineyard and Dead Caves, and made Fire in RRV look better.

2015.06.13 13:52 version 7.0f
- Running Dog are generated on chasms again (and thus their trails look correctly)
- Red/dark trolls no longer do almost exactly the same.
- Eagle attack has been fixed (do not kill the player on their second move in the Hardcore mode, and no "confused" message in non-hardcore)
- Rock Snakes now attack Golems, Hyperbugs, and Illusions
- Fixed some bugs with the Shmup mode: Orb of Yendor could be collected without the Key; Orb power is drained quickly when you have an Orb of Speed (just as in the normal HR); picking up items while using an Orb of Invisibility turned you visible just for a single frame; Orb of Shielding were not consumed if you also had Orb of Time
- added the achievements for collecting the Orb of Yendor in the new modes (hardcore, shmup)
- added the leaderboards for the shmup mode. Total treasure is counted, and for winners, time and the number of knife throws are recorded (I think it is feasible to win with the perfect score of 0 knife throws)
- added a new emoticon "pirate" and some backgrounds, for Steam

2015.06.19 23:26 version 7.0g
- Burning tentacle spam removed.
- The shmup welcome message is translated.
- The "evil stars" (in hellish lakes) no longer can cover a passable spot, and the frequency of lakes has been reduced slightly, to make the Yendor quest easier.

2015.06.20 13:22 version 7.0h
- Fixed a bug which could have caused the game to start in the purple land and cheat mode.

2015.06.21 14:50 version 7.0i
- Fixed moving the Key with the Orb of Space.
- You can now target with mouse and use joystick in the shmup mode. You can now rotate instantly with mouse/joystick, while it was impossible before, but I think it is better that way. 

2015.07.17 16:27 version 7.0j
- You can no longer attack trees while in a dangerous terrain (fire/chasm/etc).
- On your last turn of Aether, you are now allowed whenever the destination is passable (up/down rocks, switch slime colors, through halfvine cells).
- Fixed a bug which gave back 3 lives and 'welcome to shmup' on using Safety.
- The path to the Key is now generated with more details, hopefully this fixes the various problems mentioned the archmageomega.
- Fixed two minor bugs in the Polish translation.

2015.07.20 ???? version 7.1
- Ocean
- Minefield
- Version 7.1 also has some other features. Press 'v' or click the 'menu' button to see the new main menu, which conveniently lists all the features of HyperRogue. Also, a FAQ (Frequently Asked Questions) written by Fulgur14 is now available on the website. These two features should make it easier to fully enjoy HyperRogue. Also, the shmup mode correctly says that the number of knifes is counted (not the number of turns), fires are burning off and heat dissipates even offscreen (previously, many of the speed runs abused the fact that heat did not dissipate offscreen), Fire Cultists can attack more terrain types, another message is used for Sandworm explosions when you see no spice created, and a bug which caused the Icy Land to become too hot in the shmup mode has been fixed.
- Also, the German translation should be available soon. Have fun! 

2015.07.23 13:01 version 7.1a/b
- "(v) menu" instead of "(v) config"
- blow into water/fire/mines
- the PC could just stand in place during high tide and not drown
- fixed the "escaped Whirlpool" achievement
- fixed the Restart key
- in the very unlikely scenario when the Key is generated in the Whirlpool, it is protected by a Pirate party with Orbs of Water, so it hopefully does not run away and you can escape the Whirlpool

2015.07.23 13:01 version 7.1c
- you can no longer use Orb of Air against sharks, seeps, and other restricted monsters.
- but you can use Orb of Air to blow monsters into chasms.
- made the Ocean less bright in the plain mode (still brighter than LoEM), and the Minefield slightly brighter (to make it more different from the Land of Mirrors). Also, made the fire graphically calmer in the Land of Power.
- Orb of Aether now protects you from mine explosions, but also makes you unable to detect mines.
- for thematic reasons, R'Lyeh is now more likely to be adjacent to Ocean (and less likely elsewhere).
- Fixed the Hyperstone Quest message to include new lands.
- Two new achievements added ("Black Mark" and "Nasty Pet")
- Fixed a bug with Space/Safety (the game was trying to calculate the cost after Safety acted -- this is fixed, hopefully this fixes the crash too)
- Fixed a bug with Crossroads II/Ocean border
- mine marks now appear above the PC/monsters.

2015.07.24 11:11 version 7.1d
- bug with Crossroads II generation which also caused the game to stop generating lands
- saving the new treasures/kills
- Euclidean mode supports the new land, as well as the gameboard modes (pick the gameboard mode you want, and then pick Euclidean mode, to activate an Euclidean gameboard).

2015.07.24 13:22 version 7.1e
- collecting OoY works.

2015.07.25 00:24 version 7.1f
- Tame Bomberbirds now fly over chasms
- Forgetting old kills during saving, this is fixed. 

2015.08.04 00:24 version 7.1f
- the German translation is finally there, also the Russian and Turkish translations are updated to 7.1 (German achievements and some in other languages are still missing)
- the Graveyard no longer appears next to Red Rock Valley, Dry Forest, or the Emerald Mine (as the Graveyard pattern benefits the Hedgehog Warriors and Rock Snakes too much)
- mine count messages are translated now
- fixed the minefield display in the ASCII mode (@ and monsters were not displayed)
- minefield should now work correctly in the shmup mode
- monster names are now translated in the shmup mode
- a bug which caused weird things to happen in the shmup mode after leaving the game and returning should be fixed

2015.08.11 ????? version 7.2
- blog post http://zenorogue.blogspot.com/2015/08/hyperrogue-7.html
- Palace
- Living Fjord
- coop shmup
- Also, the shmup mode has received some more improvements. Coop required keys to be configurable, so you can redefine your keys and joysticks now (only in the shmup mode, but not only when playing with two players). Moreover, you no longer move slower when going backwards, and you can choose to use either the forward-backward-turn left-turn right, or the up-down-left-right cotntrol with the keyboard. 
- You no longer break mirrors or cut trees while using an Orb of Aether
- LoEM now appears as a basic land. Red Rock Valley and Cocytus are more likely to appear next to similar lands. The special border generation rules for R'Lyeh are disabled once you have found enough treasure thren, so you can escape more easily.
- Tame Bomberbirds should be saved now with Orb of Safety. Orb of Friendship now works as a bonus life in the shmup mode.
- Water and red rock are now displayed correctly in the Hive.
- Red Trolls now work correctly in the Minefield.
- Pikemen did not kill the PC by moving next to them in the hardcore mode.
- Bonfires on the coast are now extinguished during the tide.
- Fixed a bug which sometimes made it impossible to light bonfires in the Icy Land.
- Fixed a bug with Orb of Aether still draining power while using Orb of Time.
- Fire Cultists (and Orb of Dragon in general) can now destroy stranded boats
- Flavor messages for killing monsters were shown only when killing directly. 

2015.08.12 09:35 version 7.2a
- skipping a turn with the mouse
- nerfed the frequency/duration of the Orb of the Fish
- fixed the reference in the pushing description (Thumper/Guard/Skeleton)
- added a comment that Skeletons are stunned for a longer time outside of the Palace 

2015.08.12 16:27 version 7.2b

- you no longer activate pressure plates while using an Orb of Aether
- Fire Cultists will just wait if they cannot fire at your current location (e.g., a Palace gate)
- fixed the weird facing direction
- updated the Czech and Russian translations, also fixed some minor text problems 

2015.08.15 11:44 version 7.2c
- the Orb of Thorns now stuns and damages the stunnable monsters. 

2015.08.19 21:13 version 7.2d
- I have added a map editor. It is activated with Shift+A from the cheat mode, and allows you to place arbitrary monsters, walls, items and lands. It is somewhat ugly for now, and it is probably possible to crash the game by creating illegal configurations, but it should be useful for testing, and better for drawing new ideas for maps than the game board mode. (Maybe some save map feature for next versions?)
- a typo in the Land of Power
- Fjord-related things in the shmup mode: Water Elemental did not move at all, Vikings use boats correctly now, land monsters no longer run into the water to catch you when you are on the boat
- worms now prevent gates from closing 

2015.08.23 02:21 version 7.2e

- sharks now see you when you are diving (actually also parrots and all monsters restricted to specific wall type -- too many special cases otherwise)
- fixed the unlocking rule for Orb of the Frog
- the Orb of the Frog / Orb of Safety crash should be fixed
- Orb of the Frog + Orb of Aether = jump through walls (and even through worms and other monsters, even if Orb of Aether does not normally allow that)
- Orb of Teleport now works together with Fish/Winter/Aether to teleport you into dangerous terrain
- fixed the single weird beach which sometimes appears near Sea Border
- Earth Elemental now knows that it can go through sea in the Fjord
- worm explosions no longer extinguish eternal fires
- empty cells will no longer be colored weirdly in Minefield and Caribbean
- wandering ghosts now appear correctly in the shmup mode
- Turkish translation updated
- map editor: 'copy' feature for the map editor (you can copy larger circles by setting the radius); removed chasmD; fixed Shift+A moving in gameboard; more vertical space in the list
- fixed the bugs with Discord/worms (ivies already worked correctly, but I forgot to prevent monsters from attacking enemy worms)
- slightly improved the programming in some places, which also fixed many small details: red rock/halfvine interaction, rubble is now rock level 1, discord/Flash Witch, monster pathfinding in RRV, no longer can blow into monsters in water/air, chasms in palace treated as chasms, slightly changed OoWater/Slime/Icy interaction

2015.08.23 20:15 version 7.2f
- pathfinding was not working correctly with chasms in LoEM and Palace
- rubble is displayed correctly again
- also, Orb of the Frog/Fish are translated now, and fixed a minor error in Turkish translation.

2015.08.25 ??:?? version 7.3
- blog post: http://zenorogue.blogspot.com/2015/08/hyperrogue-73-edit-map-and-save-princess.html
- Princess Quest
- The Map Editor has already been present in the late patches to 7.2, but it is better now. Activate it from the "special game modes" menu (or by Shift+A in the cheat mode). There, you can place walls, items and monsters, copy parts of the map, save high quality screenshots (to BMP), and even save/load the map to a file! 
- Refactored monster movement. This means that Rock Snakes and mimics activate plates now (they did not previously), and monsters' special movement effects (for example, Pikeman attack and trails) are now activated by the Orb of Air.
- Messages are now different based on whether the monster is living or not (you no longer "kill" Skeletons).
- Rock Snakes are now generated correctly. Also fixed a small bug with worm/gate interaction.
- Activating the Cheat mode while already in Cheat mode now disables it instead (simply restarting the game sometimes does not work, so this should make it easier)
- Activating the Gameboard mode no longer clears the map automatically, so you can use it to view the patterns in alternate ways (triangular/heptagonal boards, Emerald/Fifty codes). Press F5 if you want to clear the board.
- Help in the map editor, ability to set rotation by clicking on a specific point of the cell. Mines shown. Some crashes caused by illegal combinations are removed. 

2015.08.26 11:23 Version 7.3a
- fixed the Princess Challenge achievement
- fixed the Gameboard mode
- the Princess Challenge unlocking should now honor Steam achievements, so it should be available even if you unlocked it on a different computer
- fixed minor grammar errors, added some missing lines ("cannot jump on" and "b=boundary"), added the Czech translation 

2015.08.26 20:27 Version 7.3b
- The 'second joystick' no longer does panning by default, as it causes problems with some gamepads.
- the Russian translation has been updated.
- the Prince/Princess setting (in "customize character") is saved. Also, selecting "customize character" no longer automatically randomizes everything.
- the message 'You are entering the minefield' should no longer appear when you are actually leaving it. 

2015.08.28 01:57 Version 7.3c
- The Princess is now able to use boats. (Although probably it is safer to try one from Fjord, not one from a coast...)
- Princess now keeps her HP after using Orb of Safety.
- You can now jump over a Mouse. Jumping/teleporting into mirrors/cabinets/etc. activates their effects.
- Gates now also crush items when closing, and are completely destroyed with Flash even if only one half is in the area. Also, they should no longer be generated if the other half would be in a different land.
- Map Editor: added an undo feature, and a possibility to flip while copying large areas. It is also no longer possible to rotate regions so that hexagons/heptagons do not match.
- Skeletons are now marked as non-living (they sink, not drown).
- Fixed some text/translation errors. 

2015.08.29 11:11 Version 7.3d
- Golems, Mice, and Knights are moving again.
- Eagles no longer make extra moves after moving next to PC.
- Ghosts are no longer allowed to move next to each other, so being attacked by two of them at once is no longer almost surely fatal.
- Gameboard cells are no longer black if no gameboard mode is enabled.
- Bonfires are now lighted by nearby fires.
- Save/load map no longer crashes when a file is missing (or another error).
- (Android) Loading a game should no longer cause new items/monsters not to appear. 

2015.09.01 17:43 Version 7.3e
- stunning a monster on the Palace trapdoor no longer gives you the Death Runner achievement.
- Princess Challenge should now be available immediately after unlocking.
- High quality screenshots should now work on Windows.
- Fixed some errors in translations. (Also finally added the translated achievement names)
- Albatross kills are counted now.
- (Android) The rare Android crash should be fixed now. 

2015.09.01 23:24 Version 7.3f
- fixed the Euclidean mode

2015.09.05 13:13 Version 7.3g [shmup fixes]
- Leaders/Pirates/Vikings did not move.
- Save shmup config works correctly now (well, it did work correctly before, but it did not load).
- Boats are now stranded instead of disappearing in Fjord/Ocean coast.
- You now lose life immediately if your terrain becomes dangerous (tide comes, a gate is dropped on you, etc.).
- Tide, ghost spawn, and heat transfer in Cocytus are somewhat slower now.
- Orb of Air works nicely now.
- Clicking to use orb powers should no longer crash the game.
- Visited lands are recorded, so you can play them in the Euclidean mode later.
- Female cheaters now have a different "goat" head design. (To make her more different in the coop shmup) 

2015.09.05 21:20 version 7.3h
- The Turkish translation has been updated, and some other minor errors have been fixed.
- You can now frog-jump over the sulphur lakes.
- The 'hardness frozen' message no longer appears outside of Princess Challenge.
- Rock Snakes should now attack other beings correctly (lots of special cases here, and hard to make it work in a way which makes sense ;) the one moved to should be eaten completely, and whether the snake had succeeded to move or not, all the other adjacent snake's enemies (including those on heptagons) are attacked for 1HP).

2015.09.08 15:18 version 7.3i
- panning was not available in the map editor
- zelda's pattern is now available to play with (see the Suggestions thread)
- view range accessible with panning increased a bit in the cheat mode (including the map editor)
- in the map editor, you can now play with temperatures/timeouts by (shift)-clicking again (although this is ugly and undocumented for now)

2015.10.02 ??:?? version 7.4
- Ivory Tower
- Elemental Planes
- Zebra
- Crossroads III
- World Overview
- Random Pattern Mode
- There are also some interesting changes for the more creative players! Map editor, vector graphics editor, pattern modes, and gameboard modes known from the previous versions have been merged into one. That is, while in the map editor, you can press 'r' to choose one of the patterns -- when you edit some cell, all the other cells which are equivalent according to this pattern will be changed too! You can pick one of the three implemented patterns (Emerald, Palace, Zebra), and choose which symmetries are taken into account for equivalence. You can also press 'p' to paint the cells with any color; there are also some predesigned patterns available, including the old pattern and Gameboard modes, and options to draw only hexagons or only heptagons. You can press Space to switch between the map editor and vector graphics editor, which now allows not only to edit the player character and floors, but also items and monsters; moreover, if you are editing floors and a pattern is selected, this will affect floors according to this pattern -- which allows to draw more complex tesselations, like the Sunflower picture or Zebra patter above. You can also save and load your pictures now (pictures are also automatically saved when a map is saved), and last but not least, you can now select a file when saving and loading. 
- Also, there have been some balance changes. In the patches to 7.3, Eagles and Ghosts have been weakened. In 7.4, it is no longer possible to use Orb of Space to bring Orbs from the Land of Power (most of the power is lost, as if you tried to bring them out normally), and the Orb of Time + Orb of Shielding combination has been weakened somewhat. Ghosts can now go through Tentacles. Please inform me if you have abused these, and want to reset your score in the Leaderboards. 
- Some things were refactored (mostly regarding monster movement, setting things of fire, and temporarily activable objects), which should hopefully make some things work in a more uniform way, make easier to introduce new features in the future, and hopefully did not break anything. 
- It is now easier to navigate around obstacles in the shmup mode. Also, you can now select push direction when pushing thumpers in the shmup mode.
- Hardcore mode: monsters can now kill you in the LoEM, and being stuck on dangerous terrain (fire, chasm, etc..) in hardcore mode kills you now.
- Ivy no longer drowns.
- You no longer can control where the key spawns by moving Orb of Space.
- An unarmed Princess no longer can kill a skeleton.
- If you have a highscore of at least 25 Bomberbird Eggs, the Minefield reveals nearby cells right from the start.
- Thumper interacts better with palace features now.
- Cutting trees works better with Mimics now (mimics cut trees when you move, and attack when you cut trees)
- When Orb of Space is used in the Alchemist lab, it sets the color of the target cell (just like normally)
- Some typos and missing messages. Translations are not done yet. 

2015.10.04 ??:?? version 7.4a
- the Windows version was not uploaded to Steam
- 'o' in overview
- Sunflower has been added as a level which you can load 

2015.10.04 16:45 version 7.4b
- Unlock status is now displayed correctly in the Zebra and Elemental Planes.
- minor text errors fixed, Czech translation added
- the game turning itself off while out of focus works again
- in Crossroads III, Great Walls are no longer so completely filled with crossing Great Walls 

2015.10.06 10:54 version 7.4c
- Hex Snakes no longer stand in place when the player is invisible.
- Onyx is no longer so dark in the stats.
- In the shmup mode, heating Icy Land while standing on the outside works correctly now.
- In the shmup mode, water elemental works correctly now.
- cheating while Steam was still initializing had a chance to submit false scores to the Leaderboards, this is fixed now (probably that's why Fulgur14 got 10 Elemental Gems)
- When a Key is generated in the Ivory Tower, is rests on a platform.
- Improved the tesselation in the Ivory Tower, and also the Running/Striped Dog picture.
- Water elementals no longer can go through eternal fires (to make them consistent with Orb of Water and their AI). To make the difference clear, all Eternal Fires now cycle colors slowly.
- Russian translation updated. 

2015.10.06 22:23 version 7.4d
- I have added something temporarily which broke the Princess Quest, this is fixed. 

2015.10.07 23:25 version 7.4e
- Fire sometimes burned for incorrectly long time, this should be fixed now.
- Improved the Orb of Summoning.
- Switched the native Orbs for Zebra and Palace. Orb of the Frog still appears as a secondary orb in Palace, though (and is actually more frequent there than the Orb of Discord).
- Under the effect of Orb of Discord: Vizier/Flail Guard no longer commits suicide; enemies don't attack stunned enemies (just like they don't finish off the Princess).
- Orb of Shielding is now marked as useless in LoEM.
- Placed the new lands from 7.4 in the correct place in the Overview.
- Exiting the Help screen now brings you back to the previous screen.
- Princess Quest now works in Euclidean.
- Cheating using World Overview: you can now press Shift to remove treasures/orb powers instead of adding them; game over state is updated correctly
- Fixed some things in the Russian translation. 

2015.10.08 09:50 version 7.4f
- Orb of Shielding is no longer marked as useless in LoEM
- Air Elementals now do something interesting in the Shmup mode (shoot Airballs)
- Page Up/Down keys now disable auto-rotation in the Ivory Tower
- Stunned Hyperbugs no longer move 

2015.10.15 17:02 version 7.4g
- Random number generator has been improved. AFAICT previously the differenes in RNG on Windows and Linux caused the Windows version to create too much Eagles, so if you thought that Jungle was too hard, it could be better now.
- The Hive have been tweaked slightly. In particular, if you have lots of royal jelly, Blue Hyperbugs appear starting more frequently (while Red and Green hyperbugs can be summoned with Orb of Summoning). Also, lots of Hyperbugs appear if you have multiple Orbs of Yendor, so you can no longer get Orbs of Yendor that easily as Vipul did.
- The Cave Troll description mentions that they destroy nearby items on death.
- Fixed a bug which caused the maximum scores in the Overview to be incorrectly read from the local score file. It takes some time to download the scores from Steam, which probably caused the behavior mentioned by green orange.
- Whirlpool and Caribbean sometimes appeared as unlocked incorrectly in the Overview.
- Tweaked the Hyperstones: there are not so many hyperstones now (the amount is based on the total number of kills, but this number is much larger now than when hyperstones were originally introduced...). Monsters can be generated on hyperstones. Crossroads III have hyperstones and monsters as they should. Some new monsters can now be generated in the Crossroads during the Hyperstone Quest.
- Also, limited the spawn rate of Gold, as otherwise no walls are generated in the Living Cave.
- Orb of Air is marked as useless in the Alchemist lab (since it does not work against slime -
- it is useful against foreign monsters, or as a colorless cell, but there are too many prize orbs in Alchemist Lab anyway).
- Tame Bomberbirds can no longer navigate boats.
- Mines in the Hive are no longer invisible.
- The Graveyard Shadow is now female if the PC is female.
- Bomberbirds are now restored correctly by Orbs of Safety in the Ocean.
- Wolves are now displayed as facing the hottest adjacent cell (unless next to the player).
- Mines now explode when a Gargoyle is killed above them.
- Fixed a crash which sometimes happened with mimics in the shmup mode.
- Fixed some texts in the Polish translation. 

2015.10.20 version 7.4h
- Mine explosions now destroy dead trolls/gargoyles (but if the explosion kills the troll, the body is still left).
- Fixed a bug which caused some monsters to attack golems/discorded enemies several times
- Alt no longer highlights monsters while in menus. Also, Alt makes the background darker, for better visibility. The extra info text for Minefield/Hive is no longer displayed while in menus.
- In the Quest Status/Game Over Screen, arrows, page up/down, and mousewheel now correctly scroll the last messages, and if you have pressed ESC while in the Game Over Screen, it won't be redisplayed if you start scrolling the map.
- Turkish translation updated. 

2015.11.03 ??:?? version 8.0
- blog post: http://zenorogue.blogspot.com/2015/11/hyperrogue-80-on-steam-and-hyperrogue.html
- Overgrown Woods
- Land of Storms
- Pure Tactics Mode
- Yendor Challenge
- Wild West
- paper model creator added (as discussed in the last post).
- You can now find Orb of Yendor as a prize orb in the Whirlpool (it is possible to retrieve it), and trapdoors have been slightly tweaked in the Palace while you are on the Yendor quest.
- Fjord Trolls (as well as two new species of Troll) now create different walls than Cave Trolls, with a bit different properties.
- Multi-HP monsters generated in the Crossroads now work correctly.
- A bit more Pirates in the Ocean.
- Added help text to Euclidean and Shmup modes. It is now easier to exit the Euclidean menu.
- Added ranged orb text to more orbs.
- You no longer get three lives by picking up an Orb of Safety in the shump mode.
- Monsters pushed off Rock III with Orb of Air/pushing attack are now killed (except birds and skeletons). You can now also use the Orb of the Frog to jump on high rocks.
- Improvements in the Random Pattern Mode. The Emerald-based random patterns have been improved. Added patterns based on circles. Floor pictures are now randomly assigned (Zebra/Emerald/Tower pattern are used only when the underlying pattern matches). Codes are displayed on the screen, allowing you to recognize the underlying pattern (and potentially share with the developer).
- Coordinates are given when cheat mode is on in Euclidean.
- fixed the scrolling in the quit screen (sometimes the messages were already scrolled when the game ended, which could cause you to miss the final message in Princess Challenge/Hardcore)
- Orb of Storms now kills sharks in adjacent cells 

2015.11.04 21:23 version 8.0a
- Added missing text to translations.
- Added the Czech translation.
- Added non-dry description for the trees.
- Stunned Pikemen and Flail Guards can be attacked normally now (but stunned Flail Guards don't hit themselves).
- Mutant Ivies interact with Vines (just like normal Ivies).
- balanced the Great Walls in the Land of Storms (generated horocycles made great walls less likely to appear).
- fixed the Camelot bug mentioned by tricosahedron above

2015.11.05 09:58 version 8.0b
- Sorry, you were not sure about the Golems and I could not see how a Golem attack could prevent Mutant Ivies from growing, so I have assumed that it was false ;) In fact Mutant Ivies did not attack Golems (and other enemies), which was clearly wrong. Fixed in 8.0b. 

2015.11.05 12:32 version 8.0c
- fixed the pause screen clicking
- updated the Russian translation
- Orbs and Hyperstones incorrectly appeared in the pure tactics mode in Ivory Tower/Ocean, this is fixed

2015.11.06 01:30 version 8.0d
- Orb of Aether is again affected by Orb of Time; also, previously Orb of Time drained at full speed while you had an Orb of Shield (which is not protected from draining)
- Pure tactic and Yendor Challenge now have separate scoreboards in case if you enable shmup, coop shmup, and/or Euclidean mode (local only)
- Attacks of mimics which cause stunning now work correctly
- Fixed the whirlpool and Camelot glitches mentioned by Vipul
- Key in the Ocean appears on a small island again (I like the idea of having to fish for it... but I think it is better with an island after all)

2015.11.08 17:11 version 8.0e
- Yendor Challenges and Pure Tactics Mode now actually work in Euclidean. Also, the Euclidean Yendor Challenge is less stupid than before (the path is no longer in one of the cardinal directions)
- also, separate local scoreboards are added for hardcore Yendor/PTM
- Yendor challenge scores included only wins from the current version, this is fixed
- the second Whirlpool bug shown by Vipul above should be fixed
- the Minefield Yendor Challenge now finishes in the Icy Land (so that it is no longer impossible that the Key is unreachable)
- The Living Fjord has been added to the Yendor Challenge (monster generation rules on the path are tweaked)
- Runs with score 0 are no longer counted for the Pure Tactics Mode (this change works retroactively)
- Orb of Aether and Shield are now always marked as used in the Land of Storms (not a proper fix, but it should be good enough for now)
- Subtle color changes have been added to the Ocean coast
- the troll from the Living Caves is now named consistently

2015.11.09 18:08 version 8.0f
- Global high scores are now displayed in the pure tactics menu.
- 'pure tactics mode' title
- Orb of Discord now works in the shmup mode.
- Pirates/vikings now can carry items on their boats (invisible to the player, though).
- Turn-based elements worked incorrectly in coop shmup while carrying an Orb of Speed, this is fixed (they worked in turns where OoS had an even number of charges, but in coop, OoS drops by two charges per turn, causing weird effects).
- Save fixes: the number of saves is now recorded correctly, also fixed the possibly buggy reading of saves from an old version, and enabled the save tampering protection.
- Leaderboard entries updated to contain the data related to the newer lands.
- fixed Tirear's bug with incorrectly named treasures.
- Fixed the Orb of Space multiplying powerstones. Also, the Orb of Space is now drained when it is used on a glass cabinet.
- mines outside of the Minefield now blink.
- if you collect a huge amount of Ambers, Albatrosses are generated on the open sea (all scores in the pure tactics mode for Ocean have been removed).
- In some cases, monster generation was not affected by Orbs of Yendor collected, potentially allowing collecting many OoY easily -- this should be fixed (sharks in Cocytus, sharks/parrots in the Caribbean, pirates/sharks in the open Ocean, seeps everywhere, vikings/water elementals in the Living Fjord, Albatross on the coast, Tower and RRV monsters).
- danger is now affected not only by collected Orbs of Yendor, but also by paths you have walked without collecting the Orb of Yendor -- this is to prevent strategies such as bringing many OoY together, and then unlocking all of them together. (This kicks in after walking more than two paths, and is nullified by taking an Orb of Safety.)

2015.11.10 00:50 version 8.0g
- Scores for Yendor/PTM got missing in the last update, this should be fixed.
- Scores for the PTM removed due to the balance change update when you play in PTM (not only when you raise your score, as in 8.0f).
- Fixed a bug with Yendor hardness (an uninitialized variable sometimes caused an extreme spike of difficulty after touching an Orb of Yendor).

2015.11.10 01:48 version 8.0h
- Magic Mirror now appears as the Mirror Land reward in the World Overview
- after 8.0g PTM scores disappeared in Linux, this is fixed
- higher level victories in the Ocean Yendor Challenge are nullified (if obtained in version < 8.0f)
- Mutant Saplings generated while the land was still easy should now disappear when it becomes tougher (just like bomberbird eggs, but without hatching)
- made the Overgrown Woods a bit easier (it seems it was too hard) -
- by halving the effect of collected Saplings on tree density
- obsolete scores by other players no longer appear in the in-game PTM highscore

2015.11.12 01:41 version 8.0i
- Two new achievements.
- You can now attack Viziers in the extra turn given to you by the Orb of Speed.
- Flail Guards now kill themselves if they try to attack an Illusion.
- Shmup fixes: Metal Beasts are no longer killed by your attacks, Thumpers can no longer be pushed into monsters.
- Individual scores are now displayed in Yendor Challenge (as well as in PTM).
- Your scores in Yendor/PTM are downloaded from Steam, so you can finish some lands/challenges on one computer, and some on another. (In case of PTM, this is just the sum for each land, not the whole history.)
- Added some texts to translations.

2015.11.14 13:17 version 8.0j
- One possible cause of Storms-related crashes fixed.
- In the Ivory Tower challenge, Great Walls are no longer generated inside the Ivory Tower.
- No more missing Great Walls on the barriers separating Elemental planes.
- Whirpool now gets harder with more Orbs of Yendor collected.
- Magic Boat direction fixed.
- Added some texts to translations. Added some translated achievement names.
- The Android version should be also updated soon.

2015.11.21 21:35 version 8.0k
- The problems with the leaderboards should be fixed.
- You no longer count as conductor outside of Land of Storms (this bug nearly caused a gameover in Sprite Guard's video).
- Winter Witches were not placed correctly as guards for the Land of Power -- Evil Golems were created, causing weird messages about burning and sometimes a possibility to enter without any orbs
- Setting a frozen lake in Icy Land on fire turned it to fire, instead of hot water -- this is fixed.
- Using some ranged Orbs now disables your invisibility for one or more turns.

2015.11.23 15:46 version 8.0l
- Fixed the cheats: Shift+C, Ctrl+A.
- Friends no longer keep attacking stunned metal beasts.
- Added "You construct some Elemental Gems!" to translations.
- Activating Map Editor (via menu or Shift+A) resets the ghost timer.
- Reflected lightnings no longer destroy the boat you are on.
- Orb of Aether was not considered "used" while you were standing inside a wall.
- Greater Demons now can be killed with fireballs in the shmup mode.
- In the coop shmup mode, both players can detect mines now.
- Hyperstone Quest information in the ESC screen is not displayed correctly.

2015.12.05 14:45 version 8.0m
- Thanks to TheGons, The German translation has been updated to 8.0!
- For consistency with other Trolls, Dark Trolls now create "rubble" when killed (this should not affect pure Dead Caves, but it has some interactions)
- For some people, Whirlpool Yendor challenge appeared as completed incorrectly -- this should be fixed
- Camelot is now allowed to appear in Crossroads III
- The unlocked status for Orb of Trickery/Love is now displayed correctly in the World Overview
- Demon sharks and Aether/Winter Witches sometimes generated the confused message (or killed the player in Hardcore mode) incorrectly, this is fixed
- Keys no longer appear on unstable floors in the Zebra ("gargoyle floor" is used to stabilize the Key)
- You no longer can kill a Hedgehog Warrior if this allows a Pikeman to kill you
- Wandering monsters should no longer start stunned in some situations (such as after killing Mutant Ivy in the same location)
- In the Wild West, if you try to move in the given direction and cannot because of an Outlaw, you shoot him automatically (useful for keyboard players)
- Chasm cells now count as isolators
- You can no longer continue standing on a Trapdoor/LoEM after your Orb of Aether expires 

2015.12.23 ??:?? version 8.1
- blog post: http://zenorogue.blogspot.com/2015/12/hyperrogue-81-happy-holidays.html
- Clearing
- Haunted Woods
- Also, there have been some improvements to the Shmup mode. Separate scoreboards have been added for coop shmup, pure tactics mode (single and two-player shmup). Since four players are supported now, all player characters can now be customized separately, and some new characters have been added (cat, dog, and Prince/Princess if you have completed the quest -- these new characters work in the normal mode too). You can assign a key for targetting special orb powers (previously you could only target with the mouse, which was inconvenient in multiplayer).
- new shapes for Orbs (so that it is easier to tell them apart)
- four new Yendor challenges
- more shmup bugfixes: all players get boats in the tactical Whirlpool; missiles destroyed with Orb of Flash no longer appear in your kill list; Hedgehog rotation and missiles are now affected by the Orb of Speed in the shmup mode; "pan up/pan down" commands work as expected
- Red/Dark Trolls no longer turn into rocks when killed in an unstable land
- fixed the description of Palace (did not choose prince/princess correctly)
- in the kill list, different messages are displayed when hovering over friends, constructs, and monster parts
- fixed yet another inconsistency in the sealing of Land of Power
- a smaller font is used for the list of items collected; more space for items in portrait mode
- fixed unlocking information in the description for Temple etc.
- Graveyard did become (very slightly) harder when monsters were killed -- this effect is removed
- slime no longer spills against wind
- when entering the Elemental Planes, you can enter planes based on the types of elementals you have killed
- monsters in the Ivory Tower no longer can stay in midair when they can't reach you
- added the Icy Lands as a prerequisite for Cocytus -- thus, each basic land now has an advanced version

2015.12.24 01:07 version 8.1a
- Clearing used an incorrect description
- Wind crow kills counted double, and bomberbird kills did not count at all
- The 't' key did leak to the gameover screen when it caused a gameover
- Orb of Air was incorrectly also unlocked by the Ocean
- Weird numbers were shown for the new Yendor challenges
- graphical effects of the Orbs were displayed on the bugs and friends even without Empathy
- Steam leaderboards for shmup/coop did not work; also reduced shmup chances to 5 in the LoEM
- fixed yet another Space/Safety crash
- Freedom and feathers blowing away should not work in the shmup mode; also Empathy and Undeath are now counted as bonus lives
- Fixed some text errors, added Czech translation
- using Safety in the coop shmup LoEM no longer causes you to die (due to starting on the same cell)

2015.12.24 08:49 version 8.1b
- The list of orbs for Empathy is now comma-separated
- 0 to exit Yendor Challenge was working incorrectly
- more shmup/coop PTM fixes: scores were copied from the normal mode; incorrect values; changed the number of tries for all lands to 3 (possibly to be increased later)
- "three players" and "four players" are now displayed correctly
- fixed Clearing in the PTM

2015.12.25 14:57 version 8.1c
- Fixed the multiplayer leaderboards.
- All Ghosts destroy living cave now (including Tentacle+Ghosts and Friendly Ghosts).
- Updated the Russian translation, added one missing line to translations.

2015.12.28 12:30 version 8.1d
- using the Orb of Safety during the Princess Quest was buggy (as seen in Sprite Guard's video, now the Princess automatically becomes saved in this case (so the quest is completed either by using Orb of Safety or leaving the Palace)
- when a Guard was stunned and falled into a chasm, the Princess sometimes followed
- removed the buggy condition (collect 10 Bounty) for unlocking the Wild West Yendor Challenge
- fixed the removal of Black Lotuses (close to the edge with high Black Lotus count)
- it was possible to get Cocytus adjacent to Icy/Hell even without Diamonds
- Overgrown Woods are now more likely to be adjacent to Jungle
- the edge of the Clearing now uses small trees (this is slightly more interesting because of interaction with fire)
- fixed the 't' key (and the mouse button) in the Game Over screen
- items, monsters, and mines (mines in radius 3) should not appear when using Orb of Safety -- in some cases this was not working correctly
- fixed the Master Survivalist achievement
- fixed some typos and non-translated texts

2015.12.30 18:45 version 8.1e
- double Ivy Roots no longer appear at low counts of Ruby (to make Jungle more friendly to newbies, and also to make the Jungle YC easier)
- added a new achievement ("There and Back Again")
- Orb of Aether draining away was not working correctly (you could still sit in a wall)
- killing a Dark Troll on rubble in the Dead Cave no longer creates a wall (that was changed unintentionally in one of the recent releases; killing a Red Troll on rubble, or a Dark Troll on rubble outside of Dead Cave, still creates a wall though)
- in the portrait mode, treasures are no longer listed over Hyperbug counts, and treasures/kills are resized if they don't fit in the given space
- resize the achievement description if it is too long
- advanced versions of lands are more likely to appear next to basic versions (this effect was already there, but now it is stronger)
- the description of Clearing clearly mentions that it is only accessible from Overgrown Woods
- Rock Snakes and Red Trolls killed in sea in the Living Fjord created too many levels of rock
- when loading a save with negative saved Princess count, this count is removed (hopefully should no longer appear in new versions)

2015.12.31 22:52 version 8.1f
- the "not dipping" rule has been changed in the following way: previously, it was hard to find lots of treasures in land A while being in another land (e.g., Crossroads) where you have less treasures; now, this also happens when you are close to another land (distance <= 3). This was changed because it was far too easy to just wait for the White Dove Feathers in a place where you could easily escape to another land
- removed spam messages when Hyperbugs are fighting offscreen monsters, Metal Beasts/Skeletons or Ivies
- rock snakes are now wind resistant and wind blocking

2016.01.01 13:03 version 8.1g
- fixed random crash bugs
- (The most frequent one seemed to be caused by generating a Palace close to a horocycle from another land, e.g., Land of Storms.)

2016.01.04 23:50 version 8.1h
- Rock snakes were rarely generated incorrectly (two snakes crossed, through rocks, etc.).
- Jungle, R'Lyeh, Cocytus, and Hell no longer generate the player in the middle of ivy/lake.
- disabled the new "no dipping" rule for Hyperstones.
- only escaped Black Lotuses count for the overview highscores (and thus also PTM) now.

2016.01.08 01:10 version 8.1i
- winds caused by Air Elementals now respond immediately to Orb effects (like, say, killing the Air Elemental)
- Friendly Ghosts and Ghosts on Tentacles should now be able to attack and be attacked through vine
- fixed the Camelot/PTM problems reported by tricosahedron
- some more rare crash bugs should be fixed. Also, "buggy items" now appear instead of weird treasures such as Pirate Treasure in the case of bugs in generation
- hypersian rug mode preview

2016.02.16 23:09 version 8.1j
- (j was skipped due to some naming inconsistencies with the Android version)
- fixes the bugs introduced in 8.1i: dropping the Dead Orbs, invisible lightnings, weird lakes appearing in the Caribbean
- Refactored the movement routines. Please report if something could move somewhere but it cannot now, or vice versa (but from my tests, it appears that everything works correctly).
- Enabled the Orb of Empathy + Orb of Water combo.
- Lines are now drawn together with polygons (previously, the game was drawing polygons from the previous frame) -- movement should look slightly nicer now, this also fixes the "lines under polygons in the Hypersian Rug" problem reported by tricosahedron.
- added some config the Hypersian Rug mode -- if the default settings do not work, one can now play with a (slightly worse) variant. Also mouse should be read correctly now.
- added a cheat option to disable timer ghosts.
- yet another preview -- added a mode where you play on a pure heptagonal grid. Not all lands work correctly with this mode yet (heat disperses too fast, CR2 and CR3/Elemental are not generated correctly, hex-only rules). Also, some incomplete features are available in the cheat/mapedit mode.

2016.02.17 11:23 version 8.1l
- Collecting mirrors has been fixed
- Some graphical glitches have been fixed (orb/gun targetting cursor, pattern codes, Yendor/Caribbean numbers, grid, ASCII lines, circles, alpha for lines)
- wandering monsters no longer appear after the game over in the shmup mode

2016.02.17 14:08 version 8.1m
- fixed some more graphical glitches (too large walls/items when starting in Euclidean, sometimes letters became transparent, circle around the map was not shown, crash reported by Patashu)
- "heptagon only" mode is now saved correctly (and its scores do not count)
- the Zebra pattern worked incorrectly in the graphics editor
- added the option to use the {3,7} grid to the map editor

2016.02.19 14:20 version 8.1n
- fixed the knives going through water, fire, against gravity, and against wind.
- fixed the problems with rendering the Hypersian Rug without OpenGL (mirror image, graphical artifacts).
- there may be still some further tuning but all lands should work in the "heptagons only" mode, except the Clearing and RRV. (Well, RRV works without Rock Snakes)

2016.02.19 22:11 version 8.1o
- fixed the crash bug when generating Elemental Planes / Crossroads IV, introduced in 8.1n (worked only in the heptagon only mode)
- RRV sometimes generated Yetis when it failed to generate a rock snake, this is fixed
- shape/pattern from the Map Editor is now reset when a new game is started
- extra line in the ghost description describing the "non-adjacent" behavior
- even Clearing and RRV now work reasonably in the heptagon only mode. Also, the Knights give the correct numbers in the heptagon only mode
- fixed the name of the grid in the map editor to "triheptagonal"

2016.03.08 ??:?? version 8.2
- Warped Coast
- Rose Garden
- Crossroads IV
- heptagonal mode
- chaos mode
- Hypersian Rug mode
- new floor graphics for Euclidean/heptagonal mode
- pure heptagonal mode fixes/balances: compass earlier, weakened closing plates, balanced the Princess Quest, sealands should no longer be generated on beaches
- activating the Palace Quest in the Overview while cheating teleports you to Princess (instead of an empty land)
- fixed the mirrors in shmup mode: shards taken outside of mirror land no longer count, knives breaking mirrors/mirages are mirrored now, mirrors/mirages created by mirrors worked incorrectly
- birds now can fly over the Red Rock Valley
- friendly creatures are now better at stabbing
- in the map editor, hotkeys were replaced by searching for a given word
- you can no longer push thumper on a boat
- Hypersian Rug mode: Home/End keys
- Crossroads in PTM didn't mirrors
- slight color changes, to help the colorblind people 

2016.03.13 18:56 version 8.2a
- after using Orb of Safety in the Hive, no nests appear nearby
- after applying Orb of Space to Orb of Life or Orb of Friendship, you have to move to make space for your buddy
- saved games in shmup mode did not remember the number of players
- the highscores shown in the World Overview are now based on the special mode you are playing (to unlock special features, a highscore in any mode is sufficient)
- new lands from 8.2 did not show correctly as unlocked in the World Overview
- typos fixed
- navigating the Ocean in the heptagonal mode caused crashes, these should be fixed now
- slightly changed the rules of the Living Caves in the Chaos mode (empty cells outside of the land no longer count as 5 floors)
- a new graphic for heptagonal mirrors in the heptagonal mode
- highlighting (Alt/high contrast) now highlights mirrors
- fixed some graphics which were drawn incorrectly in the heptagonal mode
- the bug with teleporting Ratlings and confused birds should be fixed
- the generator is more careful not to generate things outside of their lands (ivies, rock formations, red gems)
- the weird movement of boats with Orb of the Warp is fixed
- the message "You cannot move between the triangular cells here" is replaced in the heptagonal mode
- when under influence of a rosebush, ranged orbs can be targeted only towards the rosebush
- balancing the Warped Coast: collecting Corals did not increase the number of Ratlings on the seas; Ratlings now avoid Corals so that they won't bring treasure to you; Ratling Avengers now sometimes appear if you kill Ratlings close to the open sea

2016.03.15 11:27 version 8.2b
- nest radius is reduced in the Chaos mode, to make the Hive more dangerous and not cover the whole FOV
- the effect of Demon Daisies on the generation on demons in the Chaos mode is now 4x normal (normally, demon generation is intentionally low to help you with doing the Yendor Quest in Hell -- this is irrelevant in the Chaos mode, and moreover, there should be no safe lands in the Chaos mode)
- previously treasures in land B on the edge of your sight range were despawned if you were in land A, and you had more than 20 treasures in land B than in A -- this number is changed to 10 in the Chaos Mode, to encourage collecting treasures more evenly
- additionally, treasures are despawned and no new White Dove Feathers appear if the ghost timer is high, to prevent some exploits (not only in Chaos mode)
- the basic radius of mine uncovering is increased in the shmup mode
- a bug caused the game to stop generating Great Walls sometimes
- monsters should no longer decide to kill their friends if they are forced to move by dangerous terrain
- offscreen monster movement (usually Hyperbug) sometimes caused a crash
- no monsters were generated in the Chaotic Temple of Cthulhu

2016.03.16 03:18 version 8.2c
- sometimes a row of Temple tiles was generated next to a Great Wall
- in Chaos mode, only 25% boundaries of Warped Sea/Warped Coast/Elemental Planes lead to another subland now; also, R'Lyeh's non-Ocean boundaries are unlocked after collecting just one Statue
- Ice Wolves should no longer move if all their possible moves decrease heat
- monsters no longer try to get into the space on the other side of a half-vine from the PC
- Mutant Ivies under influence of Orb of Discord no longer attack themselves (or other Mutant Ivies)
- some more bugs exposed by the Chaos mode fixed (caused by Hyperbugs moving offscreen, or genrating multi-tile monsters crashing into each other)

2016.03.16 16:18 version 8.2d
- rose scent now respects the rules of the Alchemist Lab
- theme messages regarding Camelot no longer appear in the Chaos mode
- improved the generation of wandering pirate/restricted monsters
- changed the color of Cocytus in non-Escher chaos mode to make it easier to tell from the Icy Land
- changed the color of Emerald Mine in the Land Overview to emerald

2016.03.18 17:20 version 8.2e
- Orbs of Aether and Shielding now make you ignore the scent.
- Air currents (caused by both Windy Plains and Air Elementals) now always prevent the spread of scent.
- Fixed Sharks (and some other creatures) being stuck diagonally adjacent to the player in a warped zone. Also "confused" messages should no longer appear for some monsters there.
- In the shoot'em up mode, the default radius of mine uncovering is now 1. Also, Orb of Teleport takes care not to send two players too close or too far from each other, and the issue with birds being confused by PCs on boats should be fixed.
- Holes ('???') in the Ocean should be fixed now.
- In the special mode menu, it is clearly shown that shmup mode includes co-op.
- The PC now dies in the situation from snowyowl0's screenshot (too complicated to create a warning that spreading slime in the Land of Storms carelessly leads to being electrocuted immediately)
- Some extra diagnostic options have been added.

2016.03.18 21:18 version 8.2f
- Aether/Shielding should protect from rosebushes correctly now.
- Boats should no longer overwrite warp gates in the Warped Sea.
- Killing Miners now helps with high rock formations.
- Cocytus/Icy Land is now affected by fires on adjacent cells.

2016.03.19 21:21 version 8.2g
- Did I miss the patch that made Orb Of Aether stop allowing you to ignore rock heights? 
- I've got Ivory Towers displaying odd behavior because they're spawning Crossroads IVs inside of them, and they don't know how to handle them. 
- (also Crossroads IV should no longer appear in the Haunted Woods).

2016.04.03 12:57 version 8.2i
- fixed the "Rogue kills Vizier" message
- shift+K in the debug mode no longer kills you
- when Orbs of Water were generated as prize orbs, only boat was generated without Orb
- also, fixed the stranded boat graphics in the Hive
- centering for coop games with 3 or 4 players should work better now
- add the Warped Coast to the random pattern mode
- experimental preview: Fractal landscape generation
- preview: conformal mode

2016.04.05 02:28 version 8.2j
- air elementals' whirlwind disappear immediately on kill
- images created by the new mode (as well as the map editor and the paper model creator) are now created in the PNG format instead of BMP (under Windows/Linux) [EDIT: does not work on Windows yet -- going back to BMP for now]
- drawing with SDL_gfx instead of OpenGL (which is used when rendering PNGs) is now supported under Linux
- half-plane and band models now work with OpenGL (and thus they have better fps)
- inspired by simon_clarkstone's comment above, the path taken by the character is now displayed on the map when history display is active, and there is an option to automatically render a band .png when the player picks up an Orb of Safety or ends the run. Also, progress messages are now shown while working
- if band/half-plane model is chosen and we are on the beach/Ivory Tower or in a horocycle, the display is rotated based on the special direction and the rotation chosen in the bandmode menu. (In case if the special direction is not obvious in the normal game, this works only in the cheat mode.) This looks nicely in the half-plane model, where horocycles centered at the "ideal point above in the infinity" are represented as vertical straight lines.

2016.04.24 02:20 version 8.2k
- I seem to be getting a strange behavior accessing Ivory Tower. Gravity does not rotate the view, and some X's appear on cells around the player. Is this intended? Running 8.2j on Windows 10. 
- For the Android version, the fullscreen mode is now optional, and fixed the bug with the display of ASCII characters. 

2016.05.04 21:07 version 8.2l
- saving to PNG now works in Windows
- killing red trolls in the Ivory Tower now generates "dead trolls", while killing rock snakes generates platforms
- press 'i' while in the basic config to quickly increase the "distance from hyperboloid" parameter and decrease zoom at the same time (as the parameters approach infinity, we get the Gans model); also the game reacts quicker to parameter changes
- 'polygonal' and 'polynomial' models added to the conformal/history mode: polygonal renders the map in a shape of a regular polygon or a star (they work best with the "high quality screenshot" option from the map editor)

2016.05.20 19:06 version 8.3
- blog post: https://steamcommunity.com/linkfilter/?url=http://zenorogue.blogspot.com/2016/05/hyperrogue-83.html
- Yendorian Forest
- Dragons
- Galapagos
- history/conformal mode released officially
- Killing Rock Snakes in the Whirlpool no longer creates terrain
- Fixed Servants in the shmup mode; also Lightning and Flash should now auto-activate
- It is now allowed to enable cheat mode in PTM (but only if no treasures yet)
- A command line option to automatically turn cheat on
- A new floor pattern for the Rose Garden
- Extra texts for the Knights of Camelot
- Minor improvements in the Vector Graphics Editor: vertices of the current layer are now marked, Shift+L to go back to the previous layer, '+' to increase the number of rotational symmetry, it is now possible to set rotations and symmetries before pressing 'n'
- Since Sandworms and (non-withdrawing) Tentacles attack by moving into the target's location and eating them, they won't be able to do this if they cannot move there. Rock Snakes and withdrawing Tentacles attack all adjacent cells, without movement -- Tentacles did not work correctly in the hardcore mode, this is fixed.
- Princess Challenge now unlocks immediately when it should (not after restarting) 

2016.05.20 19:06 version 8.3a
- adds the Czech translation, fixes some texts, and makes the Dragon Chasms Yendor Challenge a bit harder.

2016.05.21 00:26 version 8.3b
- kill/killtype count should be fixed.
- Land of Storms should be fixed.
- Sorted the Land Overview a bit.
- wandering Sparrowhawks have been added. [Removed the top scores from the Leaderboards: tricosahedron's 125, Vipul's 50 something and Deathroll's 46]
- Dragon Scales now disappear after 500 turns.
- Stunned Tortoises now display only the shell.

2016.05.21 23:18 version 8.3c
- Land of Storms should be fixed (hopefully for real this time).
- fixed the description of the Vineyard.
- the cheat counter is now raised when you click on things in the World Overview in the cheat mode.

2016.05.23 01:19 version 8.3d
- updated the Russian translation
- added a message
- enabling the cheat mode should disable reloading the save
- while looking for the ghost bug, I have found that the ghost timer is reset if you scroll (without moving) -- this is fixed. Not sure if this has anything to do with the reported bug, but you can now enable the cheat mode and press Ctrl+G to verify the number of turns.
- the Hypersian Rug mode is now sensitive to the "eye distance" parameter
- cheat count is now increased if you use some of the "cheat only" things from the conformal menu
- Also, I have configured the Steam cloud, so your local scores and saves should be automatically transferred between computers.

2016.05.23 22:27 version 8.3e
- fixed some problems with the graphics editor (Shift+L working incorrectly, crash bug on using L too many times, vertices were drawn incorrectly)
- Crossroads IV should no longer spawn in Galapagos
- fixed some minor texts missing from translations

2016.05.27 12:42 version 8.3f
- fixed the Yendorian Forest generated empty when bordering Crossroads IV
- Crossroads IV should no longer intersect Haunted Woods
- it is now a bit easier to exit the Graveyard (previously Haunted Woods made Great Walls less likely to spawn)
- Friendly Ghosts of stunned monsters no longer start stunned
- Stabbing attacks, and attacks against Viziers, now can produce Friendly Ghosts (but not Flail Guards, since they kill themselves)
- Dry Forest and Dragon Chasms no longer can be adjacent
- Orb of the Mind can now be used to damage a Dragon
- fixed the interaction of Time and Domination and Energy
- female PCs are now called heroines, not heroes
- fixed the Nasty Pet achievement
- friends are no longer said to "kill" the Dragon if then only damage it
- you can no longer push Thumpers and Big Statues even if you would be attacked by a Tentacle/Sandworm
- antialiasing glitches reported by Patashu should be fixed
- the source code missed some auxiliary files and the Makefiles were outdated

2016.05.27 20:29 version 8.3g
- fixed a crash bug with "tortoise heroine"
- fixed two minor bugs in the Polish translation
- dragon floor files are now displayed above other floors
- killing an Albatross now reduces your charges of Orb of Luck slightly
- map editor a bit more resilient when placing dragons (but still can crash)

2016.06.02 01:10 version 8.3h
- monsters with non-standard movement abilities tried to path through other monsters (e.g. Leaders tried to go through Tentacles) -- this is fixed, they only path through the PC and allies, except non-Dragon mounted worms. Also, they now try a bit harder to find the path
- scent-resistant creatures were still unable to attack against rose (bug affected both Rose Ladies and the player with Orb of Beauty)
- Mutant Ivy no longer moves on you if you have Orb of Shielding
- leaving the Yendor Challenge no longer leaves you in the cheat mode
- fixed orbs' appearance as prize orbs in some lands: Orb of Domination is considered useless in most lands, Orb of Luck is useless in Endorian and Galapagos, Orbs of Fire and Dragon are dangerous in Yendorian Forest, most offensive orbs are forbidden in Galapagos but Orb of Fish is actually useful
- fixed some subtleties which caused HyperRogue not to compile under C++11 ('C++11 requires a space between literal and string macro' and 'cannot bind bitfield')
- fixed the tortoise hero crash in Polish
- immediate reaction to baby tortoise

2016.06.08 01:34 version 8.3i
- Cheats ('c') appears in the menu if you are in the cheat mode. This menu allows you to do cheating with mouse only
- some Yendor challenges set your treasure high scores while they should not (I think they would reset on game restart, but not on Android)
- fixed a problem which caused incorrect grounding of the Ivory Tower under some compilers
- rosebush scent no longer breaks your multiplayer shmup game by crashing the players into each other (without possibility of splitting)
- tides are now shown correctly in high quality shots (previously the state when the cell was last seen was shown), updated the image on site
- the main menu (and most of the things from there) are ported to the Android version (and the upcoming iOS version), replacing most of the items in the current Android menu
- some source files missed license headers

2016.06.23 00:09 version 8.3j
- Fixed bugs with breaking weak branches (they were not broken in the shmup mode, but they were broken by flying/aethereal creatures).
- Orb of Aether now allows you to fly in the Ivory Tower/Yendorian Forest. Also it works correctly with Empathy.
- When you reload the game after using the Orb of Safety, you will be brought back to exactly the same place now.
- Added some missing lines to Czech/Russian.
- The description of a Dragon now mentions that you have to kill it in the Dragon Chasms to get treasure.
- Fixed a typo in the description of Elixir of Life.
- Fixed an unitialized variable which caused a crash when running langen on some systems. Also renamed the function/field "hash" because this name causes problems on newer compilers.
- Improved the German translation (work in progress).
- Also, the iOS version of HyperRogue (8.3i) is released on the AppStore! ( AppStore link: https://itunes.apple.com/us/app/hyperrogue/id1122485103 blog post: http://zenorogue.blogspot.com/2016/06/hyperrogue-is-now-available-in-ios-app.html ) 

2016.08.03 ??:?? version 9.0
- Kraken Depths
- Burial Grounds
- Trollheim
- turn-based multiplayer
- [UI] In previous versions, keyboard movement was somewhat risky -- sometimes it was hard to tell which key moves where. As shown on the screenshot above, HyperRogue can now display arrows -- these correspond to movement keys.
- Cleaning the kill list: first monsters, then parts, then friends. As for monster parts, the number of Dragon/Kraken parts destroyed is now counted, and Mutant Ivy kill count now counts only ones killed directly (for consistency with normal Ivies -- the counts were not right in the Clearing anyway, where the actual counts would reach billions easily)
- some mechanics were not appropriately explained in their descriptions: auto-triggering Orbs (Flash/Lightning), targettable Orbs (it was not made clear that they cannot be targetted at too close or too far ranges), auto-explore radius for the Minefield
- More information about lands. For land with unlock requirements, the progress of unlocking is shown. Also it is clear which lands are not available in special modes, and which quests are optional for Hyperstone Quest.
- The option to show heptagons did not work in some lands, and was confusing in some other lands -- now, it marks heptagons with dots (as it previously worked in the Red Rock Valley)
- version number now always shown in the bottom left corner (useful when you watch recordings of HyperRogue)
- A slight change to the Minefield: you can now mark mines by hovering over a cell and pressing 'm'. This also happens automatically if you know all mines adjacent to some cell. Marking mines prevents your allies from going there, and gives you a warning when you try to step on a marked cell. Cells where a monster moved, or cells with items, are marked safe (and mines set on items explode immediately now, so you can always be sure that cells with items are safe).
- Warnings. The checkmate rule works well to protect you from most stupid mistakes, but there are some mistakes where it does not help because the actual death would happen on the next turn -- like stepping on a known mine, or moving under attack of a Kraken, in a boat (this does not kill you immediately, it just destroys your boat). Such moves could be fatal or not, and it is hard to check what is the case -- for example, if you step on a mine while escaping from an adjacent Water Elemental, the Water Elemental will catch up and extinguish the fires immediately -- so only a very basic check is made, and you can ignore the warning by repeating the action. 
- [bugfixes] Crystal Sages, Dragons, and Fire Cultists can attack all targets now (not only the player)
- fish could not go through sunken items
- fixed the bug with Orb of the Fish not letting one to stay in place in Cocytus
- Orb of Time did not work with Orbs of Aether and Thorns
- Shadows now actually attack (previously they only affected the checkmate rule)
- no more burning/sinking/falling messages for the Shadow
- The log file now mentions if the game was played in pure hardcore mode
- mouse can now step on mines (without triggering them)
- the Orb of Lightning did not reflect off walls correctly
- improved pathfinding for monsters -- it seems they no longer act strangely in tight corridors
- Crossroads IV no longer appear in incomplete Rlyeh
- allies were not killed by Rosebushes
- Bomberbirds did not explode when killed by Rosebushes
- in the Shmup mode, monsters are now less likely to get stuck
- Ghosts no longer fall off cliffs and die
- Yendorian trees are now burned by lightning (also Orb of Storms is now marked as dangerous there)
- Rich Metal Beasts killed by Orb of Storms now also produces Fulgurite in shmup
- movement to Orb of the Shell is now possible even if under attack
- some monsters with non-standard movement abilities moved unpredictably (i.e., based on the internal representation) -- now they move randomly
- fixed a bug with Ocean generation in the pure heptagonal mode
- Water Elementals now destroy manned boats in the shmup mode
- Sharks (except Demon Sharks) now suffocate when stranded on land
- monsters at unstable locations in the Ivory Tower can now falling into dangerous terrain, or into other monsters attacking them
- adjusted temperature and livecave value of some monsters
- Friendly Ghosts no longer ride boats; they are generated from Dragon and Pikeman kills 
- [fixes] a new icon!
- added a leaderboard for the heptagonal mode
- replaced Servant (from the Ivory Tower) with Familiar, and added Familiar as the seventh choice for the player character (no gameplay changes), also changed the music in the Ivory Tower
- new graphics for Eggs, sadly they are not triangular anymore
- pressing Shift now cycles in the reverse direction in more contexts (shift+N to reduce the number of players, shift+M to go back in conformal models)
- display colors in char config; also the movement star color can be configured now
- bugcounts and minecounts are no longer displayed when you are in a menu
- the menu for selecting the score to display works better now: some Orbs which were there are removed; pressing keys no longer does weird things, but rather allows you to search for a specific entry (just like in the Map Editor)
- two new models added to the conformal menu (the models are not conformal, but they fit there)
- translation fixes: conformal models' names, Dragon description, Polish translation
- not crash on very long pathnames
- improved wall display in Hive/Dragon
- draw multiple Flash effects
- quit from menu sends achievements
- graphical effect for the Orb of Beauty
- Unlocking rules were not shown for Crossroads II
- 'chop down' used for trees 

2016.08.04 11:35 version 9.0a
- updated the names for the config options ("mark heptagons", "help for keyboard users" -- to disable the arrow markers permanently switch "help for keyboard users" to OFF)
- fixed the incorrent requirement shown for treasure-based unlocks ("required 10 spice (0/3)")
- added the missing requirements for Kraken Depths and Burial Grounds (as Fulgur14 said, these lands unlock together with their crucial Orb)
- the buggy mine symbol displayed was hopefully fixed
- fixed typo "targetted"
- leaderboards seem to be fixed

2016.08.05 03:15 version 9.0b
- hopefully fixed the problem with "???" land
- removed a potential cause of the slowdown
- fixed the Necromancer not moving (no idea about the Cultist)
- treasure leaderboards worked in heptagonal/multiplayer modes while they should not
- fixed a rare crash (Lancer moving on the edge of generated area)
- fixed the mouse control in azimuthal models
- mouse control in multiplayer
- does the update help with the music problems? (I have updated the SDL_mixer libraries in the Windows package, and increased the chunksize parameter)

2016.08.06 12:20 version 9.0c
- updated the PL/CZ/RU translations
- Orb of Empathy now mentions that it works with Orb of the Stone
- Cultists no longer do nothing when at distance < 4
- fixed attacking Ghosts over Trees
- fixed Sharks moving against current
- fixed the requirements displayed in the description of R'Lyeh and Burial Grounds
- fixed monster fight messages ("X attacks Y")
- fixed the game not registering game over after using up orbs
- fixed the Hyperstone quest log
- fixed enabling/disabling the shmup mode
- unlock messages for Trollheim / Orb of the Sword / Elemental Plains (actually added in the previous update)
- fixed treasure count displayed on collection of mirror shards, elemental shards, elemental gems, and ancient jewelry
- fixed misleading messages when attacking Dragons or Krakens
- energy sword now destroys vines, for consistency
- energy sword now can destroy the Shadow for one turn
- Air Elemental didn't blow when it did not move
- player did not break weak branches
- fixed the unnecessary messages "You cannot target that close!" etc. displayed when having orbs
- troll nests in Trollheim should no longer appear too close to Great Walls
- greatly reduced the frequency of prize orbs in the Burial Grounds (e.g. Flash appeared way too often)
- previously trying to turn off the hardcore mode after game over did nothing -- now it starts a new non-hardcore game
- the hardcore turn-based multiplayer mode should work now
- fixed some achievement names and descriptions, updated the PL/CZ/RU translations

2016.08.06 17:16 version 9.0d
- mirror shards were collected twice
- prize mirrors did not appear in the Crossroads and some other lands
- mine marking is now documented
- added achievement "heptagonal knight"
- more minor updates to translations
- Baby Tortoises are no longer left behind when playing in Chaos mode

2016.08.06 21:49 version 9.0e
- the bugs reported by tricosahedron should be fixed (slowdown was because of Knights making sure that they don't get electrocuted, also another useless expensive call was removed, and crash was caused by Pikemen moving on the edge of the visible area).
- Also Orb of Winter is now correctly categorized in Dragon Chasms.

2016.08.26 11:49 version 9.0f
- Fixed the bug with Rock Snakes disabling the generation of complex structures
- Empathy+Aether no longer lets Knights or your friends to go through the Round Table (previously Empathy was enough to let Knights in)
- Each Elemental Plane is now likely to appear next to the other land when the given Elemental appears. Also Trollheim is now likely to appear next to other Troll lands
- Coastal and aquatic lands have a line explaining their connection rules in the description
- Orbs of Fish are no longer marked as useless in Kraken Depths
- Mines are now highlighted automatically only for the cell you are on
- Fixed some missing fight messages (when stabbing, approaching, or when special movement monsters attacked your friends)
- Tame Bomberbirds no longer die immediately when hatched on a boat
- Moved the Ivory Tower and the Zebra in the Overview
- No more "You collect the Grimoire (N+1)" messages if you don't actually collect it
- Ancient Jewelry now gets stolen if you dig it out, and go away without collecting it
- Ancient Jewelry is now protected from the Orb of Space (not sure about balance but surely it was buggy; also it is now destroyed by Water Elementals for technical reasons)
- Trollheim sometimes generated nests on Great Walls incorrectly
- Golden Eggs from Trollheim get stolen 750 turns after the Trolls leave, to prevent strategies where you defeat many nests then collect the eggs easily
- fixed orb ordering for Orb of the Stone
- Orb of Luck should no longer appear in Crossroads variants in the Pure Tactics Mode
- Slime Beasts did not target your allies if they were on a different color but adjacent to their color (and similar for other monsters with special movement rules)
- just for fun: Orb of Nature, which turns you into an Ivy -- cheat mode only for now (press Ctrl+X in the cheat mode to get it), no special ideas for the land for it yet

2016.09.01 13:25 version 9.0g
- a leaderboard has been added for multiplayer turn-based score.
- Fixed the problem of ghosts not appearing (the flag was not set correctly after loading a saved game)
- It was possible to move a big statue even though it would cause you to be eaten by a Tentacle
- Aether did not let you pass through walls
- Fixed problems with times recorded in the local highscore file: one problem was that the time was doubled on game over (more precisely, if you started/loaded the game at time x, had game over at time y, and quit at time z, the result was (y-x)+(z-x) instead of (y-x)), and the other problem was that time was reset when looking at the local highscore file. (I have not tried to fix the old times)
- the screen no longer moves while you are in the overview (previously it moved and did not stop)
- the message when the dragon breathes at a location with no monster is no longer "The dragon breathes fire at no monster".
- Input config now appears in the advanced config menu, and shmup/multiplayer in the special modes menu (both lead to the same menu which works as previously, but I think it is more intuitive that way)
- Fixed problems with joystick control (turn-based configured joystick movement was buggy; moved the old style joystick configuration to the input config menu; also added dead zones as requested by Arcanacra)
- Added an option to display a circle over the current cell targeted by the mouse (this feature was already there in mobile -- now you can choose whether you want it); also added the sight range and reverse control options from the mobile version
- Also, it is now shown where will the pushed thumper/monster go (with extra arrows or circle)
- Improved the Help screen. Now, it explains that you should aim for 10 or 25 treasures, and that you can use 'o' for the Overview. Pressing F1 now always shows the general help (context help is only shown if you press F1 after scrolling). Welcome messages are given in all modes, and they point to F1 in the standard mode.
- Multiple messages with the same body are now collapsed.

2016.09.01 15:44 version 9.0h
- The mirror images are trying to turn to face the mouse cursor and it seems to cause them to spin uncontrollably quite often. It's just a graphical bug as far as I can see with no effect on gameplay, but it's quite unpleasant. 

2016.09.18 21:56 version 9.0i
- Version 9.0i brings a major overhaul of all menus. The new menus should look better, and adjust to the screen size better (especially mobile). The color dialog has been improved, and it is now used when you edit the colors of your character. Most numerical options are replaced with subdialogs when you can enter the numbers directly, or adjust them with arrows or sliders; and some help is provided for some of the less clear numbers.
- 'switch places' message is no longer shown if the monster is destroyed
- the message '... is destroyed' is now shown if the switched monster is destroyed for some weird reason (like, if its place switching is impossible because of gravity, as probably happened for wonderfullizardofoz)
- Orb of the Warp now destroys half-vines
- dead Forest Trolls in the Overgrown Woods get back their old color, as they were hard to distinguish from trees
- sandworm attacks did nothing to the player in the hardcore mode
- checkmate rule did partially take your waning shield into account, even if it was about to run out
- Orb of Beauty now kills bird sover dangerous terrain
- monsters stunned while in an unstable location in the gravity lands are now killed immediately (weird in some cases, but I don't see a good rule here)
- fixed Orb of the Frog causing unwanted jumps in the turn-based multiplayer/configured input
- the hypersian rug mode is now affected by the "sight range" parameter (previously cells outside of the "sight range" were drawn black, now they are not drawn at all)
- Scores obtained in other modes are no longer counted in indices in the local scoreboard. Also scores are now sorted correctly.

2016.09.19 13:37 version 9.0j
- prince(ss) challenge description is no longer unstable while in multiplayer
- in the special modes menu, the multiplayer item is listed as "on" iff either in multiplayer or in shmup (previously only shmup was considered)
- menu items are now selected on mouse-up, not mouse-down; also sliders no longer can trigger immediately
- menus can be navigated with arrows now

2016.09.22 16:50 version 9.0k
- Right click no longer causes movement.
- Your last click no longer activates option on the game over screen. Also clicking during the game over screen is no longer understood as trying to move.
- Fixed the structure display (cheat Ctrl+W) in the heptagonal mode.
- preview: a "spherical mode" is added

2016.09.25 21:19 version 9.0l
- The "(v) menu" button did not work. Also buttons on the ESC-screen now respond to clicks.
- Fixed warnings issued incorrectly when using the mouse, or ones associated with Krakens.
- Renamed the "dist from hyperboloid ctr" parameter to "projection", also provided the proper names in the spherical mode.
- Improvements to the spherical mode: Ghosts no longer spawn, but treasures and orbs do. Improved the generation algorithm for several lands (Warped Coast, Palace, Elemental Planes, Crossroads, Crossroads IV, Land of Storms). When looking from the outside (projection>1), arrows look correctly now, and tiles that you do not see should disappear more correctly. Fixed the ivy/worm graphics. In general, it makes more sense as a game now.
- it was impossible to return to the PTM game after viewing the PTM table (using the mouse) -- fixed

2016.09.26 10:28 version 9.0m
- fix some problems with the generation of Ocean.
- elliptic geometry is added

2016.09.30 18:09 version 9.0n
- The issues reported by _monad should be fixed in 9.0n (regarding elliptic)
- Polish and Czech translations are updated (new help/welcome messages, new geometries)
- Orb of the Sword now works correctly in elliptic
- both charges are now generated in the elliptic Land of Storms

2016.10.01 01:31 version 9.0o
- updates the Russian translation. Also the welcome message is now translated if you are using the default Steam language
- Spherical/elliptic scores should no longer be submitted to the leaderboards
- Pressing Space (centering) in the elliptic mode works correctly now

2016.10.06 20:17 version 9.0p
- The kraken bug should be hopefully fixed.
- The bug with dragon-riding cats/dogs/familiars should be fixed.
- Activating the Hypersian Rug option while in spherical now takes you to the "projection" parameter setting.
- Some bugs with mobile versions should be fixed (once released)

2016.10.13 11:48 version 9.0c
- fixed the dog stripes
- fixed dropping dead orbs by clicking
- fixed some missing translations (in Polish for now)
- map/graphics editor can now output in the SVG (vector-based) format

2016.10.28 22:36 version 9.1
- Halloween mini-game
- Major overhaul of the user interface. Most of this has been actually done in patch 9.0i. The new menus should look better, and adjust to the screen size better (especially mobile). The color dialog has been improved, and it is now used when you edit the colors of your character. Most numerical options are replaced with subdialogs when you can enter the numbers directly, or adjust them with arrows or sliders; and some help is provided for some of the less clear numbers. In 9.1, additionally pressing F5 or F10 while in good game won't stop immediately (ESC screen will be shown first).
- Improvements to the Prince(ss) quest. Some bugs were fixed (jealousy did not work, monsters tended to just stay in place after hitting the Princess -- now they ignore her while she is stunned, and also the stun time is extended). If you have saved the Princess successfully, but she dies later, you can revive her with Orb of Love after you collect 20 $$$ more.
- Orb power is now drained after the monsters move, not immediately after the movement (so Shielding at 1 charge will still defend you for the next turn, and Aether at 1 charge will let you move once more) -- this should be much more intuitive, especially with Orb of Time. Also fixed some bugs with Orb of Time (Thorns or Aether were considered to be used even though they were not). Also fixed Ghosts and Rock Snakes, who did not work correctly with Orb of the Shell/hardcore mode.
- Knights of Camelot now quote Euclid, Lobachevsky, Gauss, and Escher.
- As a reference to Deadly Rooms of Death, Goblins are now afraid of energy swords, and won't step on cells adjacent to them.
- You can now change the projection quickly by pressing number keys. This is useful on the sphere, and also if you want to see the different models of hyperbolic plane quickly. 1 (orthographic or Gans model), 2, 3 (stereographic or PoincarÃ©), 4 (gnomonic or Klein). 

2016.10.29 16:18 version 9.1a
- Just two shots are given for Orb of the Dragon in the Halloween. (Please tell me if you have been abusing this and your score should be deleted)
- Halloween mini-game should appear in the main menu only close to Halloween (otherwise press Ctrl+Y in the main menu, or special modes -> euclidean/elliptic -> spherical -> Halloween).
- Updated Russian and Czech translations to 9.1, German translation to 8.3, and some fixes in the Polish translation (thanks to green orange, Fulgur14, Michael Heerdegen, and Tehora).
- Searching for things by name in the map editor now works according to the translation.
- Aether now makes you non-conductive as it should.

2016.10.30 18:47 version 9.1b
- fixed Orb of the Speed (something got messed up in the orb order changes in 9.1)
- mine will be automatically marked if you detect it from outside the minefield
- checkmate rule did not expect Flash Witches to attack if the only monster in their range was killed
- Flash Witches did not actually attack the player (in Hardcore/Orb of the Shell cases)

2016.11.06 15:19 version 9.1c
- fixed the message "Vizier kills the Rogue" when the Rogue kills the Vizier
- The message "a magical weapon is waiting for you" now appears after collecting 10 sunken treasure
- fixed the problem with Orbs of Air and Mind used against the Kraken. (blowing off tentacles, blasting the head, message when blasting a tentacle)
- fixed the issues with wandering monster generation in the Ivory Tower (Apples could bring extra monsters, Familiars were not generated).
- fixed the auto-reveal in the Minefield at 20+ eggs
- the Orb of Dragon was considered "useless" in lands without worm-like creatures -- this was supposed to be the Orb of Domination
- fixed the message when using Orb of Space while standing on a Compass
- High contrast/Alt mode now highlights only active Ivy branches
- Zombies in Halloween are now darker.
- Fixed the PC facing after using Orb of the Frog or the strong wind.

2016.11.20 20:44 version 9.1d
- preview: 3D display
- grid improvements
- key '4' fixed, also '5', '6', and '7' can be used to switch other display options
- fixed the calculation of distances in spherical mode
- Improved the ASCII display for Krakens and Dragons (previously the wound status was not shown), Tortoises, and stunned monsters.
- setting fullscreen always works as if keypressed now
- score is now displayed correctly in Halloween
- goblins will no longer move senselessly when they can't reach you
- "Native to Camelot" instead of "Native in the Camelot"
- fixed Palace description
- fixed Orb of Time + Orb of the Sword II
- Prize orbs now appear in the Red Rock Valley. Also Orbs of Space are more frequent there now.
- Orb of the Aether now allows you to move against the wind (as expected).


2016.11.22 11:44 version 9.1e
- fixed the rosewave colors broken in the last update, Onyxes no longer change colors
- ASCII mode fixes: using distinct ASCII symbols for weak/solid/trunk in the Yendorian forest; quicker start-up and better letter sizes
- Chaos mode fixes: Orb of the Dragon appeared too fast, Troll nests appeared with way too low probability
- 3D mode fixes: red outlines are no longer displayed on chasms; changed the vertical alignment of in-wall items and monsters, Ancient Jewelry is now somewhat transparent

2016.11.27 00:06 version 9.1f
- simple 3D effects to the monsters. This feature is activated from the "basic config", "monster display mode".
- Also, humanoids have LEGS now! They are visible in the 3D monster mode, or the shmup mode, where the legs of humanoids and dog-like creatures are animated.
- Wall and monster shadows added
- If you press F10 and it would cause the game to be saved, no more asking for confirmation. Also, in the ESC menu, "save" is shown instead of "quit" in this case
- Removed minus signs displayed in the Yendorian Forest
- Mimics were not displayed correctly for the Familiar PC
- Fixed incorrectly colored floors under bonfires etc. in the Icy Lands, and under Thumpers
- Onyx fixed to look as before
- Fixed sulphur spikes on the Chaos/CR4 borders
- Shmup mode fixes: birds no longer collapse trapdoors; Vampire Bats now work; fixed crashes associated with displaying Familiars, offscreen Mirrors, and targetting Orbs in some cases; Orb of the Sword blocked your knives, and spinned uncontrollably when blown away by an Air Elemental
- Fixed the incorrect message "%The1 is destroyed!" when destroying halfvines with Orb of the Warp

2016.12.01 17:43 version 9.2
- blog post: https://steamcommunity.com/linkfilter/?url=http://zenorogue.blogspot.com/2016/12/hyperrogue-92-3d-hyperbolic-animations.html
- Escher 3D mode
- sound effects
- animated movement
- particle effects
- fixed golem heads
- Trolls now have bigger feet
- Steps are bigger now
- Legs are no longer animated when riding boats or worms
- Centering animation is smoother
- Fixed the shadow of Sparrowhawk
- When using Orb of the Fish, there are no legs, and the fishtail is animated
- 3D effects for the water, improved chasms
- Characters in the gravity lands are now displayed skewed due to gravity
- Friendly ghosts are now colored brightly
- Improved the 3D levels for worms and wormriders
- The 3D graphics now works with half-plane and band models
- Fixed mounting tentacles: when escaping, don't go to the root immediately, and monsters are attacked on the way; a Ghost can no longer move to player's position and vice versa
- Ghost timer disable cheat (ctrl+G) now also disables the Orb power caps
- Minor translation fixes
- Mousewheel now allows to quickly scroll multiple-choice option items, and to give orb powers in the cheater's overview
- Fixed minor problems with moving things (on boats, or using Orb of Space)
- Shmup mode: items moved in boats are visible, don't see items in water if you are fish in boat
- Boats in the Whirlpool no longer face weird directions
- shift+5 cycles wallmodes backward
- Fixed the stalemate calculation for Outlaws

2016.12.03 14:23 version 9.2a
- gameplay: mimics are now able to kill Rose Beauties
- control: numpad keys no longer switch graphical modes; fixed the 's' key setting the scrolling speed instead of saving config
- movement animation for switching place with golem, Windy Plains items, and magical boats
- particle effects when walls melt, and fire-related particle effects
- sand dunes and trees are now pyramidal in Escher/3D
- items under half-vines are moved to be roughly centered in the grassy part
- leg movement while riding boats was not disabled in non-3D modes
- animations for falling floors, and falling and sinking monsters

2016.12.04 02:29 version 9.2b
- Fixed the shape of trees in the Warped Coast
- Animated movement for Orb of the Frog and strong wind
- Striped Dogs, Palace Guards, and Draugar still had particles while falling -- disabled.
- Shmup mode fixes: Orb of Beauty works now, and shakes when entering a boat fixes
- Removed incorrect particle effects from thumpers and bonfires
- All unstable floor graphics are very thin now, and falling animations made (mostly) accurate. Different z-level is used for the bottoms of water bodies, and for chasms. For chasms, it actually corresponds accurately to infinite depth :)

2016.12.06 23:36 version 9.2c
- In the Advanced config, there is now a submenu where you can configure the 3D parameters. Also added an option to remove faraway details in this menu, and things over other things should be placed mostly correctly.
- Improved the performance of graphics rendering (also, it seems the Windows version has been recently compiling without optimizations)
- Fixed the graphics in 3D heptagonal warp.
- Heptagonal wind is now slower.
- Solid branches in the Yendorian Forest are now darker (solid branches should be green and weak branches should be red, but that wouldn't look well)
- Added particle effects for small branches breaking.
- Fixed stabbing by friendly monsters.
- Red/dark trolls produce particles if they don't affect the terrain. If a wall created from a monster death falls, its falling is animated.

2016.12.06 23:26 version 9.2d
- fixed boat graphics
- a crash with dragons in the shmup mode
- a bug with configuring keyboard (it was impossible to set arrows because they were interpreted as menu navigation).

2016.12.07 21:50 version 9.2e
- Now it can now be precisely configured at what distance we have "high", "medium", or "low" 3D detail. The default is the "high" detail level everywhere, which also gives more details than previously (and there is no longer a hidden dependence even if the option is off). (On mobile the defaults will be lower)
- collecting 10 hyperstones in spherical mode will no longer produce weird scores in the leaderboards
- Water Elementals were not disallowed to enter Zebra and LoEM (only player's magical boat was)
- a separating wall is now drawn if a body of water appears next to a chasm (as happens often in the Elemental Planes)
- when targetting orbs, circle markers and particle effects are shown (thanks to a previous bug which created excessively many unintended particles when targetting Orb of the Dragon)
- circle markers are now drawn both on the ground and high level, to make it more clear what is targetted

2016.12.10 21:33 version 9.2f
- Assigned sounds to some more events. Recorded new voices with Tehora, mostly for the Prince(ss).
- Orb of Aether no longer loses power needlessly with the Orb of Time.
- Fixed Viziers and Flail Guards killing themselves with Orb of Discord.
- Halloween holes display fixed.
- Fixed the save/quit option in the (v) main menu.
- Fixed the ASCII mode.
- Fixed trees displayed very badly in low-detail.
- Sand Worms and Tentacles no longer have a joint on the cell where they're coming out of the ground, and a particle animation is added at that location.
- Ocean walls look like buoys now in 3D Escher mode (but mechanics have not changed yet)
- Fixed graphical glitches on krakens and other multitile monsters not at the ground level

2016.12.11 11:46 version 9.2g
- fixed characters riding dragons not displayed
- Tentacles still did have the last joint

2016.12.13 23:03 version 9.2h
- Redesigned the display of items and kills
- Fixed the bug with cells incorrectly marken as attacked while skipping turns with the Sword (this problem caused Draugar to be confused)
- Circular markers etc. are no longer displayed while in menus

2016.12.14 02:30 version 9.2i
- fixed the rightclick/mouseover disappearing

2016.12.17 03:46 version 9.2j
- items/kills can be sorted according to one of several orderings (choose in the basic config)
- tuned the item/kill display (extra markers for native items/monsters, demons, no numbers for non-items, etc.)
- fixed shift+5 (change wall mode)
- friends set on fire will no longer try to escape through walls
- Towers of Camelot are done a bit differently now (the guards stand on Towers [level 3] which give better 3D, protect them from fire, and let them talk and fight)

2016.12.27 20:53 version 9.2k
- fixed the arrow navigation in menus
- fixed the following bugs with Orb of Time: Orb of Sword was not considered used when chopping plants; Orb of Empathy was always considered used if you had an ally nearby; with Empathy+Aether both were considered used even when they were not. (I feel it is a bit strange that the Orb of the Sword has an effect of blocking monsters' movement and that effect is not counted for Orb of Time, but I think it is fine as it is)

2017.01.05 17:58 version 9.3
- blog post: http://zenorogue.blogspot.com/2017/01/hyperrogue-93-three-new-lands-and.html
- online version
- Reptiles
- Dungeon
- Lost Mountain
- Columns now appear on the coasts of R'Lyeh so that you know where you are
- The World Overview and PTM now have two pages (but you can also view everything on the single page). Also a help screen is added for the World Overview.
- Separate pathfinding for slow monster, ivies, and worms
- Orbs of Yendor no longer block movement
- Smoother movement when scrolling animations are disabled
- Treasure cheat now gives Elixirs, Ivory, and Rugs quickly in the Crossroads, to make it easier to reach the halfplane lands
- Animated leg movement for Hyperbugs and Metal Beasts (not very visible for Metal Beasts though)
- A sound added when attacking with the magic sword, and removed when using the strong wind
- Dash/frog/strong wind now kills flail guards, pikemen, and hedgehog warriors if appropriate.
- Fixes in the Euclidean mode: removed trees in the Clearing, fixed heptagonal shadows (e.g. of the hexagonal columns in R'Lyeh), regular patterns in the map editor now work, and the lines are shown in the correct position
- minor bugfixes: stun stars appear above heads; a graphical glitch with Yendorian Forest adjacent to CR4; in the Map Editor, only the currently set "display codes" option is highlighted; "You are now a tortoise heroine!" (not "hero") in shmup

2017.01.07 23:53 version 9.3a
- updated the Czech and Russian translations
- added achievements for PTM and Yendor Challenge (1000/5000/15000 points)
- added two new Yendor challenges
- quick-land-teleport cheat works better now
- added Reptiles and Lost Mountain to the Euclidean mode
- the Pure Tactic Mode for Dungeon works now
- renamed "Orb of Dash" to "Orb of Vaulting"
- added translations for "small bush"
- the close button now quits the game again (or asks for confirmation if it thinks that confirmation is needed)
- mousewheel now can be used to scrolls big lists in menus
- fixed the typo in achievement "Mountain Climber"
- fixed mouse direction interpretation while Alt-highlight is on
- fixed the display of World Overview in high resolutions
- fixed monster nativity info in Living Caves

2017.01.10 17:16 version 9.3b
- Reptiles, Haunted Woods, Galapagos difficulty now depends on the number of Orbs of Yendor. High scores for the Galapagos YC have been reset (scores of Vipul and tricosahedron are removed, but they should be back when they relogin into YC)
- Flavor messages for unlocking Mountain and Dungeon
- Reptiles now has the requirement of 10 Elixirs, instead of the Ivory Tower
- Fixed two separate descriptions (one incomplete) for Orb of Nature/Friendly Ivy
- A sound for tricking Flail Guards
- Mousewheel now scrolls down immetiately even if it overscrolled up too much
- Fixed the Orb of Shielding allowing to stay in place in fire
- Pushing off heptagons using the keyboard worked weirdly -- fixed. (There is a direction indicator for keyboard users, and mouse users can enable the "draw mouse circle" option in the Advanced config to have an indicator.)
- It was intentional that Reptiles can climb up and down Red Rock III, but suicides were not -- fixed, also added stuntimes to reflect that climbing is hard for them.

2017.01.10 18:04 version 9.3c
- fixed the falling animations

2017.01.16 17:42 version 9.3d
- Collecting 25 pieces of Ancient Jewelry allows your orb-swords to chop through barrow walls (I think PTM is more interesting this way)
- Added sounds for Orb of the Sword used against barrows and plants.
- Reptile bridges (which are created when a reptile moves over water) no longer catch fire. Using fire on reptile no longer creates bridges. Items under reptile bridges are destroyed. Kills no longer raise drastically when mousing with Dragon over a reptile floor.
- Land description mentions explicitly that Whirlpool can be left with Orbs of Safety, as otherwise players with previous experience with trap lands would expect the same of Whirlpool (I am not sure whether a warning should be given for trap lands)
- Fixed movement animation for heptagonal Krakens (previously crashed the game).
- Key to Yendor can no longer generate on a Reptile; also generates on a lone floor in Reptiles now.
- Sightrange in the cheat mode can be set a bit over 10 now. Also "overgenerate" option is added to the sightrange dialog, which makes sure that everything you see is fully generated. Sightrange is reset back to 7 if cheat mode is off.
- Targetted orb (and summoned monster) are now marked with '!' in the list. Orbs with power < 10 have a slightly bigger number so that you can see that they are running out.
- Dead Orbs are now correctly shown to always appear in the Haunted Woods. (Orbs of Safety are forbidden, but other Orbs do appear in general.)
- Flavor messages when collecting items no longer appears on non-pickupable Grimoires, and they do appear on Mirror shards. Also a different message is now used instead of "That was easy" if your first monster was tough.
- Eagles no longer can make an extra move after attacking an ally and moving into its position.
- Fixed a bug with checkmate rule not working correctly with Orb of the Sword's in-transit cell.
- [shmup] Orb of Yendor was not collectable
- [shmup] Reptiles did not work correctly, also the 9.3 orbs did not work correctly (Nature gives you life, and Vaulting lets you shoot another missile backwards)
- [shmup] the game no longer crashes when a monster's missile hits a monster in shmup (such kills are credited to the player who caused the monster to shoot)
- [shmup] fixed Orb of Recall

2017.01.21 16:51 version 9.3e
- selecting princess quest in the cheater's overview now moves you to the Princess immediately (no need to press Space)
- fixed the message about Swords when getting 25 of not-jewelry, and added a special message the first time you collect 25
- extra information about the high-scoring game was not uploaded to Steam
- Chaos Yendor challenge should be fixed (previously played game should be already counted when you log in)
- '8' no longer switches colors when playing on the numpad

2017.01.22 21:47 version 9.3f
- added some sounds for Cultists (thanks KosGD!)
- fixed the problem with reassigning the Yendor challenge in 9.3e
- help now mentions that right Shift can be used instead of right click (to help OSX users)

2017.01.31 23:34 version 9.3g
- added a new geometry to the geometry menu (the Zebra quotient space -- quotient spaces based on other patterns would be harder to add)
- mouse movement in elliptic geometry should be fixed
- added the predesigned pattern 'four triangles' to the map editor
- fix isNative for Palace
- Mobile versions: touching the item/monster glyphs for extra information should be fixed

2017.02.01 16:16 version 9.3h
- the problems with sightrange should be fixed
- middle mouse button no longer moves (only pans)
- fixed improper click detection in the World Overview (and possibly other situations)
- marked Orb of Luck as useless in some lands, and Orb of Nature as useless in the Vineyard
- fixed bugs related to the interactions of Orb of Nature with: Life/Friendship, Domination (two bugs), Frog/Vaulting/strongwind, Teleport, Recall (in all cases the friendly ivy is destroyed)
- also fixed the interaction of Life/Friendship and Domination
- Orb of Discord now does the default orb pickup sound (instead of silence)

2017.02.10 16:57 version 9.3i
- fixes in the shmup mode: fixed sharks (and other monsters on different levels) in 3D looking weird; Orb of Frog (and possibly some other orbs) crashing the game in multiplayer shmup; plate-related sounds were not played; falling animations and sounds; tuned the Reptiles a bit
- fixed the gnomonic projection in the spherical geometry
- implemented the Zebra quotient space in a more elegant and stable way
- [Android,iOS] a compass has been added so that you can move without obscuring the display
- [iOS] fixed the musical glitch
- [Android] possibly fixed the startup crash in new versions of Android

2017.03.05 21:11 version 9.4
- a new land: Prairie
- a new land: Bull Dash
- a new land: Crossroads V
- new parameters for 3D (Y shift and rotation angle)
- new models: ball model, hyperboloid model; models are now sensitive to eyedistance
- redone the commandline parameters
- special conducts now explained in the help
- Orbs frequency changed
- achievement for killing the Sandworm in the Zebra Quotient geometry
- mirrors now appear in the Windy Plains as advertised
- fixed the orthogonal projection in elliptic geometry
- shmup: Draugar no longer killable with knives
- shmup: not conventionally killable monsters can no longer be killed by being crashed into
- "%the1" in the Golden Egg description
- fix the ghost/Shield bug
- Orb of Storm no longer kills you in some cases (in hardcore) in the Land of Storms
- shmup: fixed the list of monsters killable by Orb of the Sword in shmup
- fixed the mousecircle -- shows the movement target as intended (not the cell under the cursor)
- fixed the movement compass in the mobile versions: colors of arrows correspond to features, mousecircle highligts target correctly, the compass disappears when you long touch to target orbs
- refactoring: geometry, line graphics

2017.03.09 13:12 version 9.4a
- further improvements to the command line
- darkening more
- improvements to svg output
- fixed the crash bug after Prairie
- removed the Prairie from the chaos mode
- added summoning rules for Prairie, Bull Dash, Zebra and Land of Mirrors
- Euclidean and spherical versions of the Prairie
- fixed the monster generation in quotient Palace
- improved the heat transfer algorithm (Icy/Cocytus). In the previous algorithm, the sequential processing of cells (outwards from the player) caused the heat to transfer differently from and to the PC. Additionally, walls now melt after the monster movement, to make the monster movement more predictable. The effect seems noticeable.
- in the field quotient space, effects such as heat transfer, fire spreading, and livecaves/livefjord CA now happen in the whole world instead of just in the view range. (So if you wait in place long enough, the whole Icy Lands will burn eventually.)
- CA experimentation land
- added sounds for Bulls waking up and crashing
- music was not declared for CR5
- fixed achievements in Google Games; fixed login to Google Games in Android
- fixed keyboard support in the Android version
- compass can be resized in mobile versions
- updated the German translation (a small bit)

2017.03.10 16:31 version 9.4b
- updated Czech and Russian translations.
- CA fixes: no more ghosts, help text, visible in the land list for finite geometries without enabling the cheat mode, CA mark
- fixed a bug which sometimes caused Great Walls to appear inside lands adjacent to Graveyard/Ocean even if they should not (e.g., Ivory Tower)

2017.03.25 02:06 version 9.4c
- some fixes to the Polish translation
- Vine Spirits are now destroyed when the vine containing them is destroyed
- Vine Spirits and Slime Beasts no longer can travel from half-vine cells to slime cells and vice versa (and similarly for seeps/walls)
- added a command line option for sound directory
- RogueViz

2017.03.31 21:35 version 9.4d
- [mobile] changing the character gender
- [Android] fixed the "share" button in the Android version
- [all] [mobile] fixed the website link to go directly to .../hyper/
- [all] offscreen wolves and some other monsters were not drawn in some situations
- [mobile] movement compass arrows are now darkened for illegal moves
- RogueViz: Collatz visualization and some other improvements
- dialogs are drawn to the side if screen space allows

2017.04.08 01:20 version 9.4e
- the Leaderboards are fixed
- Ctrl+E cheat moves to target geometry and back
- expansion (in "special modes") allows you to compare the expansion rates for various geometries
- fixed a bug with calculating the distance between arbitrary cells, and optimized this routine

2017.04.08 16:25 version 9.4f
- removed the unintended distance from origin from the expansion mode
- the spiral renderer now renders the whole path even if multiple PNGs had to be created
- the Tutorial (in "special modes") points the player to many basic things about the game, or interesting things about hyperbolic geometry

2017.04.14 18:56 version 9.4g
- a new floor pattern for Bull Dash (inspired by "Seven Butterflies Pattern" by Doug Dunham, in turn inspired by Escher)
- limit polygonal sides to 3
- fixed a bug with heat in the shmup mode
- fixed a bug with mouse control in non-disk models; the band mode is no longer in vertical mirror image
- in the line animation, arrow keys now control the speed
- CR4 no longer appear in the Canvas if you have >= 200 treasure
- [tutorial] fixed a crash when clearing the map after using '3' (pure heptagonal map)
- [tutorial] disabled Orbs of Safety as they were somewhat incompatible
- [tutorial] added a slide about the shoot'em up mode
- [tutorial] improved some of the texts
- [tutorial] disabled changing the geometry in slides/lands which do not support this
- [tutorial] Aether or Flash is given if you cannot teleport away from the current situation (or when you press the cheat key twice)
- [tutorial] added a warning if the player is trying to go to an unexpected land
- [technical] fixed the weird numbering of shapes in polygons.cpp; minor improvements to RogueViz

2017.04.28 13:25 versin 9.4h
- tutorial reminds about right-clicking
- black background and blue circle replaced by an aura
- fixed side number dialogs

2017.05.19 20:08 version 9.4i
- when the camera is rotated, aura and mouse are affected
- prettier trihepta grid
- the line patterns menu displays many kinds of regular patterns of lines over the game screen (Ctrl+W in the cheat mode, or 'random patterns' in the map editor)
- keys are now shown correctly in color menu items
- Tutorial: keys no longer work in other menus; info that Camelot unlocks early; 
- many improvements to RogueViz (special help, extra option s)
- navigation keys now work in RogueViz and color dialog
- Rogue description
- '1 turn' not '1 turns'
- weird keys no longer exit menus
- alt+enter for full screen
- keypad Enter should now work in most cases
- commandline options should work later
- stranded boats now can be used in the shmup mode under Orb of Water

2017.05.29 11:19 version 9.4j
- [technical] improved the architecture of the Tutorial
- the tutorial menu now shows what '5' does in the current slide
- [RogueViz mostly] virtualRebase now works in other geometries
- [RogueViz] Euclidean Collatz
- [RogueViz] better closing
- [technical] better conditional compilation: in particular, can be compiled with NOTTF (use built-in compressed font) and NOSDL (no graphics, but can still do e.g. SVG output)
- graphical inventory/kills in HUD instead of letters (optional)
- better inventory/kills on square screens

2017.05.31 18:50 version 9.4k
- translations updated
- ascending leaderboarsd (such as the Hyperstone time) should be fixed
- fixed switch the land from the menu in alternate geometry modes
- mimics and thrown knives are now simulated everywhere in field quotients (they cannot follow a straight line in shmup due to precision errors... I mean, don't expect too much of your aim!)
- fixed some things about the elliptic shmup mode
- fixed additional controls in the shmup mode (or when keys are remapped) -- they now work unless these particular keys have been mapped to something
- fixed Halloween crashing in the large field quotient geometry
- I feel like the game would benefit from having unique art for the Shards to display on the treasure counter. :) 

2017.06.08 19:53 version 9.4l
- fixed hyperbugs moving into Orb of the Shell
- fixed orbs appearing inside the Mountain platforms
- Orb of the Sword now removes bushes and branches (for consistency)
- added torus geometry (torus size configurable via command line parameters)
- command-line option to create monster(s) (e.g. -M "Red Hyperbug" 3)
- fixed the size of kills/items in the heptagonal mode (they were scaled up instead of down)
- improved mouse targetting of locations further away in Euclidean
- sphere shmup movement/elliptic confusing
- changed Orb of Winter to be 'forbidden' in the Minefield rather than useless
- seeps are listed as appearing in Dead Cave
- orb unlock info
- wind/fire effects, improved dry forest spreading
- [RogueViz] self-organizing maps

2017.06.12 19:45 version 9.4m
- [RogueViz] can switch the Tutorial to RogueViz presentation
- [RogueViz] fixed the placement of the legend in Euclidean RogueViz
- fixed a bug with resolving conflicts between 'standard' and configured keys

2017.06.18 19:00 version 9.4n
- mouse control in the vector graphics editor (e.g. click on 'add v' then clicking on the map will add vertices)
- the vector graphics editor now allows editing any part of the shape in a much more user friendly way
- Bulls can now attack tough monsters (hedgehogs, flailers, viziers) and push stunnable monsters now (even heavy ones) and Thumpers; if pushing is impossible, the Bull will be stunned instead of attacking eternally
- changing the screen background color now affects the hypersian rug mode
- added a missing russian translation
- [RogueViz] fixed legend in the svg/high quality output
- more control for text in svg output

2017.07.16 21:05 version 10.0
- peaceful mode
- anti-aliased lines, and linewidth setting, option to make lines further from the model center narrower
- rearranged the menus
- '9' key to list all the frames in the current slideshow; better support for multiple slideshows compiled in
- configurable border and foreground color (mostly for presentations, not available in the menus)
- aura effect adjusts to the background color
- nicer text frames
- aura in the spherical geometry
- fixed the Hypersian Rug on some machines (using another OpenGL function), glew used on Linux
- unicode superscript d is now used in the expansion screen instead of "^d"
- some preparation for the Inventory Mode
- texts changed, some minor translation fixes
- fixed the default wsad keys
- antialiased multisampling
- major refactoring: return to previous menu
- image in the character selection screen
- ignore zero-score games
- do not save zero-score games
- consistency in menu
- multiple selectable columns in scores
- menu -> scores => list the current game if in game over
- yendor/holygrail hardness fix
- hints shown on the quest status/quit screen
- long mirrors in the Mirror Land
- gravity destroys glyphs
- horns/bull now have different colors
- do not save princess in dungeon (and other gravity lands?)
- better love image
- controller works in menus
- better joystick axe configuration (no longer show up to seven players)
- on the esc-screen, the selection moves to 'continue' to prevent accidental quitting
- fixed Princess-related bugs (easier to find; squeak only once; no 'unknown princess'; saving with safety)
- inventory achievements
- double wall rate for Luck in the inventory mode
- slightly increased the charge count for Orb of Shielding and Orb of Freedom
- better config system
- replaced mtrand.cpp with the std implementation
- [technical] improved the NOGL compilation flag to avoid OpenGL
- [technical] refactoring (gotoHelp, sdltogl)
- [technical] changed #ifdef LOCAL to #ifdef EXTRA_...; extra features are now included by starting the compilation from another file
- [technical] HYPERPATH added, for reaching the files when HyperRogue is called from a different location
- [technical] private source files moved to the "private" dir

2017.07.1? ??:?? version 10.0a
- fixed a bug with achievements
- fixed a crash bug when restarting from the main menu

2017.07.21 23:59 version 10.0b
- more changes to the Hall of Mirrors: improved the Mimics, replaced the monsters
- made the Hall of Mirrors work in special modes (chaos, shmup, peace)
- multi-tile monster reflections are now animated
- fix crash bug when shifting modes
- fix crash bug with shmup mimics
- made the kill/treasure icons smaller
- removed the '!' marks on treasure in the Orb Strategy mode
- Orb of Discord no longer works o Krakens
- a bit higher mirroring for Orb of Earth
- fixed a bug with PTM desynchronization due to Mirror Land name change
- [technical] reworked the system of OS/capability compiler flags

2017.07.23 01:16 version 10.0c
- added missing descriptions
- updated the Czech translation
- Hall of Mirrors and LoEM are no longer forbidden to be adjacent
- fixed the Overview in the menu to go to the one appropriate for the current mode
- peaceful mode state is now displayed correctly in the main menu
- readded the sound when breaking mirrors
- fixed the vertical position of the flower in hand

2017.07.24 01:49 version 10.0d
- the bottom line in the inventory mode is now always visible (i.e. you can exit the inventory with mouse)
- peaceful mode and shmup mode are now compatible
- fixed the problems with free Orbs of Safety in the Orb Strategy mode
- fixed some texts

2017.07.25 03:21 version 10.0e
- more fixes for the peaceful mode: tortoises no longer move in shmup; Fire Cultists
  no longer throw fire; Ivy no longer grows; no more statues under Ivy; no more
  Grimoires; the Knights no longer talk about war; the Princess no longer wants
  revenge; the Sword is graphically replaced with a shovel and digs again
- fixed a bug with loading the old style config (affected the mobile versions)
- fixed the arrow keys to scroll
- the Android version should no longer draw the screen while locked
- victory speedrun leaderboards in orb strategy
- Narcissist and Mirror Spirit kills count

2017.07.25 21:24 version 10.0f
- color saving on 32bit machines should be fixed
- 'save config' appears again in the basic config

2017.08.06 14:00 version 10.0g
- added a new Yendor Challenge
- improved the efficiency in the Hall of Mirrors
- reduced the sulphur lakes in the Heptagonal Hell
- new princess messages
- Halloween and Reflection should no longer appear in the Chaos Yendor Challenge
- OoY now automatically activates if you move the boat into it
- no more 'you have found ...' spam while moving an object with a boat
- checkmate rule no longer thinks you are protected when standing on top of OoY
- fixed bugs with (hardcore) turn-based multiplayer
- bugfix: Dragon Chasm->Reptiles did not respect the Elixir of Life requirement
- no longer crash on saving peacemode
- map/vector editor commands now always fit on the screen
- [ui] translations updated, languages selectable from a menu
- [ui] new start menu
- [ui] the X for Yendor/Compass is now placed perfectly (well, on the same pixel, and not in Euclidean) and has an aura effect
- [ui] mouse now acts on click, not on release (configurable in the menu)
- [ui] animate legs in char select
- [ui] subtle animations in the inventory/kill list when a monster is killed
- [ui] player death animations in the hardcore mode
- [osm] fixed a bug with mirroring message
- [osm] fixed a bug with Dead Orbs gained incorrectly
- [osm] rewards for extra Daisies and Elemental Gems
- [osm] messages after 25 PF, DDaisies
- [osm] the inventory screen now displays more information
- [osm] dead orbs no longer require Graveyard in the OSM -- more logical that way
- [osm] command line options added for OSM and peace 
- [osm] improve centering the orb display
- [cheat] new cheats: save princess, unlock all touched Orbs of Yendor
- [cheat] 'F' clears the "killed by spilling slime carelessly" status
- [cheat] removed cheats that are made redundant by the Map Editor
- [cheat] a special screen for debugging the land generation (cheat: shift+G)
- [mobile] remove menu 'button' from mobiles
- [mobile] the Tutorial is somewhat adjusted for mobiles
- [mobile] map/vector editor available (though not very convenient)

2017.08.06 23:45 version 10.0h
- fixed the shmup mode not turning on
- fixed some minor bugs with playing the Tutorial with only mouse/touchpad

2017.08.13 21:42 version 10.0i
- fixed a bug with crashes in peaceful shmup
- fixed the square model
- fixed the charge count in the Orb of Air (it only gave 1 charge)
- kills and treasure count no longer appear in the peaceful mode
- fixed the orb generation in the Whirlpool in OSM (i.e. they no longer generate)
- translation fix
- limited the number of messages appearing on screen to 5
- you can now use Ctrl/Shift+mousewheel to control zoom and projection
- updated the online demo

2017.08.14 23:59 version 10.0j
- in the Chaos Mode you get Orbs earlier (i.e., no need to collect 10 treasures)
- OSM: Orbs of Beauty, Sword, Sword II, and Freedom automatically attack when acvtivated (and the activation direction (and the direction for Swords is shown on screen)
- OSM: balance tweaks for the Hyperstone Quest: some advanced lands give extra Orbs; Powerstones increase the number of orbs received from mirroring (and it also affects the mirrorings that happened before collecting Powerstones); mirrors appear together with Hyperstones, so you do not have to go to the Hall of Mirrors to use your new Orbs of the Mirror; - OSM: fixed the Black Lotus achievement awarded incorrectly
- OSM: the Hyperstone Quest cheat now works correctly
- OSM: fixed Orbs in the Whirlpool (10.0i fix was incorrect)

2017.08.18 03:12 version 10.0k
- Filtering by keyboard in the World Overview screen
- the World Overview now states the orb unlocked correctly in the OSM (for Mirror and Crossroads)
- magic boats no longer ignore the warp rules
- fixed minor bugs with boats moving items
- fixed some bugs with Alchemist's land copying
- spilled slime now stabilizes the Palace gates
- fixed pushing Thumpers into chasms
- reduced the monster generation in the Hall of Mirrors while you are outside
- no longer display the orbs on game over outside the OSM mode
- going from tactic to chaos or OSM should now start in the correct land (and thus no longer enable the cheat mode)
- Emerald Mine requirements were displayed incorrectly
- Sight range increase is now allowed in some of the special modes (not only the cheat mode)
- in the local scoreboard column selection, 'kills' key changed to '/' to remove conflict with searching
- Configured key and mission menu's overview now display the mode-appropriate overview screen
- separate land highscores should work in OSM (and some other modes) now
- RogueViz improvements
- fixed the 'quick mouse OFF' option

2017.09.03 ??:?? version 10.0l
- Orb of Stone over water produces bridges now
- You can now use Orb of Matter over temporary bridge again, to create a wall
- Fixed some ways of producing permanent land in the Whirlpool
- summoning bats in the Dungeon activates plates now, since they are stunned
- Fire spreading is now simulated in the whole generated part of the world.
- Orb of the Mirror no longer claims to give 2 charges when mirroring itself after powering up
- timer no longer runs while in the start menu
- do not spill slime through mirror walls
- fixed enabling the Princess Challenge
- reduced the spawn rate of Gadflies in the Prairie, for better balance
- Great Wall consistency
- fixed hotkeys in the inventory mode
- better mission screen in the peace/tutorial/autocheat mode
- Fixed a bug with saving Camelot PTM
- No more weird message on collecting Dodecahedra
- total victory no longer requires the Princess saved in the same session
- small fixes to the translation, RogueViz improvements
- added some extra rewards to the Prairie OSM.

2017.09.03 21:01 version 10.0m
- great wall consistency caused glitches in the Ocean generation -- hopefully fixed
- water tiles use tiles with less gaps now, so that it looks better in 3D
- a subtle wave effect on the free Ocean

2017.09.04 20:43 version 10.0n
- fixed the shmup crash bug

2017.09.17 14:01 version 10.0o
- fixed the mirror cache
- fixed the mirror glitch
- fixed the Princess Challenge
- fixed a bug which caused some texts not to be translated
- fixed a crash bug with Random Pattern Mode and Rock Red Valley on mobiles
- fixed mouse tooltip messages in mobiles
- fixed the checkmate rule not taking the mirrored mimics into account
- fixed some bugs with the activation of Orb of Yendor

2017.10.14 19:50 version 10.1

* four new lands
- Terracotta Army
- Hunting Ground
- Volcanic Wasteland
- Blizzard

* help and interface improvements:
- the help for Orb Strategy Mode did not appear when it should
- orb help now lists the OSM information (required refactoring)
- 'inventory' icon always appears in OSM now (even if you have no orbs)
- better info about forbidden/dangerous/useless orbs, and fixed a bug with marking using forbidden orbs
- more space for orbs in OSM, fixed some bugs
- help screen for lands includes bestiaries
- improved cheating in the Overview
- new message styles added (left-aligned messages which no longer obscure the game area)
- 'message log' is now a separate option in the mission screen
- added Halloween to start menu (if the date is correct) and fixed it in quit menu
- fixed the names in credits
- mission screen reshown after a bad move in 'see how it ended'
- fixed problems where the standard mode would not be reset correctly

* graphical improvements:
- Mimics now display Thorns (with Empathy)
- made Earth Elemental look similar to other Elementals
- improved Giant Fox
- improved the display of holes in Halloween
- fixed the 'away' function to draw sidewalls correctly
- Hall of Mirrors works better with high sightrange
- changed graphics for some orbs

* gameplay:
- Orb of Friendship is now forbidden in the Princess Quest
- fixed the Crossroads in PTM
- relaxed local orb generation rule in the Chaos Mode implemented in special cases too
- you no longer can have more than 6 bullets for the Revolver in Wild West

* technical:
- improvements in the graphics editor: 'u' loads the current monster image; if PC display is off, you automatically edit the floor below; fixed editing colors
- refactored the land generation
- some new command line options
- 'shame to cheat' is no longer displayed when autocheating is on

2017.10.14 19:50 version 10.1a
- fixed the missing leaderboards
- fixed the typos in the description of Lava Wolf
- fixed the ordering of lands in the Overview

2017.10.15 01:06 version 10.1b
- added wandering monsters to the new lands
- no longer highlight blizzard particles
- flash/lightning destroys terracotta warriors
- more tactical lands
- Salamanders stunned by fire
- slime visible in Volcanic Wasteland (but destroyed by lava)
- living monsters awaken Terracotta Warriors

2017.10.16 00:43 version 10.1c
- changes to the Hunting Ground:
- - a new pattern at 0 treasures
- - guards now always appear in pairs (not larger groups)
- - you can now see the guards leave to form larger ambushes at 10 treasures
- - made the 17-18th treasures a bit easier
- worms no longer spam messages while going over lava
- fixed the confusion between changing language and sending score to Leaderboards
- Item/boat burning message no longer appears when this happens out of sight
- 'that was easy' message no longer appears if you are actually fighting a group
- fixed the PTM list (Blizzard appeared twice instead of Terracotta)
- rebound 'i'nventory key no longer works if it should not
- Orb of Safety no longer goes above 7
- guarding dogs have slightly orange eyes
- ambush size is displayed by hovering over the item in Hunting Ground
- Terracotta counters are sometimes lowered at high treasure levels
- fixed two more graphical glitches in Halloween
- fixed the joystick support

2017.10.17 01:50 version 10.1d
- updated the translations
- made the dogs give up to 'regroup' when you have escaped
- you can now melt ice through great wall into the Blizzard
- if the sight range option is lowered below 7, ambushes temporarily increase it (as the land makes no sense otherwise)
- ancient weapon icon in the inventory

2017.10.17 23:41 version 10.1e
- added an option to disable background particles (for lower end platforms and for easier reading)
- added an option to change the font size on desktop
- the wind icon in Windy Plains is clickable now
- [mobiles] clicking the Inventory and Wind icons works correctly now
- [mobiles] fixed the missing 'achievements and leaderboards' in the menu
- no more ASCII characters in some wall display modes on lava+lily
- bridges over the merrcury rivers look better now
- Terracotta Warriors no longer wake up if they have ghosts over them
- Orb of Fish has a tail now
- minor text/translation improvements
- warriors awakening takes Orb of Speed into account now
- land connection likelihoods adjusted for the new lands

2017.10.25 23:17 version 10.1f
- fixed the Halloween in main menu
- fixed Zebra unlocking

2017.10.26 22:00 version 10.1g
- fixed floating-point values sometimes saving incorrectly on Windows
- fixed 's'ave the config also toggling the 's'team leaderboards
- fixed the 'wm' and 'mm' commandline options
- added the Octagonal geometry (work in progress)

2017.10.26 22:39 version 10.1h
- fixed some graphical glitches introduced by 10.1g
- fixed some graphical glitches in Halloween

2017.10.31 00:31 version 10.2
- added Crystal World
- reworked the geometry experiment menu
- changed the Hunting Ground music to Graveyard
- hint about Alt added to Hunting Ground
- extra help about slide changing, disabled Euclidean mode from early slides
- fixed the message priority on alchemy+wind
- fixed the wrong text in Tutorial
- fixed a bug which reduced the quality of graphics
- no more forced heptamarkers on non-truncated Warped since they are denoted with colors anyway
- fontscale is now saved
- fixed CR4 appearing inside mirror reflections

2017.11.01 00:48 version 10.2a
- improved the texts in geometry experiment menu
- translation updates (to Polish)
- the "expansion" screen has moved to the geometry experiment menu (click world size)
- 'o' key acts more intelligently now
- fixed the reverse keyboard movement in Euclidean
- fixed graphical glitches with the sphere (the sphere is now drawn completely, )
- added 'alpha' commandline parameter
- fixed some polygons which did not end in the start point
- Hunting Ground no longer hangs in some geometries

2017.11.03 22:56 version 10.2b
General:
- marked Orb of Earth as useful in Hunting Ground
- Rose Garden needs 90 treasure now
- the order of lands is now the same in all listings
- translations updated
- Glowing Crystals no longer required for the Hyperstone Quest

Geometry experiment improvements:
- Crystal World now generated in weird hyperbolic chaos mode
- no Dead Orb generation in the smallworld Graveyard
- Power works correctly on big spheres (randomly on other weird geometries)
- adjusted the hive radii in weird hyperbolic geometries
- fixed the Field Quotient Prairie
- improved the Land of Storms
- made ambushes work on the sphere
- added Mercury Rivers to Euclidean and spherical Terracotta Army
- improved Windy Plains on smaller spheres
- Zebra patterns for some of the new geometries
- Halloween on a Torus
- 'strong wind' was not allowed in Euclidean for some reason
    some fixes in validity
    validity appears in better place, lands colored
    don't display 'bad end'
    translations updated
    unified the land lists

2017.11.07 14:42 version 10.2c

Fixes in help/tutorial:
- fixed the Help in main menu showing incorrect screens
- fixed the problem with help not appearing correctly in Warped and Rose
- fixed the Tutorial not showing the help text for some slides

Geometry experiment improvements:
- Hypersian Rug now works with the torus
- conformal menu: band model for spherical geometry (aka Mercator projection) works nicely now
- conformal menu: fixed the azimuthal modes with Euclidean and spherical geometries
- you can now use 'Advanced Configuration' in Torus and Field Quotient geometries
- fixed the mobile HUD elements not displaying in the correct locations
- reduced the sphere graphics quality on mobiles
- fixed Sphere display with eyedistance
- fixed a freeze bug in Hunting Ground+Chaos+octagonal
- the wall blocking the starting point (e.g. "your" grave) is no longer removed in any bounded geometries

Map Editor improvements:
- the load/save feature in the Map Editor should now work correctly in other geometries
- MapEditor's "predesigned patterns" feature now works correctly with other geometries
- fixed a crash when trying to use predesigned patterns in Torus
- you can now hold mouse to paint multiple cells

Other:
- fixed glitches with OoWarp+Hall of Mirrors
- menus are no longer shown on the side in mobile versions

2017.11.13 12:00 version 10.2d
- fixed the incorrectly rotated display of Overgrown Floor and Ocean Surface in the standard geometry
- changing the model in conformal menu automatically resets scale/projection now
- fixed parts of 3D modelse disappearing in Mercator/equi* on sphere
- fixed the issues with falling animations (drawn in wrong order); also they remain active for longer time in non-hyperbolic now
- the center no longer disappears in Euclidean equi* models
- HUD elements, including the compass, now drawn correctly in all conformal pmodels
- lines behind sphere are now drawn (darker)
- better colors for objects behind the sphere when changing the background color
- fixed model boundary drawing on spheres
- improvements to the spherical equi* models: the correct circle is used as the boundary, instead of the whole screen; aura
- conformal/history mode in Menu is now marked ON if any of its features is active
- improvements to the Map Editor: fixed bugs with copying on new geometries; copying now also copies HP/stuntime; more efficient copying/painting when high radius is selected; "dragon" and "dragon head" show up as different names; buggy dragons are no longer fixed while still in the map editor
- the factor of darkening the elements behind the sphere is is now configurable (in 3D menu); also works better with transparency now
- fixed some bugs with the 'movement compass' for mobile devices (correct placement and rotation); it is now also available on all platforms (though probably not that useful not on mobiles)
- some fixes for shmup in new geometries (untested)

2017.12.03 20:02 version 10.2e

UI improvements:
- Improvements to the start menu. Selecting one of the options from the Start Menu resets all special modes you have configured, which should help in case if some weird mode has been set for some reason (if you have intentionally saved a weird config, you can just exit the start menu). You can now also go back to the start menu from the main menu, and selecting Shmup now takes you to the key configuration.
- score/kills in the main HUD is translated now
- Dog PC's nose is now black (previously it had the same color as eyes)

Graphics editor / geometry experiments:
- the graphics editor's tesselation editing feature is now made more powerful and intuitive. You can edit more sophisticated tesselations from the editor (previously you had to switch to the map editor to do this). Side menus are now used for regular patterns and line patterns. Some simple regular patterns have been created for the new geometries, and asymmetric tiles are now rotated more intelligently now.
- selecting the field pattern on Euclidean does torus instead of crashing
- fixed the bug with user-drawn shapes overtaking the screen in stereographic perspective on sphere
- fixed the basic floor in nontruncated four hexagons
- some new related commandline options

Gameplay bugfixes:
- friends are no longer crushed when Empathy should protect them
- no more 'Ambushed' messages when picking up dead orbs etc.
- fixed the incorrect lines in help description (incorrect repetitions, Guest states)
- no more Prairie/Crossroads III borders (Prairie/C4 looks like a bug but is intentional)
- no-escape Blizzard cells now generate OoSafety
- Fixed the bug with instakillable Salamanders
- Hunting Dogs are now slower in coop shmup
- fixed a minor potential bug with non-orientable surfaces

2018.01.05 19:15 version 10.3

Major new features:
- four new lands: Jelly Kingdom, Ruined City, Snake Nest (three-color geometry only), Docks (octagonal geometry only)
- new special mode: texture mode
- enhancements to the Hypersian Rug mode (native geometry change, perspective)

UI enhancements:
- most actions which deal with external files now let you choose the file
- HQ/SVG shots in the editors now include the aura background (use Shift+F6 for the old way)
- renamed 'truncated' to 'chamfered'
- added advanced keyboard/mouse controls to the Help screen. Also added some new advanced mouse controls

Gameplay bugfixes
- monsters no longer inconsistently try to look at the player in quotient geometries
- Orbs of Fire, Lightning, and Lava are now marked as dangerous in Dry Forest.
- Orb of Lava is now marked as dangerous in Yendorian (Fire/Lightning/Dragon were already dangerous).
- Volcanic Wasteland no longer spawns next to Dry Forest or Vineyard.
- fire now spreads from lava to adjacent flammable materials.
- fixed the grid markers for items in Alchemist Lab
- fixed a bug with Orb of Slashing in OSM inventory
- cleaned up some special cases wrt attacking a Vizier

2018.01.07 00:00 version 10.3a
- fixed screens not disappearing when restarting
- changed the word 'chamfered' to 'bitruncated' ('chamfered' was not correct either)
- fixed the Snake Nest in non-bitruncated Octagons
- fixed some bugs with Snake Nest generation
- fixed some problems with memory clearing in other geometries (which could cause crashes or memory leaks)
- a sound for Blue Raider's attack
- Mirror Land is back in Euclidean
- fixed the missing word
- fixed killable wandering Skeletons in Ruined City
- PTM did not display the last element if the list length was odd
- a new Yendor Challenge added
- bitruncation is now switchable for the square grid
- fixed a bug which desynchronized the PTM scores on OSX
- PTM/Yendor scores should be saved correctly for the new geometries
- updated the Czech translation

2018.01.08 23:26 version 10.3b
- you can now play Crossroads IV in alternate hyperbolic geometries, for a mostly complete game (not all lands though)
- removed the Crossroads from the Chaos mode
- updated the Russian translation
- some translation/text fixes
- fixed geometry restrictions for achievements/leaderboards -- which leaderboard entries should be removed?

2018.01.11 23:37 version 10.3c
- fixed the crash related to RRV
- new graphics for Sandworm/Rocksnake/Tentacle tails
- removed the sandworm/tentacle-from-the-ground dirt effect

2018.01.20 20:14 version 10.3d
- Android/iOS versions updated
- weirdly located trap arrows should be no more
- fixed the octagonal/fieldquotient geometry
- commandline option to change the effect volume
- fixed some potential crash sources

2018.01.27 15:41 version 10.3e
- attack animations
- a feature to remove faraway (~150) cells for the memory (ones which probably cannot be reached anyway) -- this is now the default for low memory devices [ you will see if a cell has been removed :) ]
- some rebalancing for the Terracotta Army: more Jiangshi at low treasure counts, attacking Terracotta Warriors directly may summon Jiangshi if there are not many on screen
- You now get radius 1 minefield uncovering at 1 Bomberbird egg (no more permanent unlock)
- rose scent is now visible over chasms
- fixed the selection in color choosing dialog
- a bit stronger Rose dispersion for elementals; Blizzard disperses Rose too
- changed the message when activating orbs from OSM
- some extra commandline options

2018.01.31 00:25 version 10.3f
- fixed a bug which caused the Blizzard not to look as it was supposed to on Windows
- fixed petrified monsters not destroying arrow traps
- fixed some issues with speheres in the Hypersian Rug mode
- you can now use '1' and arrows to move points in the Hypersian Rug mode, and '2' and '3' to rotate by 180 and 90 degrees ('4' to enable the ODS projection used in https://www.youtube.com/watch?v=tT80boNjP_A is compiled out)
- fixed fieldpattern-based lands (Blizzard, Volcanic, Ruined City) on the torus
- improved Ocean and Volcanic tides when sight range is set to more than 7

2018.02.03 21:45 version 10.3g
- fixed the sorting of local scores
- high quality screenshots can now be saved with OpenGL (this works faster and works with Hypersian Rug)
- rewritten the stereo vision -- it has more options now
- Hypersian Rug now works on Android, and it is controllable by rotating the device (combined with "stereo version" Cardboard VR should be supported)
- fixed a crash bug in the iOS version

2018.02.09 08:08 version 10.3h
- minor optimizations
- fixed a crash bug when leaving quotient space
- fixed the problems with incorrect display and mouse control in the Hypersian Rug mode
- fixed the display in the spherical geometry

2018.02.12 16:12 version 10.3i
- updated the iOS, Android, and online versions (Hypersian Rug works in all of them now)
- magic texture adjustment: fixed the algorithm
- magic texture adjustment: fixed the names of parameters; added texture position X/Y
- Implemented the shmup versions of Ruined City and Jelly Kingdom.
- fixed particle transparency
- properly colored Mimic particles; no falling animations for Mimics
- Illusions ignore plates (does not change much?)
- capital letters used as hotkeys for later Yendor challenges, instead of weird symbols.
- a new Yendor Challenge: Living Caves
- fixed the 3D effect on graves and mercury rivers

2018.02.14 11:38 version 10.3j
- fixed the Elemental Planes (did not appear because of a bug)
- improved the Snake Nest at high treasure counts
- added extra lands to the Random Pattern Mode
- rock snakes/red trolls now destroy items when they die over them (except on Rock III)
- when loading textures in the texture mode, you can now tune individual triangles
- fixed the descriptions in the stereo vision config
- updated the translations, added some previously untranslated texts

2018.03.02 13:09 version 10.3k
- made dragon dismounting easier
- added attack animations when attacking trees and mirrors
- better quality Hypersian Rug rendering (do not cross itself)
- reversed aura when projection < -1
- fixed the high quality screenshot feature
- fixed screensize/radius in portrait
- fixed zoom while editing texture
- fixed texture load-on-save
- fixed SVG output of spheres
- 'docks' subpattern can be changed now
- fixed slightly wrong placement when stereo is off
- fixed the hotkey clash in texture adjustment menu
- fixed mousing doing several things in texture adjustment
- made the zoom consistent (it worked differently in Euclidean)
- disabled game playing if 'renderonce' is on
- some new commandline options
- map screen size computation in Euclidean now acknowledges projection and sightrange

2018.03.02 XX:XX version 10.3l
- fixed monster infighting caused by dragon dismounting changes
- fixed Android slowdown

2018.03.24 17:22 version 10.3m

For hyperbolic geometry nerds:
- added smooth surfaces of constant negative curvature (in the hypersian rug menu)
- Alt makes rotation slower in the Hypersian Rug model
- added the hemisphere model
- improved the quality of 3D models from conformal menu

Gameplay bugfixes:
- fixed the Princess Quest not appearing
- worm-like creatures are no longer happy to get into bull herds
- raised Zombies no longer move on their first turn
- no more great walls in PTM Graveyard
- no more Lost Memory areas in PTM Chaos
- no more broken Red Raider pairs close to player start
- Baby Tortoise movement is now animated (when switching places with an adult)

User interface:
- shmup mode in the start menu replaced with a special mode chosen randomly from a selection
- the start menu now includes an explicit option to use the current/saved settings

MINOR:
- reptilecheat option ('-rch') disables Windy chasms
- synchronized fanframe so that the period is 1000 ticks

2018.03.27 14:48 version 10.3n

- replaced green/red dots in the Blizzard with arrows
- spawn sound for Wind Crows
- updated the translations
- the conformal/history menu is split into "models of hyperbolic geometry" and "history menu"
- improved the automatic rotation system in "models of hyperbolic geometry"
- lower halfplane option added (works better in the Ivory Tower than upper halfplane)
- four new models in "models of hyperbolic geometry"; improved the old ones (especially the 3D effects are now 'correct', except that they assume that the ground is a hyperbolic plane)
- when changing the sight range, overgenerate works immediately now.

2018.04.12 21:30 version 10.3o

- New geometries based on the Goldberg polyhedron construction. This lets you
  play on bigger (in term of cells) spherical worlds, or hyperbolic worlds
  with a smaller proportion of heptagons/octagons.

- You can select Crossroads IV in non-standard hyperbolic geometries to play a roughly
  normal full game (except that all the straight line land borders are CR4-style).
  This already existed, but it has been improved (e.g., Ocean should work correctly,
  bad quality lands are still included so that you do not get unsatisfiable
  unlock requirements). Additionally, the lands are now sorted in 'geometry experiments'
  by quality, so Crossroads IV is easier to find.

- Sight range is now handled more cleanly. You no longer get jagged edges while
  scrolling the map. Drawing the Zebra quotient geometry is more efficient.
  When adjusting the sight range, you give the value as a bonus (e.g. -2 = 
  2 less than usual) -- this makes more sense as the default sight range depends
  on the geometry. More options if cheat mode is on -- you can separately
  adjust the "generation range" and the "game range" (essentially, monsters' sight range).

- Fixed some bugs with the texture mode: 'cancel texture' actually cancels now, 
  texture remapping, 'slave color' hotkey clash, textured spheres are drawn correctly.

- Improved the small world geometries: Vine Spirits/Witches always appear in the
  Land of Power and Vineyard; additional fire is no longer permanent in the
  small Land of Power; fixed the Lost Mountain. Also more efficient generation.

- Emerald Mines and Vineyard are now random in order 4 geometries, also Vineyard is random in spherical
- some new commandline options
- the key name F1 shows correctly
- fixed the Red Rock Valley in non-bitruncated heptagonal.
- fixed the stereographic projection of a sphere
- fixed the Yendorian sky colors when scrolling
- Knights and quit-menu now display circle sizes only if HyperRogue actually knows them
- three-coloring appears in the menu for cube
- no more orbs on Crossroads in the PTM equidistant lands
- Temple of Cthulhu walls should no longer be impassable in non-standard geometries

2018.04.13 14:49 version 10.3p

- Improved land validity reporting. Appears when starting the game or when requesting help for the land.
- Fixed the bug with Caribbean in non-standard geometries (caused freezes, crashes, and bad horocycles)
- Elemental Planes work in weirdgeometries (but with simplified walls).
- Fractal landscapes fixed in Goldberg heptagonal geometries
- No more Lost Mountains in quotient Jungle etc.
- GP(x,y) with x<y can be selected now

2018.04.14 10:28 version 10.3q

- Clearing works in bounded geometries now.
- Fixed the flash markers.
- Fixed the geometry experiment games automatically marked as cheating.
- Fixed score sorting.
- Fixed Wild West not appearing in PTM.
- Fixed the crash in PTM.
- Fixed the particle scaling in Goldberg.

2018.04.15 13:35 version 10.3r

- Fixed the missing walls in the Palace
- Geometry Experiments menu now lets you change land in the standard geometry too (but you will be marked as a cheater)
- Allowed the sloppy Graveyard in heptagonal
- Also allowed Land of Storms which was disabled by mistake

2018.04.23 13:44 Version 10.3s

Gameplay:
- better messages when dropping Dead Orbs impossible
- fixed odd stripes of CR4 in the Graveyard
- fixed the bug which caused too low Great Wall generation in the Crossroads
- falling birds now trigger trapdoors
- non-standard-hyperbolic chaosmode no longer generates lots of the originally selected land
- made some things in the Tutorial more clear: removed the '3' key for heptagonal mode
  (probably more confusing than useful); the '1' and '2' keys now print a message that
  you are temporarily leaving your game or returning to it; in the ESC menu, the button
  captions are adjusted when they disable something rather than enable it  

Graphics:
- Yendor/Caribbean cross appears on the boundary again
- map no longer disappears suddenly and irreparably if you scroll into the invisible region
- 3D graphics are now automatically scaled vertically on high Goldberg settings
- labels (e.g., numbers shown if you check the expansion rate) are no longer displayed on the cells which are behind the sphere 
- predesigned patterns: 'distance from origin' option, an option to make all the floors invisible (possibly show line patterns only); fixed issues with line patterns drawing incorrectly
- pageup/down spin 2x slower to make it possible to rotate by 90 degrees

Models of hyperbolic geometry:
- increased the default Hypersian Rug distance so that the whole model fits on the screen
- the conformal square works better in non-hyperbolic geometries now
- Earth included as a loadable (spherical) texture, also fixed some issues with loading such textures
- in the 'display mode' menu, appropriate projection names are used in non-hyperbolic geometries
- two-point equidistant model rendered better on the sphere
- non-conformal band models can now be saved to a file too
- line animation is now more precise -- it starts and ends strictly at the starting point and the current position
  (unless you change an option), if these two cells are similar (e.g. move 15 cells in a straight line in the Zebra pattern) 
  the back-to-start transition will be invisible, and thus line animation and spiral will be smooth
- spiral mapping no longer crashes the game, and resizing the window works now
- fisheye model (mostly for Euclidean geometry)

2018.05.03 13:19 Version 10.3t

- ESC clears the viewdistance option
- fixed a bug with bitruncated order-4 geometries (caused crashes on OSX and no effect otherwise)
- fixed some issues in the texture mode (incorrect saving, 'cancel texture', not remapping after changing the parameters)
- fixed the 'land mirages' appearing in the Ocean
- fixed the Crossroads IV/Camelot/Warped problem
- fixed the chessboard pattern
- fixed treasure/monster generation in randomized palaces
- disabled quest in weirdhyperbolic palaces
- fixed the Princess Challenge activation
- line patterns now work correctly in elliptic geometry
- fixed the validity information for the Snake Nest
- fixed the zebra3 pattern on Goldberg geometries
- added a "cube/elliptic" geometry
- improved the vertex placement for Goldberg polyhedra on spheres
- GP(x,x) implemented in elliptic geometry
- more roses spawn in chaosmode

2018.05.08 01:40 Update 10.3u:
- A major rewrite of the floor pattern code. Patterns are now automatically remapped to all geometries, with great results. 
Warped Coast and Crystal World in GP(2,1) octagonal (or similar) are especially interesting (also the 'show heptagons' option in map editor patterns
in this geometry, but it is not playable).
- Multi-tile monsters (especially Krakens) also look better in non-standard geometries now.
- Reduced the line quality in (spherical) Goldberg polyhedra (high quality was good with just 32 cells, but renders too slow with more).
- Green and Gray Raiders move correctly in non-standard geometries.
- Krakens no longer change their number of tentacles in GP(2,1) octagonal and similar (they use their own rule for forbidden cells).
- fixed crashes in some weird land/geometry combinations.

2018.05.09 21:38 Update 10.3v:
- fixed Hive
- fixed a memory error

2018.05.26 12:00 Update 10.4:
- Strange Challenge (on Steam)
- leaderboards rewrite: faster sync of Yendor/PTM scores on Steam
- translations updated
- Orb of Slaying is no longer considered universally useful; it also permanently kills Mirror Spirits now
- fixed the shmup mode

many geometry-related fixes:
- reduced the priority of Big Triangle so that it is below other floors -- looks better in Crystal sublands
- lightning bolts should no longer freeze the game in some bounded geometry settings
- Hunting Dogs no longer retreat outside of non-quotient hyperbolic geometry
- fixed Goldberg graphics in elliptic and Zebra quotient geometry
- fixed geometry changing in the Tutorial
- improved compatibility ranking for Windy Plains and LoStorms ('pattern incompatible' in non37; LoS has randomized version for other geometries now), RedRock and RuinedCity (need good pseudohept pattern), Hedgehog lands (less fun in order-4 geometries), marked an incomplete land as in development
- fixed plain floor shapes in order-4 geometries (previously only worked in Euclid Squares of these)
- fixed threecolor pattern claiming to work when it does not, or producing weird effects

non-game:
- fixed a bug in fixStorage, and other fixes in RogueViz; added the 'staircase simulation' to RogueViz
- ODS projection now works in Euclidean and hyperbolic

2018.05.27 01:21 Update 10.4a:
- Strange Challenge should exit correctly.
- rules are described better in other geometries

2018.06.13 01:32 Update 10.4b:
- Orb of Love does not give the 30$$$ bonus in the Strange Challenge -- this is now made clearer (the displayed score no longer includes this 30$$$, and a help text for Orb of Love is added).
- Strange Challenge should reset OSM and Chaos mode correctly
- a flat torus can be embedded in S^3 -- HyperRogue now knows about this when rendering torus in the Hypersian Rug mode in the spherical native geometry
- it was possible to get another chance in the Strange Challenge by pressing ESC in specific circumstances -- this should be fixed.
- fixed some issues with adjacency taken into account incorrectly with Hedgehogs/Flailguards/Pikemen and Warp/halfvines
- orb of Horns, and other cases caring about opposite cells, should now work correctly in nonstandard geometries
- marked Orb of Lava as useless in the Haunted Woods
- fixed the Earth Elementals falling/dying in Red Rock Valley
- Orb of Recall no longer creates holes in the Yendorian Forest
- fixed a bug which caused forgetting the PTM game when 'reseting special modes'
- added the 'Banach-Tarski-like' visualization to RogueViz
- faster drawing of convex shapes in the online version
- translation updated, fixed some player gender directives in Russian
- torus rendering no longer creates darker areas because of the side difference
- fixed the non-3D display of rock formations in Goldberg geometries
- Hunter dogs (guarding/regrouping) and sometimes Ice Wolves no longer count as a different kill type (not counted in total kills)
- uniformized the 'back' and 'help' options in menu (consistent hotkeys, consistent placement, added them where they were missing)
- pushing a thumper through a stranded boat is no longer allowed
- fixed a bug with pushing Thumpers through tentacles

2018.06.14 16:39 Update 10.4c
- fixed viewing the "past challenges"
- fixed a bug which sometimes caused current scores to be copied to past challenge leaderboards. 

2018.06.18 17:49 Update 10.4d
- no more ambushes when summoning orbs from OSM/SC in the Hunting Grounds
- Land validity is displayed when selecting geometry after selecting land. Validity message appears in the geom-exp menu.
- movement animations now work in quotient geometries
- Rock Snakes from the Snake Nest now keep their colors in other lands
- more Ivy in the Jungle in Goldberg geometries
- fixed problems with computing distances in non-standard tori
- creating Mimics in the map editor now works correctly
- fixed saving the full texture
- fixed some problems with adjusting textures to Goldberg geometries in the texture mode; improved the delayed pixel drawing

2018.06.22 20:03 Update 10.4f
- (10.4e was a Steam update just fixing SC#9)
- new quotient geometries: 'minimal quotient' (based on DivisionByZero's construction https://steamcommunity.com/app/342610/discussions/1/3051633726580659909/ ), Klein Quartic, Bolza Surface (aka the "Docks Quotient"), Bolza Surface x2
- fixed some issues with the generation of Land of Storms in other geometries
- bitruncated 'four hexagons' should no longer appear in SC; non-bitruncated 'four hexagons' will be rarer

2018.06.24 01:19 Update 10.4g
- fixed Arrow Traps not killing anything (and possibly other similar cases)
- fixed the 'skip start menu' option

2018.06.28 14:14 Update 10.4h
- fixed the map not being generated far enough in non-std geometries after Teleport (and other orbs)
- fixed the missing message when picking up orbs from a boat
- rewritten various pathfinding (and similar) algorithms in a more robust way
- Orb of Freedom is now checked after the Terracotta Warriors, and it consider active arrow traps as impassable
- kills-at-once achievements now also count the 'original' kill; it no longer counts if a monster performs the killing
- in quotient geometries, the whole world is now generated from the start (otherwise e.g. Blizzard breaks down); also the windmap (used in Blizzard/Volcanic) is now generated correctly in field quotient
- an option to display all floors as 'full', i.e., without spaces between them ('r' in map/graphics editor)
- new commandline options: -fsh (floor shape display) and -noshadow (disable shadows)
- fixed a bug with Orb of Mirror display in OSM

2018.06.29 12:27 Update 10.4i
- fixed a crash introduced in the last update
- the Strange Challenge ON/OFF switch now shows the correct state (not the state of Random Pattern Mode)
- fixed the "chaos mode locked" help display 
- fixed Wild West (gaining extra bullets, shooting)
- Random Pattern Mode: randomized the starting land; Baby Tortoises no longer appear

2018.07.03 04:15 Update 10.4j
- fixed Prairie
- Orb of Empathy + Orb of Water no longer works on enemies too
- fixed Strange Challenge leaderboard display

2018.07.07 11:06 Update 10.4k
- fixed shards collectable in the old Land of Mirrors
- fixed the animation in (small) field quotient geometry
- fixed the "-geo" and "-qpar2" command line options

2018.07.08 14:22 Update 10.4l
- fixed PTM games not recorded when switching modes
- Random Pattern Mode: fixed the Land of Power, treasures appear in the Reptiles.
- fixed the "-geo" parameter

2018.07.11 12:45 Update 10.4m
- Goldberg-Coxeter construction in order-4 geometries
- Raging Bull / Orb of the Bull / Orb of Horns worked correctly only on hexagons and heptagons
- marked Whirlpool as not working in order-4 geometries
- "triangle grid: rings" now works in order-4 geometries
- fixed the size of Krakens and energy sword on the Euclidean square grid
- fixed Kraken movement on squares
- shift+f2 to shift+f4 can now disable HUD, FPS, and the map
- fixed several instances when PTM score would not be recorded when changing modes

2018.07.30 09:22 Update 10.4n
- Docks and Snake Nest no longer appear in Strange Challenge bounded geometries (SC#21 scores removed)
- irregular grids (available in 'variations' in geometry experiments -- work in progress)
- fix a crash bug in the texture mode
- fixed a crash bug with the 'mark' command when no cell active
- improved the controls (keyboard, compass) in non-standard geometries
- fixed some graphical litches in the stereographic/gnomonic projections of the sphere
- mark cells with stars instead of circles if in stereo mode or in spherical geometry
- fixed some orbs not saved correctly in Orb Strategy Mode
- highlight buttons on overview/PTM screens
- fixed the seabed layer which was drawn incorrectly
- close/open/trapdoors and Rugs now look better in non-standard geometries
- faster startup on restarting the game
- killing a Tortoise with a saved baby kills the baby too
- blowing off a tortoise with baby now blows off the baby even if there is an item in the target location
- summoned Tortoises no longer die on hit
- it is no longer allowed to use Orb of Space on saved Baby Tortoises

Mobile version improvements (not yet released:)
- device orientation-based scrolling on mobiles
- dialog navigation enabled for mobiles
- improvements to the mobile compass: can be used in modes other than MOVE (long click to switch mode to MOVE anyway); better arrow scaling
- improved zoom feature (in Overview/PTM screens); fixed a bug with zoom spilling to the inventory screen

2018.07.30 17:47 Update 10.4o
- fixed a crash bug with displaying hypersian rugs in the inventory
- added a stretch parameter for cylindrical equi-area and equidistant models

2018.08.05 17:40 Update 10.4p
- Gameplay/bugfixes:
- - fixed a crash with Orb of the Warp
- - fixed the Ocean Yendor Challenge
- - fixed the Crossroads IV in PTM
- - fixed a bug which caused sea buoys to sometimes not appear
- - fixed the message order for teleport/jump orbs
- - fixed a checkmate rule bug with Pikeman and (potentially killed) monster on the way
- - the cost of leaving Land of Power now happens before collecting items
- irregular tilings:
- - bitruncation (more tilings supported, including the Crystal World and Warped Coast)
- - some help text
- - singletype patterns now can be remapped to irregular grids
- - fixed a crash when enabling irregular tiling multiple times
- texture mode bugfixes:
- - textures were scrolled incorrectly after loading -> fixed
- - texture configs based on polygonal tilings now load correctly
- - fixed singletype texture patterns
- - texture aura option
- graphics:
- - line quality option
- - fixed the lines in the svg screenshots
- - vertical stretch parameter is now available in all models; more details in equi-area
- - fixed some glitches in the stereographic projection of the sphere
- Strange Challenge bans: Orb of the Warp and Orb of Lava in non-bitruncated geometries; Land of Storms in finite geometries
- translation update (PL, CZ)

2018.08.22 17:40 Update 10.4q

New geometries:

* Archimedean tilings. If all faces are regular, and all vertices are identical, you can pobably play HyperRogue on it.

* A variant of the binary tiling. A horocycle-based tiling great with horocycle-based and equidistant-based lands.

Bugfixes:

* fixed Ocean not displaying at all at low detail
* fixed crashes when collecting Hypersian Rugs in some geometries
* fixed the description of treasures which unlock secondary orbs -- other treasure name given correctly
* a button appears when player not visible; fixed space-centering
* land validity: Warped Coast knows that it is OK in chessboard geometries
* digons arising in the Warped Coast in some geometries are now shown as narrow tiles
* Blizzard/Volcanic should now work on Goldberg, irregular, and Archimedean spheres
* improved mirrors in various geometries
* improved the display of huge shapes (such as tetrahedron faces) in spherical geometries
* improved the shadows
* GP(x,y) spheres were not displayed correctly if x and y were very large
* texture remapping: better display of slave tiles, improved remapping chessboard tilings to Goldberg
* reduced the default value of irregular density to 2

2018.08.23 01:53 Update 10.4r

* added spaces in sample Archimedean tiling specifications
* added some new Archimedean tilings to the list
* removed the 'L' marker from Fulgur14's snub tiling
* changed the way 'size of the world' is displayed for hyperbolic tilings
* fixed a bug which crashed spherical Archimedean tilings on Windows
* more statistics on Archimedean tilings
* fixed the Land of Power in some geometries

2018.08.24 23:53 Update 10.4s

* previous page button
* another 3666 variant
* pressing Backspace while the Archimedean symbol is already deleted does nothing instead of leaving the menu
* Hypersian Rug mode works with Archimedean tilings

2018.08.31 19:27 Update 10.4t

Bugfixes:
* Camelot a bit more frequent in Crossroads IV
* fixed Crossroads IV appearing inside Mountain (and probably other horocyclic lands)
* space message no longer always appears in shmup
* fixed Orb of the Sword in shmup
* fixed a graphical issue with water next to chasm (the water tile looked as if it was a floor)
* fixed the camera in Mountain

Archimedean tilings/geometry experiments:
* dual and bitruncated versions
* new interesting symmetry variants for 3^7
* fixed some lands in Archimedean tilings
* an option to enable 'chessboard', 'three colors' and 'football' colorings when available
* 'faces per vertex' and 'size of the world' now display correct values in all geometries
* Windy Plains wind bubbles now animate correctly in all geometries

Vector graphics editor:
* fixed floor editing
* more detailed pattern selection in Goldberg/irregular/Archimedean tilings, in the graphics/map editor
* the editor now displays the area of the currently drawn shape
* fixed angle measurement and grid display (it was supposed to measure angles relative to the previous grid center)

2018.09.07 16:19 Update 10.4u

* fixed some glitches in spherical projections

Web demo:
* greatly improved the efficiency
* CUSTOM_CAPTION can be configured (used in pentagonal exploration)
* better text on white background

RogueViz:
* draw legend if there are multiple edge types even if no standard legend is present
* fixed help in RogueViz kohonen
* load/save compressed data in RogueViz kohonen
* vertex search feature in RogueViz
* fixed some bugs with drawing edges
* rogueviz:: greatly improved vertex help
* fixed bugs with white background
* open URLs from Emscripten
* commandline option to rotate
* Pentagonal Exploration added
* fixed some bugs in the RogueViz Presentation

2018.09.10 18:47 Update 10.4v

* animation system
* fixed the animation of snakelike creatures in quotient geometries
* fixed keyboard movement in non-orientable geometries
* fixed the sight range on non-bitruncated tori
* fixed texts disappearing when scale is set to less than 0
* number editor and command line parameters now accept expressions

2018.09.24 00:16 Update 10.4w

* improved understanding of paths and circumferences, in all hyperbolic geometries (except Archimedean)
* * big numbers given by the Knights of Camelot and during the 'game over' screen are now computed precisely even for big radii, and also in more geometries
* * the expansion screen ('size of the world' in geometry experiments) now has many new features
* * the Key to Orb of Yendor can now be generated on any cell in distance 100, not only cells connected with 'bull lines' (key generation was buggy in some geometries)
* * fixed some bugs / improved efficiency of distance computations in some geometries                                                                               
* fixed graphical/movement glitches in the minimal quotient space
* GP(2,1) and similar geometries allowed land boundaries to cross, this is fixed
* parsing expressions allowed for integers too; unary minus is allowed
* command line options -pal and -palrgba now accept the pattern name; -msm and -msmoff to control memory saving mode; -killeach to kill a number of each enemy monster type
* enabled sightrange increase in Archimedean, also translation of sightrange and better note about additional options
* creating [Baby] Tortoises in the map editor now creates 'local' ones at first, and random ones on another click
* when you scroll into a mirror wall, the view is reflected
* if the memory saving and cheat modes are on, translate animation will move the PC together with the view, thus saving memory

2018.10.28 03:09 Update 10.4x

* fixed the crash when starting the Halloween minigame, and also when starting Wild West

Improvements to models/projections of hyperbolic geometry:
* Added Joukowsky transformation and Joukowsky+inversion
* added 'model orientation' parameter for 2D models which have an orientation
* Joukowsky, Joukowsky+inversion, and band model now have 'transition' parameter, to make a transition from a more standard projection (with other interesting projections on the way)
* hemisphere and hyperboloid models are now rendered more nicely (using the same algorithm as is used for the sphere in orthogonal projection)
* fixed darkening of the other side

Other bugfixes and improvements:
* improved line width in SVG output
* commandline option to record animation, new conformal parameters, and outer circle color (-ring), -btwidth, set translation
* improved animation when scaling
* color dialog no longer invisible on white background
* rug no longer always renders in Poincare
* graph drawing in RogueViz
* some extra chars supported in the browser version; some other minor web improvements

2018.11.01 19:09 Update 10.4y

* In the "view range" setting, you can now choose to not draw all cells in the given range, but based on their visibility (i.e., being on screen and not too small). 
  Especially useful with non-azimuthal hyperbolic projections -- e.g. band and halfplane models will automatically adjust to the visible region, instead of drawing tiles
  which are offscreen/too small and/or not drawing other tiles which are far but still well visible.
* various text improvements, and translation update
* link displayed in the model menu
* fixed drawing of the boundary of polygonal
* in svg screenshot, disabled weird recoloring and ringcolor changing

2018.11.11 12:11 Update 10.4z

User interface:
- A new menu where you can customize colors. You can customize colors of most interface elements 
  (background, projection background, projection boundary...) as well as the colors of most
  single-colored game entities (useful e.g. for colorblind players).
- A new simple but powerful approach to animations. Simply set the value of parameter to "0..1"
  and it will animate linearly from 0 to 1. You can also use functions (cos(0..2*pi)), multiple
  steps ("0..1..0") or refer to other parameters (set scale to "(1+projection)/2").
- Player character can be set to be left-handed. Also the Princess is now left-handed.

Projections:
- spiral projection (for hyperbolic and Euclidean geometry)
- 'rotated hyperboles' (2D version of the 3D model used by HyperRogue)
- polynomial model replaced with one where you specify the formula used
- projection-based range now works correctly in Archimedean, binary, and Euclidean tilings
- MÃ¶bius transformations in spiral and Joukowsky projections

Patterns:
- Added seven-coloring in the Euclidean mode. 'Zebra triangles' line pattern used on the torus shows the big triangles.
- line width configurable in line patterns
- added new line patterns: circles, radii, meridians, and parallels

Commandline arguments:
- most important dialogs can be launched from command line
- Previously some arguments used - while some used --; now both forms are accepted for all arguments
- empty arguments are ignored in the web version
- some new arguments for the recently added features

Other:
- made Archimedean tilings more stable
- help for Haunted Woods no longer shows the special conduct as failed when you succeed
- added the sunflower spirals and fundamental domains to RogueViz
- improved SVG output

2018.11.19 20:59 Update 10.5

- Goldberg geometries did not work correctly -- this is fixed
- fixed a crash when jumping on an Orb of Safety
- fixed some bugs related to the shmup mode: no longer crashes in combination with Yendor Challenge; keys are named correctly; fixed the ijkl default keys for the second player;
  fixed some bugs which sometimes caused us to go through walls
- fixed some cases where the record feature would not record anything
- half-plane and band models are now computed on the GPU side (and thus these models are now rendered at high fps -- will be important in the upcoming racing mode) (in 2D only for now)

2018.11.20 17:59 Update 10.5a
- fix a bug with Hypersian Rug rendering

2018.12.11 22:37 Update 10.5b

Bugfixes and minor features:
- you can no longer see mines by changing the color
- mouse now works in the color menu
- numpad now works as directions with numlock off and numbers with numlock on
- fixed crashes when entering some symbols in Archimedean
- surface 3D graphics are now automatically disabled in rug (won't work correctly with quotient rugs anyway) and in pmodels which do not support it
- Hedgehog Warriors are replaced by Fire Cultists in non-3-valent Camelot
- fixed in_smart_range adjusting to the screen resolution rather than the current texture

Geometry experiments -- new quotient spaces:
- "torus/Klein bottle" now includes infinite cylinder and infinite Mobius band
- Macbeath surface, Bring's surface, Schmutz's M(2), Schmutz's M(3)
- "dimensional crystal" -- a surface in e.g. 4-dimensional Euclidean geometry, represented in hyperbolic way

2018-12-12 03:17 Update 10.5c:
- fix crashes related to multi-dimensional
- fix some format incompatibilities in save level feature -- does this fix the problem? (sunflower.lev now loads the map correctly, although some graphics seem to be not rotated correctly)
- fix hives not appearing in the Chaos mode

2018-12-14 18:25 Update 10.5d:
- screenshots are more configurable now
- web:: 'take screenshot' feature now creates a SVG file and opens it in a new window
- added sm::MAYDARK to some dialogs; sidescreen now requires screen ratio strictly greater than 4:3
- svg:: circles now have better linewidth
- web:: SHIFT/CTRL/ALT keys no longer disable menus
- text improvements, PL/CZ translation update
- warnings when hitting an ally; harder to miss now
- warnings when trying to finish a running game

2019-02-08 10.5e:
- This version imports some bugfixes/improvements from 11.0g.

2019-01-11 17:00 Update 11.0:
major new features
- new game mode: Racing Mode
- new land: Irradiated Fields
- new land: Free Fall
- new land: Brown Island

features
- improvements to the map editor: an option to disable wandering monsters; settings (reptilecheat, autocheat, safety etc) configurable; save items/kills and some other settings
- background animations in the start menu; start menu options no longer reset the graphical options -- there is a separate entry for that
- shmup mode can now be paused
- new projections: conical spirals and bands
- graphical display of the paths for Orb of Air; Orb of Air now affects boats, statues, thumpers, and barrels
- added Crystal Camelot achievements
- more natural humanoid movement animation
- 'paint textures' in main menu works better; no more alpha on floors while editing textures; symmetry markers shown correctly again
- when text search in overview matches nothing, it now displays lands not in game
- shift+G cheat screen is now editable
- easier to exit the Tutorial
- improved welcome messages in special modes
- octahedron geometry (good with the Goldberg-Coxeter variation)

minor gameplay changes
- Blue Raiders now can destroy boats
- reduced the range of Fire Cultists to 2 if getDistLimit() < 4
- Orb of Winter now protects your boat from destruction

bugfixes
- fix a crash on OSX after some scenes in the Tutorial
- fixed help in lands
- roar message now uses the correct number of kills instead of 20
- Orb of Empathy works correctly with Orb of the Fish now
- ghosts no longer appear without reason in Crystal and other low-distlimit geometries
- gadfly kills no longer counted twice
- fixes to the screenshot feature
- no more pushing statues on arrow/fire traps

2019-01-17 14:28 Update 11.0a:

Brown Islands:
- elevation shown in the help line
- a description of the elevation mechanics in Brown
- Bronze Bugs are stunned also when pushed into water
- fixed the walls generated by Bronze Beasts outside of Brown Islands
- additional guest orb: Orb of Safety

Free fall:
- a description for Western Hawks
- Orb of Gravity now gives life in shmup (since it does not work)
- trolls (and similar creatures) no longer create walls in Free Fall

Racing fixes:
- disable mouse pointing (scores reset!)
- no more shmup welcome message
- fixed a bug with official races generating incorrectly
- finish message
- fixed not configuring track correctly when started from CLI
- side display
- scores should be updated automatically
- an option of standard_centering
- fixed hotkey clash for 'best scores to show as ghosts' vs 'guiding line'
- race angle now defaults correctly to 90 degrees
- race TPP now adjusts better to the screen aspect ratio
- 'two players' option should work now

Map editor:
- an option to change new canvas cells without clearing the map
- no more crashing on 'c'opying outside of map
- fixed a crash with changing some values in Shift+G
- tortoise flags are now editable with Shift+G and saved into saved levels

Crystal geometry:
- no more ambushes on compasses
- no more compasses in the Minefield
- Emerald Mine now generated randomly
- fixed the achievement descriptions

Other:
- options of TPP and fixed facing direction, not only in racing
- Orb of Lava is now marked 'useless' in Graveyard

2019-01-18 21:14 Update 11.0b:

- number editor now accepts hex numbers, and uses hex as default when editing Tortoises
- fixed crash on changing projection while not in race
- fixed crash when Orb of Safety is blown into the player's position
- text fixes, PL translation updated

2019-01-20 12:47 Update 11.0c:

- baby creators of the Brown Island now mature after going 6 screens away from the place of their spawning (in other words, when you explore the boring (baby) part of the Brown Island, you will get to
the interesting (adult) part quickly)
- no more cheat mode after disabling the Racing mode (this was caused by not resetting the starting land back to Icy)
- Czech translation updated, typos fixed in the Polish translation

2019-01-24 14:15 Version 11.0d:
- fixed time measurement problem in Android (causing the camera to not move smoothly or sometimes even not move at all)
- Android versions updated
- no more Gold in Free Fall Yendor
- fixed Free Fall (and Windy Plains) treasures in shmup mode
- Graveyard no longer can be adjacent to Ruined City
- fixed the issue with Orb of Aether always being marked as used due to Minefield uncovering (now it is only used if it actually prevents some Minefield cells from uncovering)
- fixed Brown Islands crashing in Euclidean (that algorithm does not generate anything interesting in Euclidean though:)
- fixed some issues with commandline arguments (svg shots made correctly now)

2019-01-28 22:32 Version 11.0e:
 - the new lands are now available in the Pure Tactics Mode
 - the "movement compass" config option was not clearly named -- it should be better now
 - spherical geometry no longer crashes
 - Free Fall no longer crashes in Euclidean
 - Crystal Rug no longer displays invisible floors
 - new predesigned pattern where you can give a formula to color cells according to the coordinates
 - map editor save features now saves more data: multiplayer positions, rosewaves, turncount (ocean waves), mutant ivy phase
 - the screen split in multiplayer mode was supposed to happen only in the racing mode -- fixed
 - fixed a crash in the Ivory Tower Yendor Challenge

2019-02-06 22:45 Version 11.0f:
 - redone the 'Experiment with Geometry' menu
 - fixed a bug with pushing thumpers into fire traps
 - fixed inventory mode scores not recognized correctly
 - fixed a freeze in spherical Dungeon
 - fixed incorrect graphics when adding trapdoor in map editor
 - fixed mouse position being interpreted incorrectly in some models
 - fixed the obsolete description of Minefield auto-reveal radius
 - fixed the "no HUD" option in the screenshot menu

2019-02-06 22:45 Version 11.0g:
 - formula pattern works in spherical
 - no more Brown generation in PTM Ocean
 - no more mobile compass by default in mobile

2019-03-01 04:30 Version 11.0h:
- an option to make arrow keys etc. move smoothly (even in the default control system)
- map editor: editable statues (to be drawn with the graphics editor); z-level can now be set for each layer in the graphics editor
- fixed racing in {4,4}
- fixed irregular tilings on quotient spaces; saving non-bitruncated maps
- fixed minemark help
- fixed the graphics scaling for wolves, animated legs, and the shmup mode
- yet more interesting Yendor path in binary tilings
- a preview of 3D geometries

2019-03-01 19:14 Version 11.0i:
- fixed the bug with animal legs
- added two Euclidean honeycombs

2019-03-03 00:51 Version 11.0j:
- improved lands: minefield displays correctly; Emerald Mine in Euclidean geometries; nice crossroads in spherical geometries
- all the regular honeycombs

2018-03-10 19:18 Version 11.0k:
- fixed a glitch with a bodypart taking the whole screen in spherical geometry
- selecting horocyclic lands in standard geometry works
- 'towards Gans' option works again
- added some people to credits
- distance tester added
- improved the Magic Sword graphic, and its tip is now computed correctly when changing geometries
- an option to desaturate colors for anaglyph
- grid color is now configurable
- CLI option -geo recognizes menu_displayed_names
- fixed regrouping dogs disappearing

3D:
- the 't' key now targets the same target as the mouse
- water etc and land barriers are now drawn as transparent walls
- improved which 'circles' are drawn
- Great Walls and horospheres in H3 geometries
- set the S3 parameter in 3D geometries to the smallest loop, so that it tells whether hedgehogs can be killed
- new 3D geometry: 'triangles on horospheres'
- improved sightrange change dialog; in standard mode, monster action depends on whether they are drawn. Automatically adjust monster generation based on the number of generated cells.
- Orb of the Sword and Mirage Clouds work in 3D shmup (Mirrors work too but they start weirdly)
- monsters better at avoiding obstacles in shmup
- two-player 3D works
- orb targetting (in noshmup it already worked, in shmup it works like in 2D)
- help works
- grid drawn correctly
- transformation between Crystal 3D and Cube tiling
- boats are drawn
- parrots and seeps now ignore depth testing
- a 3d image for compasses in the world

11.0l: fixed aura on sphere

2018-03-17 04:20 Version 11.0m:

- floor patterns are now used in 3D geometries as textures
- implemented field quotient spaces for the regular hyperbolic honeycombs. Synchronizing non-quotient regular honeycombs with the field quotient has improved their performance
and led to an implementation of a cool Emerald Mine pattern for 534, and also some Vineyard/Emerald patterns for both 435 and 534.
- implemented two new horospherical honeycombs, based on rectangles and hexagons
- 3D Ocean works (not very fun though), fixed a crash in 3D (e.g. in the Hive)
- borders on fires, limit particles if there are too many fires
- tour:: replaced 'a'+i to allow longer presentations
- fixed the image not appearing in the texture mode
- fixed "dark landscape" etc. patterns
- texture:: aura no longer flickers

2018-03-24 01:53 Version 11.0n:

- fixed the animation of items on boat
- fixed knight cloaks and tortoises
- fixed some instances of friends not being protected from environment with Orb and Empathy, or being protected with Orb but without Empathy
- stunning a ghost no longer also prevents some other ghosts from moving
- improved the naming of models and projections; in general perspective projection, you can now explicitly set inverse Poincare and ortho/Gans

3D:
- models; animations; smart range now work in 3D.
- made 3D a bit easier
- fixed a bug with ice in 534f; also you can now actually melt something
- Ivory Tower in horosphere tilings (and also in regular hyperbolic honeycombs, but better with horospheres)
- Yendorian Forest, interesting (and different) in each available hyperbolic honeycomb

2018-03-24 12:31 Version 11.0o: fixed Ivory/Yendorian

2018-04-05 14:41 Version 11.0p:

Interface:
- major restructuring of the menus
- removed an option "scrolling by orientation" on devices which do not support this (it caused a black screen)

Gameplay:
- Space Rocks, a shmup-exclusive, bounded-exclusive land (based on a well known classic game)
- a special construction of the Minefield in bounded geometries, which is very similar to the original Minesweeper
- Orbs of Yendor can no longer be moved with boats
- fixed Friendly Ivy attacking non-attackable monsters
- removed Witch and Evil Golem from the polymorph list; replaced them with Falling Dog and Mutant
- Orb of Freedom takes Rose scent into account
- a better message on illegal moves in Brown Island
- bulls become enraged when blown with Orb of Air
- Shadows are now immune to Orb of Air

Projections:
- line animation (in the history mode) should now work in all geometries; you can choose game start -> current position or last recenter -> current view; in quotient geometries, the latter option follows the geodesic homotopic with the path taken by the camera, rather than the shortest path
- the spiral projection is renamed to "spiral/ring" and now works in spherical geometry (hint: change wall mode to black and draw the grid)
- an option to display a 3D cut when displaying 4D Crystal in rug mode
- changing the model color had no effect in hypersian rug mode -- this is fixed
- [3D] azimuthal equivolume projection; buggy model boundaries not shown

Other:
- fixed the ESC key flashing and doing nothing in the Expansion slide
- restructured menus
- [3D] more stable PC centering

2018-04-13 13:09 Version 11.0q:

Gameplay:
- using an Orb of Change on a Red Raider now also changes the other Red Raider
- improvements in the bounded Minefield: fixed in spherical geometries; auto-charged teleport; adjacency rule can be changed in geometries with valence > 3; fixed some bugs with more than 7 adjacent mines
- Orb of Phasing is now forbidden in the Princess Challenge
- Narcissist and Mirror Spirit kills are now saved
- fixed incorrect counter values when pushing thumpers into water
- removed Lost Mountain and Brownian Islands from the chaos mode overview
- fixed fire in Brown Islands
- some flavor messages no longer display in special modes if they are inappropriate for them

Geometries:
- in Euclidean 3D modes, lands such as Crossroads and Camelot are now generated just like in Crystal (transformation works correctly)
- fixed a crash bug when switching places in some geometries
- fixed the wrong code for {4,3,4}
- the option to restrict generation in 3D no longer produces weird elements
- fixed wrong texturing in hororec
- distance calculated correctly in Rhombic
- fixed some Archimedean geometries freezing
- fixed invalid bitruncation in torus geometries

Creative/3D:
- horosphere tilings now save/load correctly
- vector graphics editor improved in 3D: display all coordinates; level changing; 3D models are now shaded; edited items do not disappear
- single-type textures now can be remapped to 3D geometries
- in some situations texture was lost when starting a new game while it should not
- formula editor: comma can now actually be entered; 'shot' parameter to change shots

2018-04-29 20:13 Version 11.0r:

Game:
- disabled scrolling in Haunted Woods
- Zebra valid in Zebra quotient; Minefield and Kraken Depths no longer valid in Strange Challenge in bounded geometries
- Orb of Winter no longer marked as useless in Volcanic Wasteland
- no more complaining when trying to save the game on your first run
- fixed a bug with incorrect number of lives when loading game in the shmup mode
- fixed backward incompatibility when loading polygons via MapEditor
- fixed the Orb of the Warp effect (destroyed while refactoring)

Archimedean:
- increased the limit from 14 to 18
- slower heat transfer
- fixed potential incorrect computation of default ranges

3D:
- monsters now use 3D models (based on the 2D models) and are now facing correctly
- 3D tori and some twisted versions (see 'advanced parameters')
- in third person perspective, the camera distance is now automatically reduced if there is a wall on the way
- removed transparency from monsters in 3D
- fixed shots (shmup mode) not being displayed at their actual locations
- rebalanced Space Rocks in 3D

RogueViz:
- CLI option -collatz-go
- fat_edges
- rainbow color specification
- fixed label positioning in 3D
- 3D trees in Collatz
- Flocking in 3D, more CLI parameters (check_range, flock shape), multithread support, do not try large steps even if delta way too big

2018-04-29 20:13 Version 11.0s:

- 3D fixes: fixed a crash; correct camera distance reduction in horosphere tilings; fixed PL/CZ translations

2019-05-10 03:26 Version 11.0t:
- fixed the binary tiling
- fixed Mutant Ivies appearing via Orb of Change
- redone gravity in shmup
- cell cursors are now prisms, not circles or stars
- enabled antialiasing in the browser version
- fixed the sky display in Yendorian
- a setting to configure the smoothness of binary tiling (also quality of 3D textures)
- in the Hypersian Rug mode, changing parameters live now works better

3D:
- the 3D engine now can be enabled for 2D geometries, for a nice first-person perspective view (3d settings -> FPP)
- seeps visible through walls, no junk in Jelly Kingdom
- a setting which prevents the walls from appearing out of nothing
- fixed sphere in native perspective

2019-05-10 11:51 Version 11.0u:
- fixed Ocean/Red Rock

2019-05-13 16:02 Version 11.0v:
- push cursor did not appear in the hardcore mode or while having targettable orbs

2.5D/3D improvements:
- 3D model improvements: monster eyes, humanoid eyes (with configurable color for the player), 
  armor shape, humanoid model, disabled the Thumper animation, Orb visual effects, ratling model, smaller cones for
  slimes, (in 2.5D) armor displayed as headgear, added shadows, fires/bonfires/buoys/thumpers, humanoid leg movement, 
  skeletal feet, Orb of the Sword markers
- transparency now works better (Hall of Mirrors in 2.5D, non-perspective models in 3D)
- Hypersian Rug is no longer available in 2.5D/3D
- item/monster icons in HUD
- fixed racing
- fixed items being hidden incorrectly
- [2.5D] ASCII minimap replaces radar!
- [2.5D] gravity rotation
- [2.5D] fixed Space Rocks: fixed movement direction, space rocks no longer try to 'randomly spin' into space
- [2.5D] no more incorrect mirror markers
- [2.5D] better view range in quotient spaces; things no longer get off into space in quotient geometries
- [2.5D] fixed in Euclidean
- [3D] engine optimizations: do not draw back walls, do not draw walls outside of the view (default view range increased), an option to limit cell generation
- [3D] fixed transparent walls between lands
- [3D] using models not walls for worms

2019-05-15 17:49 Version 11.0w:

Gameplay:
- Thumpers activated by Bulls are no longer permanent
- Terracotta Warrior statues flashed or shocked now count as kills; Terracotta Warriors now display time; Terracotta Warriors now turn into slimes when slimed
- fixed the Burial Grounds unlock rule
- fixed the menu option 'help for keyboard users' doing nothing
- fixed some issues with the per-frame limit on cell generation (in 3D/smart generation modes)
- monster orientation is now fully modelled in non-orientable geometries
- selecting a (horo)cyclic/equidistant-based land in the Experiments in Geometry while in standard geometry works now

2.5D/3D preview:
- fixed in 2.5D: irregular tilings, Goldberg tilings, Euclidean Archimedean tilings, and elliptic plane
- better minimap in Euclidean, spherical, and 3D geometries
- items shown on the radar even if user-shaped or hidden
- shadows no longer flicker
- Orb of Gravity and Orb of Lightning particles
- fixed the z-ordering in spherical geometry
- disabled the optimization in spherical geometry (we may see things behind us)
- items are now a bit larger
- improvements to the 3D modeller: correct placement, quicker editing, color changing works now, ways to place new points in 3D more intelligently; you cannot edit floors, so 'pick something' is displayed when you try

2019-05-16 03:22 Version 11.0x:
- using Orb of Safety marked you as cheater

2019-05-16 18:03 Version 11.0y:
 - improved 3D models: Bull horns, Cat head, anything which had holes at its ends, Butterfly (previously crashed the game), animation for all winged creatures (previously only Eagle model had animation), 
   leg movement animation for quadrupeds; also the stun stars are drawn now

2019-05-30 18:30 Version 11.0z:
 - fixed: selecting some lands in Experiments with Geometry caused incorrect generation
 - fixed the monster list of the Ruined City
 - fixed the way HyperRogue saves floating point numbers in text format on Windows (previously files generated with Vector Graphics Editor or Paper Model Creator could save incorrectly)
 - also improved the way HyperRogue displays numbers, and the slider for editing integers looks different; fixed the growth ratio display on Windows
 - Orb of Recall now recalls you to your old rotation/orientation
 - larger sightrange limit in Euclidean
 - improved the sword angle handling in non-standard geometries
 - no more Orbs of the Bull in Prairie in the Orb Strategy Mode
 - fixed drawing the net in the paper model creator

 - new special game mode preview: 
   - dual geometry mode [not yet working in non-shmup 3D]
   - submodes of the Chaos mode
   - frictionless track in the racing mode (Space Rocks)
 
 - 2.5D preview: 
   - improved Vineyard half-walls, item colors in the Minimap, Rose Garden (scent waves and Thornless Roses were not visible)
   - added ceilings and skies (the elusive "hyperbolic sun" got an official interpretation!)
   - third person perspective key ('3') now works
   - improved ASCII mini-map: gridlines, no more double drawing of items, mini-map correct in all circumstances, including vertical movement or y/z rotation
   - fixed a crash in Euclidean when changing camera level
   - auto-adjust in switch_fpp
 
 - 3D/2.5D preview:
   - racing:: progress bar live in 3D
   - 3D:: fixed a crash on drawing Hyperbugs
   - improved models: Ratlings, hypersian rugs, Giant Rug

2019:06:03 22:31 Version 11.0Å¼:
- fixed a crash bug when drawing weird shapes on OSX
- fixed Thornless Roses not appearing / appearing incorrectly / crashing the game
- fixed ambushes and Hunting Ground treasure generation in non-three-valent geometries
- Rosebush scent waves are now more visible outside of the Rose Garden
- fixed bugs with the Prairie in the total chaos mode; also more roses
- speedometer in the racing mode
- fixed some hotkey clashes in the menus (animations, 3D settings)
- gfx: flattened reptiles on non-standard tilings

2.5D/3D:
- better sky, sky color variation
- fixed a crash in Terracotta Army
- striped dogs model
- adjusted some dialog help texts
- an option to configure the eye level
- dual geometry mode: moved the Land of Power to the hyperbolic world

2019-06-13 18:28 Version 11.0Åº:
- improved memory handling
- fixed the PTM version of Brown Islands
- Orb of Matter no longer 'works' in the Free Fall
- fixed the depth testing in Hypersian Rug
- fixed a crash in draw editor
- fixed the multiplayer mode (it was not possible to enable or configure it)
- fixed the Clearing
- fixed a crash when using formula pattern in spherical geometry

2.5D/3D:
- fixed the worm shadows
- fixed a crashbug related to sky
- better sky in Irradiated Fields; brighter land in Hell, Alchemist Lab, and Irradiated Fields
- fixed dog stripes
- fixed a bug with the history animation
- improved rotation config
- when you start or press Space, the view direction defaults to horizontal
- [full 3D] the extra knives given by Orbs now fly in different directions (rather than flying in the same direction but rotated)
- fixed the orb display in Orb Strategy Mode
- fog color is now the same as the background color instead of always black
- shading of all humanoid models

2019-06-18 15:29 Version 11.1:
- added Orbs of Safety in the Ocean and in geometries which drain memory quickly
- reduced Trollheim/Hive generation in new submodes of Chaos
- Chaos Mode + Orb Strategy Mode combination: you get Orbs earlier, and standard unlock rules are used
- ASCII mode: fixed monster coloring, compasses, grid in Hall of Mirrors, better warped/normal border
- improved line animation/recording
- Crossroads IV achievement should be fixed
- fixed a possible crash while changing graphics settings
- eyecolor saved
- one princess enough for gold
- translations updated

2.5D/3D:
- eyes on warrior statues
- CLI option: -tstep
- fixed some shapes in 3D (like Mine Mark)
- fixed the Z-placement of the Tentacle tail, and worm shadows
- fixed the HUD icons of monsters
- better sky for R'Lyeh, Temple, and Ruined City
- arrows from arrow traps now visible in 3D
- humanoids were not shaded
- fixed the loss of texture happening sometimes on changing modes or the 'wall quality'
- improved memory management
- reduced the number of bird animation frames to save memory
- fixed a bug where changing wall quality sometimes caused the textures to disappear
- fixed a possible crash bug, and made the game use less memory for geometry cache

2019-06-25 18:39 Version 11.1a:

Dual Geometry mode:
- fixed the Land of Storms not working correctly in dual geometry mode
- added a message when trying to perform an impossible skip-turn
- now works in (non-shmup) 3D geometries

Other:
- fixed a crash bug with Bulls pushing things offscreen
- controller dead zones are now configured via number dialog

2.5D/3D:
- fixed the monster color in the minimap for Dragons etc
- stereo mode: fixed incorrectly using Euclidean eye positioning; a bug with texturing; and issues with the sky
- fixed panning in the shmup mode (Up/Down did weird thing and Left/Right did reverse thing)
- up direction now remains fixed while scrolling
- added a separate option for highlighting the forward cell
- Orb of the Sword now works in 3D geometries (non-shmup)
- Terracotta Army: fixed incorrect bridges on mercury rivers and sky over them, fixed the vertical placement of Jiangshi
- shadow of the player character is always shown
- improved Tortoise graphics in 3D, Baby Tortoises appear
- camera level higher when riding dragon
- keyboard/controller movement works better now in 2.5D; improved controller camera control

2019-06-28 13:49 Version 11.1b:
- you can now move in 2.5D and 3D with mouseclick/touchscreen
- 2.5D/3D/VR in the mobile versions

2019-06-28 13:49 Version 11.1c:

- long touch to wait in 3D geometries

2019-07-03 08:10 Version 11.1d:

- fixed a bug with the incorrect starting tile in Euclidean Crossroads
- fixed the OpenGL off mode, also should now work in OpenGL 1.0 on Windows (not all features)
- onscreen keyboard in edit dialogs (crucial in mobile, also useful in general)
- animation which combines translation and rotation
- linepatterns now can have their widths set individually
- fixed the black screen when resetting stereo modes in 3D
- new projection: central inversion (for Euclidean geometry)
- easier to edit IPD with mouse

2019-07-28 12:30 Version 11.1e:

Gameplay
* unlocking Irradiated Fields no longer requires 60 treasure
* disabled cyclic lands in the list in Euclidean/Sol
* ambush restriction no longer considers friendly, slow, or multi-tile monsters
* allies now prefer escaping unsafe locations to attacking
* allies did not avoid 1-stunned lancers
* fixed allies evading Demons incorrectly

Graphics
* fixed snakes in Archimedean
* floor textures now work with >8 sides
* creature_scale can now be changed in all geometries except standard non-cheater shmup
* specific linewidth configurable for grid and model boundary
* CLI arguments: -grotate, -twopoint, -animclear

Geometries and projections
* standard binary tiling
* kite-and-dart tiling
* kite-and-dart tiling on horospheres
* Solv geometry
* extra two-point projections

2019-07-30 13:54 Version 11.1f:

General:
- fixed prairie in chaos mode (hopefully)
- fixed crash on displaying Rugs in inventory in 3D geometries
- shmup: fixed a bug with recall+safety
- shmup: collect items when bumping into them in a boat
- fixed incorrect pushing in some geometries (also caused crash when next to Thumper in Solv)

Solv geometry:
- an improved renderer with better and configurable sight range
- fixed crashes in some lands in Solv
- crossed out Elemental Planes
- special Vineyard
- fixed minemarks obscuring the view
- when you scroll, cells are generated on the way, and the matrix is no longer destroyed

2019-07-31 17:35 Version 11.1g:

- memory warnings appearing incorrectly should be fixed
- shmup: fixed Dragons/Knight/Flailguard bullets flying in wrong directions in 3D
- shmup now compatible with Solv
- fixed some key conflicts in 3D menu
- optimized graphics in Solv, also reduced the default range
- fixed a bug with sandworms exploding in 3D (when leaving the generated part of the world)
- radar range in 3D geometries and Euclidean 2D FPP is now configurable

2019-08-03 11:50 Version 11.1h:

- Geodesic movement in Solv did not work correctly, this is now fixed.
- fixed the Racing mode to work correctly in Euclidean Archimedean, kite-and-dart (both 2D and 3D), standard binary, and Solv.
- fixed the Orb of Yendor to correctly generate the path in Euclidean Archimedean, kite-and-dart, and Solv. (Solv worked, but is more interesting now.)
- third person perspective now works correctly in Solv.
- Graveyard and Emerald Mine are now nice in Solv
- removed Land of Storms, Warped Coast, and Camelot from full games in 3D geometries
- fixed a crash when generating Rose Garden in 3D geometries
- fixed the landscape generation discrepancy in the racing mode (affected ghosts in Dragon, Ruined City, and Crossroads)
- fixed loading maps in the map editor

2019-08-08 00:35 Version 11.1i:
- fixed desynchronization in racing Crossroads and Ruined City
- Nil geometry (another nonisotropic geometry)
- the radar now displays a compass in Nil and Sol
- fixed a memory leak when taking postprocessed screenshots
- Reptiles no longer appear in full game in Sol
- reduced the frequency of Seeps/Parrots/VineSpirits in 3D modes
- shmup mode no longer ignores frame limit (just sets it to at least 30)
- fixed Chaos mode in Sol
- fixed the 'targeted cell' in nonisotropic geometries
- fixed the rotation in the orthogonal projection of model in nonisotropic geometries
- fixed shmup not working correctly in the non-geodesic mode in nonisotropic geometries
- disabled heptagon markers blocking the view in 3D geometries
- improved Red Rock and other heights display in 3D geometries

2019-08-10 22:41 Version 11.1j:
- fixed Racing desync in Crossroads
- the life limit in the shmup mode is working again (it was to be removed in the Orb Strategy mode but it was removed altogether)
- items now correctly face the player in nonisotropic geometries
- ability to write a debug log file
- cleanup of the source code, and started improving the documentation [ http://www.roguetemple.com/z/hyper/doc/ ]
- fixed UI elements crashing into each other in some resolutions in the Vector Graphics editor
- in Vector Graphics editor in nonisotropic geometries, you can now draw geodesic spheres and constant X/Y/Z surfaces, and put points on them (the 'z' key)
- furthermore, the coordinates are displayed correctly in model and geodesic spherical

2019-08-14 21:12 Version 11.1k:
- fixed a bug with Archimedean hyperbolic tilings
- added new (pseudo)cylindrical projections: Mollweide, Collignon, central cylindrical; also pseudocylindrical projections work better now
- azimuthal equidistant projection is now available in nonisotropic geometries
- split the projection screen into two
- disabled clipping test in simple perspective in sol
- fixed 'individual width' option in line pattern working incorrectly, and displayed incorrectly when editing
- fixed a bug in approximate distance calculation (which caused the 'X' mark in Caribbean to be shown incorrectly)

2019-08-19 15:48 Version 11.1l:
- product geometries (select any non-Euclidean 2D geometry, then select "current x E" in experiments -> 3 dimensions)
- mousewheel worked incorrectly in nonisotropic spaces
- no more crash when saving config in Archimedean
- better projection boundaries
- fixed a crash in pure {4,4}
- CLI arguments for creaturescale and character selection

2019-08-19 15:48 Version 11.1m:
- fixed the bug with black creatures in 3D
- fixes for the product spaces:
- - product game stats are not saved (previously they could be confused with non-product game stats)
- - fixed crashes when drawing stuff in S2xE
- - fixed 3D models' arms (incorrect altitude) and armor (random errors)
- - third-person perspective

2019-08-21 07:38 Version 11.1n:
- optimized H2xR
- fixed crashes in H2xR land generation
- fixed fullscreen "flashes" in product geometries

2019-08-27 22:45 Version 11.1o:
- rotation spaces
- simpler honeycomb in Nil
- pointing-to-directions now checks for the cell which is the most towards the given direction
- fixed a crash when switching Archimedean modes
- welcome messages for the new geometries
- starting in Crossroads II now works in hybrid
- product:: fixed backwall optimization in TPP view and legs
- shmup:: fixed the keyboard rotation direction inconsistency in 3D
- shmup for product: player movement

2019-09-10 09:15 Version 11.1p:
- smoother coloring pattern in Crystal
- fixed some minor glitches in SL2
- fixed the glitches in S2xE
- an option to show the underlying geometry in rotation spaces
- an option to display a crosshair in the center of the screen
- fixed the determining of the selected cell in product/rotation geometries
- a quicker and more convenient way to recompile the source code after changes (see mymake.cpp)

2019-09-14 ??:?? Version 11.2:
- released 11.2 : https://zenorogue.itch.io/hyperrogue/devlog/99827/hyperrogue-112-thurston-geometries-free-update

2019-09-28 09:15 Version 11.2a:
- racing mode: 
- - Racing now works in bounded geometries and all Thurston geometries
- - fixed a bug with going through walls (also in shmup)
- - racing and Thurston racing added as possible random options in the start menu
- gameplay:
- - fixed being able to phase into a chasm (and possibly some other issues)
- - fixed accessing Emerald Mines from Irradiated even though it was not unlocked
- - fixed nativity marking for Elementals in Elemental Planes and seeps in the Emerald Mine
- - marked the Orb of Water as useless in Free Fall
- graphics/sound:
- - fixed a glitch with Reptile graphics in 3D
- - fixed the pit walls in Halloween
- - better rendering of Solv into the glitchy region
- - stop disabling music in the mercury river
- - correct binocular vision in 3D geometries (isotropic only for now)
- fixed the standard binary tiling
- no more orb usage after death in the shmup mode

2019-09-30 01:46 Version 11.2b:
- fixed a bug in the shmup mode
- fixed a potential bug in precision
- fixed Orb of Air usable on Friendly Ivy

2019-10-05 17:36 Version 11.2c:
- gameplay:
- - fixed wrong display of prize Orb spawn rates
- - when cleaning up the area (e.g. during Recall) boats remain boats, and ladders are not cleared (also fixed another potential source of blue floor in Brownian on recall)
- - fixed an exploit in Orb Strategy Mode (a trick to gain extra Golems)
- - old Strange Challenges now can be played unofficially
- - fire in Brownian no longer generates blue floor
- - in randomwalk/total chaos modes, special graphics are no longer used for Warped Coast
- - free Orbs of Safety in the Land of Eternal Motion in Orb Strategy Chaos Mode (combo)
- - Orb of Fish is no longer marked useless in Warped Coast/Sea, Cocytus, Brown Islands, and Irradiated Fields
- geometries and projections:
- - ternary tiling
- - stretched hyperbolic and stretched Solv geometry
- - fixed a possible crash in Archimedean geometries
- - less aggressive backwall optimization in Solv
- - fixed incorrect distance shown in Nil (e.g. racing)
- - improved fisheye projection: aura, parameter can be changed
- - ball model and fisheye are now available in nonisotropic geometries
- racing mode:
- - in 3D, you now reflect off blocking walls
- - fixed a bug which could cause the player to sometimes get stuck in a wall
- - wall sliding in 3D (glitchy graphics though)
- - fixed the Crossroads in some geometries

2019-10-06 12:09 Version 11.2d:
- fixed "look through wall" glitches in 3D shmup (by preventing the player from getting too close to wall)
- fixed bugs in Nil
- fixed spherical racing not enabling correctly
- 'patterns' in 3D geometries now actually work, by creating walls
- random landscapes now work (by projection) in hybrid geometries

2019-10-12 14:02 Version 11.2e:
- tessellations with ideal vertices: {3,infinity} {3,3,6}, {3,4,4}
- four-dimensional crystal using {3,4,4}
- some patterns for the four-dimensional crystal
- increased the default per-frame cell generation limit to 250

2019-10-26 15:35 Version 11.2f:

Gameplay:
- fixed Orb of Speed saving on the first move
- warning on entering pits
- fixed incorrect mouse interpretation in spherical ortho

Geometries:
- rendering walls in 3D geometries using a ray-based renderer -- this is configured in 3D settings. Great at rendering quotient spaces at large distances as well as weird geodesics in
  nonisotropic geometries. While less practical for standard HyperRogue, works great in racing. Currently implemented for Euclidean, regular (i.e., not horospherical) hyperbolic, 
  standard Solv, and Nil.
- added some patterns to Nil and Crystal
- optimize racing mode
- quotient spaces using Nil geometry (select Nil then advanced configuration)

Other:
- fixed empty config files incorrectly loaded

2019-10-27 02:48 Version 11.2g:
- fixed worm/tentacle movement
- prevented Gadflies, Hunting Dogs, Vine Beasts, and messenger Gulls from appearing after using Orb of Safety
- Thumpers now attract monsters with special movement rules
- fixed boat graphics
- ray: configurable reflective walls; fixed Euclidean bitruncated honeycomb
- fixed the crashes on generation of 3D elliptic spaces and 3D Crystal
- fixed confusion when moving through 3D elliptic spaces

2019-11-02 22:44 Version 11.2h:
- underlying space view is now available in product space
- raycasting: product spaces, stretched spaces, horospherical honeycombs
- bugfixes in periodic Nil
- alternate 3D races (periodic spaces, etc.)

2019-11-03 14:46 Version 11.2i:
- fixed unfilled shapes when rendering S2xE
- removed outlines from falling stuff
- fixed some issues with preventing Orbs of Yendor from boat moving: 'locked with powerful magic' message spam; no longer movable through land with OoWater; you can jump out of an OoY boat using OoFish/OoAether/OoGravity
- hell unlock message on 10th shard
- levellines feature: shade rendered output by Z coordinate (nice in Hypersian Rug mode)
- fixed the overlay in the texture mode (also disabled in ray -- not implemented)
- fixed the rug becoming black on some computers when resizing window or during the start animation

2019-11-15 14:25 Version 11.2j:
- gameplay:
- - fixed the bug in the Prairie which caused the Bulls not to attack correctly (in particular, they would not hit Gadflies or kill the hardcore player, or be blocked by Thumpers)
- - fixed the Haunted Woods unlock in Orb Strategy Mode
- - fixed a potential crash when generating horocycles

- shmup gameplay:
- - sharks on dry land now die/transform
- - Butterflies are no longer killable with standard knives
- - hopefully fixed some crashes (esp. in the inventory mode)
  
- graphics:
- - rewritten some old routines to a simpler, more general form
- - 'reset view' feature now always causes the player character to face upwards (in 2D, changeable with 'fixed facing' feature) or front (in 3D)
- - Crosses in the Graveyard are now arranged in a symmetric pattern
- - Orb of Recall now recalls the original orientation
- - fixed the 'dual grid' pattern
- - fixed the walls in ternary tiling
  
- geometries/projections:
- - new geometry: Arnold's Cat Mapping Torus
- - new geometry: wrapped product geometries (... x S1, see advanced config of product geometry)
- - new projection: horocyclic coordinates model
- - formula pattern: extra parameters available, choose walls in 3D geometries, read colors from texture (undocumented)
- - fixed simple perspective and Poincare ball in nonisotropic geometries
- - ray: fixed left/arrow keys doing nothing when editing exp range; hard limit feature
- - level lines: do not use levellines for the underlying map in Rug

- other:
- - command-line option to disable music

2019-11-16 03:08 Version 11.2k:
- stereo in ray
- fixed the graphics getting glitchy after some distance
- fixed the clipping in Poincare Ball model
- fixed the 4D Crystal in H3 geometry
- ray configuration saved
- random in expression parser; 'draw inner walls in pattern' setting
- fixed the confusion when picking up Orb of Speed while having one

2019-11-23 23:47 Version 11.2l:
- Gameplay:
- - Orb of Choice is now considered useless in Land of Motion
- - fixed a bug where disabling the cheat mode while the land is changed in Geometry Experiments would produce weird lands
- - fixed birds not approaching the player in boats when shielded (and similar cases)
- - fixed generating wandering monsters on the player in small geometries
- - removed a Ruby in Free Fall (some leftover from debugging)

- Geometries:
- - fixed the field quotient advanced config not working correctly when switching the base geometry
- - generalized the field quotient advanced config to generate a bit more manifolds (the new ones are small, and include Bring's Surface, Klein Quartic, and some I do not recognize)
- - animated Friendly Ivy growth
- - more careful handling of small quotient spaces (one-tile-wide torus is now possible)
- - in quotient geometries, the camera will now track the specific preimage of the player
- - alternative honeycomb in Nil (see advanced parameters -- not working in ray yet)
- - map editor: should now correctly save product/rotspace maps, binary width setting, and other geometry settings

2019-11-30 18:37 Version 11.2m aka 'Back to Euclidean':
- Gameplay:
- - RPM and OSM are no longer considered incompatible
- - Allies are now immune to friendly Beauty.
- - Hyperstone-optional lands are now clearly marked in the Overview
- - buffed up the Orb of Intensity in OSM
- - fixed the displayed Gold requirement for the Dead Caves in OSM
- - on-petrify crash should be fixed
- - fixed Tentacle riding

- Geometries:
- - made the geometry selection more intuitive: "tiling" lets you select the tiling, while "quotient" lets you select one of the quotient spaces available in the current tiling (there is also a list of interesting quotient spaces)
- - fixed the crash when trying the Goldberg-Coxeter construction
- - Euclidean hex/square tilings rewritten. This simplifies the code by removing special cases (they were previously implemented in a different way from everything else). As a result, bitruncation, irregular, and product spaces now work.
- - Product spaces now support rotation and reflection.
- - third-turn space is now available in Euclidean 3D geometries
- - spiral projection and rug now automatically adjust if the Euclidean view is rotated
- - fixed the highlights in variation menu
- - when defining Euclidean quotient space, the fundamental domain is shown
- - in the Archimedean menu, filtering by geometry is available
- - {3,12} base available for the field quotient
- - the Hunting Grounds and Galapagos are now optional in Euclidean

2019-12-06 14:09 Version 11.2n:
- subtler default out-of-range color in raycasting
- added fractal landscapes to more lands in SC
- map editor: when using a larger edit range, cursors are drawn on every affected cell
- various markers are now drawn on all copies in quotient geometries
- fixed cell selection in some geometries
- the cells in front of you is now shown by default in 3D geometries (in non-shmup)
- product geometries are now drawn in a more robust way
- correctly display/rotate the PC in product geometries
- fixed distance computation in SL2 (racing works again)
- reduced the number of cells generated in 3D racing
- bug fixed: incorrect renderer was used when switching from S2xE to H2xE

2019-12-08 19:41 Version 11.2o:
- some of the flashes in the Hunting Grounds were missing -- fixed
- fixed the bug with Land of Storms
- irregular maps created for tori can now be used on covers (larger maps)
- fixed facing in 3D Euclidean   
- alternative vector graphics styles (see the 'line width' setting in graphics)
- improved CA simulator (Moore neighborhoods, works with the new geometries with large numbers of adjacent cells)

2019-12-27 12:43 Version 11.2p aka 'the Happy Woodcutter': 

Gameplay and interface:
- fixed turn-based multiplayer
- Mutant Ivy in the Clearing now regrows even if it is offscreen
- floating bubbles are now shown when fighting Ivy/Demons or collecting treasures
- the (approximate) number of Mutant Ivy leaves killed is now computed (do not worry, these 125986129812649812649531688516982685965129215 leaves you have cut will regrow quickly)
- the tree walls of the Clearing are strengthened (no more Ivies and Trolls cross them)
- improved (old style) joystick handling: the input is smoothened for more accuracy; if you move a stick then press a button to move, you will no longer move again when the stick moves back to neutral position
- fixed the line animation (the screen no longer jumps during the animation; the history/spiral is now rendered correctly; long bands are now rendered correctly when using band GLSL shader or when the model orientation is changed)
- in the start screen, random animation is named, random option is stated, and one extra random animation

Geometries:
- a conformal mapping is now used when doing Hypersian Rug in a torus
- adjacency rule now affects not only the Minefield and CA but various kinds of environmental effects (slime spill, electrical conductivity, heat conductivity, fire spread, livingwall CA)
- improved bitruncated {4,4}: fixed distance and coordinate calculation, simpler floor in gravity lands (number of cells in distance and Free Fall work now)
- a new 'geometry' which loads arbitrary tessellations defined in files (currently only for 2D geometries)
- auto-rotation (in gravity lands etc.) now works better, and it works in Euclidean
- a new geometry: {4,oo}
- performing product on Catalan tilings no longer forgets about the 'dual' variation
- fixed some incorrect/irrelevant information displayed in 'geometry experiment' menu
- when in Euclidean geometries, keys 123 now automatically adjust the scale
- fixed straight lines that were too long being displayed as straight lines (even if not in Klein model); also improved the precision of the long grid lines
- land distance shows the correct values in equidistant-based lands in Euclidean

2019-12-27 23:06 Version 11.2q:

- fixed the Yendor Challenge based on the Orb of Recall
- fixed the plain graphics for {4,oo}
- added/fixed/improved some sample TES files
- tessellations from file: 
- - command "conway" (Conway notation)
- - command "unittile" (like "tile" but all lengths equal 1)
- - commands "grave", "line" (specify patterns for Graveyard/Vineyard/etc)
- - commands "subline", "sublines" (extra lines that can be shown using patterns->linepatterns)
- - fixed reloading
- - fixed a possible crash on loading

2020-01-02 18:57 Version 11.2r:

- fixed the incorrect negative digits displayed in Clearing help
- geometries:
- - hyperbolic honeycombs {5,3,5} and {5,3,6}
- - six-dimensional Crystal in {5,3,4} 
- - Crystal now can be a d-dimensional torus
- - the 'underlying tree' linepattern did not work correctly e.g. in pure {5,4}
- - linepattern colors and multipliers are now saved when saving the configuration
- - long grid/linepattern lines can now have variable onscreen width (i.e. wider closer to the center of the Poincare model)
- tessellations from file:
- - fixed mirrors
- - 'nonorientable' tiles
- - sublines now optionally accepts epsilon, and also fixes a bug where it expected an integers
- - updated tes files

2020-01-06 22:04 Version 11.2s:

- Steam rich presence
- geometries: quotient space in {5,3,5}; single-cell quotient spaces in {5,3,3} and {5,3,5}; fixed spherical tessellations from files; extra tessellation files

2020-01-16 17:25 Version 11.2t:
- Field Quotient is now available for all regular hyperbolic honeycombs, and additional field-quotient compact manifolds may be searched for
- new patterns 'Y' and 'Z' for bounded spaces
- in 3D Racing, there is a menu option for 'show 3D configuration' instead of the confusing 'config projection'
- improved Solv rendering
- fixed some bugs with tessellations from files (fixed line animation, fixed bad performance when away from the start, dealt with numerical errors, fixed spherical plain floors)
- paper model creator now available in OSX

2020-01-19 00:16 Version 11.2u:
- raised the limit on the number of edges to 120
- extended 'linewidth' settings: illustration mode, hint about Alt, disable shadows, bright mode, colorblind simulation
- fixed the direction reflected monsters face in the Hall of Mirrors
- mixed infinite order

2020-01-28 19:48 Update 11.2v:
- added dual geometry puzzle generator
- added a comma in shmup help text
- Temple rings are now displayed in the mouseover text
- in the patterns menu (in map editor), you can now set the default wall type
- Camelot no longer generates trivially in {even,x} tessellations
- added {4,3,6} honeycomb
- Compact hyperbolic honeycombs are now implemented using canonical paths. Improved CPU/RAM efficiency and reliability. (Horo)cyclic lands (e.g. Camelot) work correctly now. Also improved Graveyard and Zebra.
- underlying/horocycle tree patterns now can display fat edges in 3D geometries

2020-01-29 19:27 Update 11.2w:
- optimized generation of compact hyperbolic honeycomb
- improved Temple of Cthulhu in 535 and 435
- fixed dual geometry sync destroyed when pressing Space

2020-02-08 10:46 Update 11.2x:
- ASCII/3D mode; neon settings better with border changed
- no timer ghosts in dual geometry puzzle
- in dual geometry mode, when one side is Euclidean, only the other one rotates
- fixed crashes in some geometries (S^3, horospherical hyperbolic, rotation space) and missing tiles in H2xE rendering
- correct centering in raycaster
- while in cheatmode, centering lets you center in cardinal directions
- fixed a crash when displaying inventory with OpenGL off
- nicer side plain walls in binary tiling

2020-03-07 04:42 Update 11.3:
- new lands: Frog Park, Eclectic City, Wetland
- new implementation of the checkmate rule
- beefed up Orb of Empathy: it now also protects your allies from your indirect attacks
- fixed several bugs when going too far into the Clearing; an achievement for destroying lots of leaves
- on-activation effect for Orb of Digging in OSM
- all chaos modes can now be used for achievements
- special map generation when going too many steps from the starting point
- named Knights
- bugfix: worms now generate land if they wander through not-yet-generated 
- bugfix: fixed a crash when not using OpenGL (again)
- bugfix: fixed pointing at cells in Solv
- bugfix: fixed native monster information for Ocean
- bugfix: fixed allies handling Demons incorrectly

2020-03-08 01:29 Bugfix update 11.3a:

- fixed counting kills (for the purpose of Master of Melee achievement etc.)
- fixed some typos
- fixed Red Raiders killed incorrectly
- Frog Park is now disabled in shmup
- fixed Swords moving randomly when having Orb of the Frog
- moved Rose Garden back to being unlocked at R90
- fixed Orb of Impact stunning things while using the mouse
- Warp Gates are now untouchable by Orb of Chaos
- fixed land parameter switching by Orb of Chaos (e.g. in the gravity lands)
- fixed pushing in shmups
- optimized drawing side walls
- main menu cancels visualizations enabled from the quit screen
- fixed centering lost after Eternal Motion in shmup
- fixed centering disabled after Orb of Safety in shmup

2020-03-11 11:34 Bugfix update 11.3b:

- Thumpers are now still considered when one cell outside the game range
- fixed Wild West
- fixed Orb of Chaos in Terracotta Army
- you can no longer try to change the adjacency rule in infinite-order tilings
- fixed Dragon kills counting as double
- fixed a crash in some tilings when drawing plain sidewalls
- clear memory error in wfc
- fixed typo
- fixed music in Frog Park
- fixed a problem in irregular tiling (?)

2020-03-12 10:32 Bugfix update 11.3c:

- Frogs are not generated until you are in Frog Park or have treasure
- Frog Park longer can be generated adjacent to Land of Motion
- Orb of Safety is now marked dangerous in Wetland
- Orb of Chaos no longer despecializes Tortoises

2020-03-16 21:47 Bugfix update 11.3d:
- fixed the missing messages (and click sound) when interacting with Orb of Yendor
- you no longer immediately die in LoEM in the Hardcore mode
- fixed items disappearing with Orb of Winter and Orb of Magnetism
- fixed Baby Tortoise colors in tour/PTM
- fixed Tortoises losing their colors
- fixed Orb of Chaos losing Hive colors
- added the new lands to PTM
- fixed game over not being detected correctly when using magical boats

2020-03-22 12:01 Update 11.3e:
- arbitrary tessellations: new files, utility functions for making Archimedean tilings, fixed a bug in some spherical tilings
- fixed a precedence bug in expression parser
- fixed a bug in loading maps from old versions
- Galapagos: moving over other tortoises no longer clones them, and shading now can be disabled
- fixed the Slime cheese in the Wetland
- fixed distance computation in 3D fieldquotient
- fire-related orbs are now useless in Wetland
- Orb of the Fish is no longer useless in Wetland and Frog Park
- some 3D models were created incorrectly in S2xE geometry (they were asymmetrical)

2020-03-25 13:51 Update 11.3f:
- updated the number of lands given in a slide of the Guided Tour
- fixed a serious bug (it caused crashes in Solv racing, but it could cause other issues too)
- fixed two bugs in inverse_exp in Solv (one caused wobbling, other caused possible crashes)
- fixed the interaction of Orb of Chaos and Orb of Time
- fixed a crash in paracompact honeycombs
- fixed a crash bug in {4,3,5}
- fixed a (broken) help screen displayed when mousing over another land in the Guided Tour

2020-04-02 14:05 Update 11.3g:
- The powers you get for Orb of Yendor are now consistent with useless/dangerous/forbidden rules
- Fixed a bug with the three new orbs not being saved correctly in OSM
- face/edge/vertex centering
- in line animation, you can now choose to precisely specify the first and last point to animate
- you can now increase the view distance after death, and use line animation whenever you can increase the range
- fixed the hotkey in 3d->camera rotation
- fixed a crash bug in Zebra quotient space and some horospherical tessellations
- fixed random_spin() in three dimensions
- fixed the grid display in nonisotropic hyperbolic geometry
- Archimedean tessellations: added some more samples, and some additional checking

2020-04-06 11:43 Update 11.3h:
- neon mode works in 3D (textured things are drawn as wireframes), an option to not fill neons
- 3D geometries no longer crash when OpenGL is off 
- fixed a bug when switching between various binary tilings
- fixed flashes disappearing
- fixed some achievements awarded before making the move
- fixed cell counter
- fixed the achievements for Elemental Gems and Ancient Jewelry
- Wetland rebalanced
- less awkward map position in portrait mode
- added vertical margins for mobile screens
- reverse FPP mode on iOS should be fixed
- fixed the missing message when PC could not stay in place
- fixed a potential rare crash

2020-04-17 21:00 Update 11.3j:
- the Hypersian Rug mode now uses HyperRogue's 3D engine. As a result, its controls are consistent with HyperRogue 3D (which has received shift-strafe for this consistency), you can now view it in all models, and embed in Solv and Nil geometries.
- a drawing tool (see creative mode). Contrary to Vector Graphics Editor (now called Shape Editor) and texture editor, this simulates on using a huge non-Euclidean blackboard (unless played in Euclidean geometry or in a quotient space, of course).
- WRL export (export e.g. your Hypersian Rug or a hyperbolic honeycomb in ball model to a 3D modelling tool or a 3D printer)
- fixed some issues with 'vertical stretch' (acted inconsistently, stretched text)
- fixed central inversion in 3D models
- better error information when trying to read an illegal tes file
- CA mode now automatically awards Orb of Aether (so you can step space) and is simulated on every step in animation mode
- more accurate Solv rendering (using RK4 method instead of buggy midpoint)
- when giving values, you can use "..|" (animate with sharp changes); "../" can be also used for spline interpolation

2020-04-22 01:46 Update 11.3k:
- Orb of the Sword now destroys shrubs
- more accurate mouse when in 2D projections
- fixed horocycles in bitruncated {4,x}
- fixed Great Walls in {5,3,4}
- Hypersian Rug/camera improvements: 
- - camera rotation now works better in 3D scenes with gravity (including product geometries, 2D-in-3D and gravity lands)
- - now displays geometry correctly
- - removed outdated documentation
- - panning enabled in the menu
- - shift+mousewheel for zoom works in rug
- - zoom hotkeys now change FOV in perspective modes
- - lshift+arrows now rotate the model in rug
- - shift+PageUp/Down now zooms
- - rug can now be mouse-rotated with Ctrl
- - fixed in standard binary tiling and in *.tes tilings

2020-05-01 18:57 Update 11.3l:
- Tessellation files: 
- - added a debug screen if the polygon does not end correctly
- - added a command debug(tilenumber) to debug connections
- - if you define constants, they take precedence over predefined constants
- - expression parser now accepts whitespace in expressions
- fixed a bug when scrolling with arrows then moving in quotient spaces
- fixed 'smooth scrolling' option not making scrolling very smooth
- an option to fatten regular (isotropic non-Euclidean) honeycomb edges
- better centering in screenshot, 'rotate PC' option
- in animation, 'monster turns' can be configured (useful for animating CA or butterflies)
- fixed Butterflies in non-orientable geometries

2020-05-16 11:26 Update 11.3m:

gameplay:
- Orb of Safety in multiplayer should be fixed
- fixed a potential crash while clearing the map

configuration:
- recently added lands should work better for FPP (correct skies, Frog model; also fixed the Sun)
- allow setting the resource dir
- rewritten the o-key functionality to let the user choose from several applicable options
- you can now configure the music to play while out of focus in the menus (see "music volume")
- 'light' movestar now has size adjusting to geometry
- help for keyboard users options includes help for VI keys and WASD keys
- fixed movement while in rug

geometry:
- tes files can now define "affine tessellations"
- 'change curvature' option (in regular 3D honeycombs you can change the curvature of the cells)
- raycaster for the spherical and SL2 geometry [does not draw vertical walls well]
- raycaster in rotation/product spaces now works also for non-regular base tessellation
- stretched spherical/SL2 geometry (raycaster only)
- 3D models were buggy in rotation spaces
 
2020-05-29 10:41 Update 11.3n:

new geometries:
- icosahedral hyperbolic honeycombs
- hyperbolic honeycombs with ultra-ideal vertices
- an option to truncae ultra-ideal vertices (both in 'real' and curvature-changed honeycombs)

new features:
- random pattern mode for Zebra, Wet and Frog
- record animations directly to a video file (currently only Linux 60fps using ffmpeg)

bugfixes:
- fixed freeze while drawing the sky in {n,infty} FPP
- fixed possible crash when doing 'underlying tree' in some geometries
- fixed some bugs when curvature-changing Euclidean geometry
- fixed the monster list in Snake Nest
- in checkerboard tessellations, the two-color distance shading in some lands is replaced with a three-color one
- added 'back' in quotient config
- fixed some patterns in Crystal bitruncated {6,4} (this also fixes incorrect tile graphics)
- fixed (horo)cycle-based lands in Euclidean
- fixed raycasting glitches in hyperbolic space
- fixed incorrect farlands generation in quotient geometries
- fixed incorrect wall shape in some geometries (e.g. Euclidean)
- fixed a bug in 16-cell

2020-05-31 16:47 Update 11.3o:

- new commands for tes files: cscale, repeat
- texture mode now compatible with tes files
- more detailed explanation if the polygon does not end
- in texture mode, relabeled "zoom/scale" to correct "scale/rotate"
- parser: edge_angles function
- fake curvature: not works in 2D (regular, bitruncated, and Archimedean); improved net showing; new options
- Nil: fixed the raycaster, and a freeze when changing the 'width' parameter
- fixed a crash when changing wall quality in some geometries
- when selecting singlecolor/randomcolor pattern in 3D, you can now specify the wall probability

2020-06-07 19:18 Update 11.3p:
- simplified the tes format (removed angleofs(pi) which is now the default)
- tes files now can include 'slider' values, which can be changed live during the game
- only a few sample tes files are now included (the full collection is maintained at: https://github.com/zenorogue/tes-catalog )
- a basic raycaster is now available in 2D geometries in FPP mode
- minor tes improvements: better error messages, removed debug output
- fixed a glitch in the raycaster
- option -WT to teleport to a land, but without safety generation
- fixed crashes when drawing boats in some geometries
- throw an exception when file does not exist
- improved shmup in fake/slided geometries
- fixed texture remapping in fake curvature

2020-07-08 16:36 Update 11.3q:
- extra sound effects (frogs appearing, Kraken death, elemental gem, apple, demon levelup)
- fixed 'disable texture' in rug levellines
- an option to rotate not around the center in 3D
- view coordinates no longer works outside of cheat mode
- an option for volumetric raytracing (i.e. glowing fog visualization)
- fixed the boat protection given by Orb of Winter
- tes files: undo in connection debugger
- eyelevel setting now works in the first-person shooter mode
- expansion in reg3::in_rule() activable [test]
- added efficient generation rules for 353
- fixed the graphical sizes of wolves and orbs in some geometries
- fake curvature in the rhombic honeycomb
- ordered net creation in fake curvature
- new 3D Euclidean quotient space: Hantzsche-Wendt (double cube) manifold

2020-07-13 01:32 Update 11.3r:
- new options in the variation menu, which allow e.g. playing / map editing on the duals of Goldberg tessellations, or e.g. warped GP(2,1) {8,3}
- redone some Guided Tour slides and possible crash
- you can now add text in the Drawing Tool

2020-07-25 02:27 Update 11.3s:
Bugfixes:
- the checkmate rule now takes tortoise calming into account
- fixed colors of underwater compasses and rugs
- collecting items while moving compass
- Reptile counters are now reset when fast creatures move over them

Geometries:
- primitive-based rendering in stretched S3 and SL geometries (replacing the old SL renderer)
- period can now be changed in rotation spaces, e.g. to obtain SL or the universal cover
- fixed a crash when walking over a hyperbolic digon in Archimedean tiling
- fixed a crash in untruncated sphere
- statistics given in 'experiments in geometry' (world size, faces per vertex) are now correct in new variations

2020-07-28 22:03 Update 11.3t:
- HUD graphics now always use the default (not the one for the current geometry)
- fixed a possible crash in kite-and-dart tiling
- fixed distance computation in periodic product spaces (racing in H2xE no longer freezes)
- rotation space over closed manifold now works correctly with theoretically correct period (divisor of Euler chi times PSL value)
- fixed a stupid crash in universal cover of SL
- fixed distance computation in quotient spaces
- fixed radar in SL geometry
- fixed a freeze in Berger sphere primitive
- better raycaster in Berger sphere/SL geometry (now uses a geodesic formula, also bug fixed), also disabled by default
- fixed key conflict in 3D config
- shape editor/drawing tool now work correctly in 3D with mouseaiming off
- mouse aiming can now be temporarily disabled in the editors using alt
- drawing tool now works in 3D, and also if you are drawing while playing a movement animation
- fixed drawing unnecessary cells in SL2
- fixed a bug while saving/loading maps using new variations
- improved handling of cases where matrices were not enough to represent positions (long band model, universal cover of SL) -- faraway monsters now face the player correctly, and racing/shmup now works in SL

2020-07-29 23:02 Update 11.3u:
- Orb of Air now kills Red Raiders if separating them, instead of crashing
- fixed bad HUD in 3D
- redone peaceful mode to puzzle/exploration mode

2020-08-02 13:24 Update 11.3v:
- cool fog effects in 2.5D
- '@' no longer drawn (incorrectly) in 2.5D radar
- fixed stranded boats in 3D
- fixed a bug with Orb of Recall
- fixed Minesweeper on huge bounded maps
- improved mission screen in Minesweeper (it displays automatically on win now)
- removed irrelevant hints and progress messages on the mission screen when you are not playing a full game
- Safety saves / PTM scores / Yendor scores / high scores should now work correctly in all geometries (the system is not fully backward compatible, so some old scores might disappear)
- a crash when setting new variations should be fixed

2020-08-05 01:29 Update 11.3w:
- fixed shmup in elliptic
- fixed a crash with loading old save games

2020-08-08 16:10 Update 11.3x:
- fixed raycaster in twisted geometries; weirdly twisted spherical geometry
- draw crosshair even if nohud
- an attempt to fix/debug the crash that some people are reporting on loading a saved game

2020-08-20 16:47 Update 11.3y:
- Chaos Mode unlocking should be fixed
- correct error message when trying to move from Rock III to a wall
- Speed Witches are no longer incorrectly considered as threats (but Flash Witches are real threats!)
- three new projections
- Camelot help now mentions Crossroads IV
- fixed premature victory screen in minesweeper

2020-09-17 04:32 Update 11.3z:

geometries and projections:
- Nil can be now viewed in the loximuthal model, or in the Heisenberg model with changed orientation, or a mix
- several new projections of S2/H2 based on cartography
- chessboard pattern in 'unrectified' tessellations (also fixed the variation selection)
- improved correctness checking for Archimedean symbols: 6,5 or 6,4,2 are no longer valid

UI:
- you can now configure camera movement/rotation speed
- highlight feature is now separate from monster display, and you can configure permanent superhighlight
- the 'copy' button in the Map Editor now works with the mouse

game bugfixes:
- improved Key generation in Land of Mirrors
- you can now push Statue into Fire with Orb of Winter
- fixed Free Wall unlock requirements in OSM
- fix the Crossroads IV achievement (which also enables the Chaos Mode)
- fixed Halloween (which was working completely incorrectly)

graphics/UI bugfixes:
- orb of domination X is no longer huge
- fixed Yendor/Grail collection benefit help message in OSM
- fixed errors with mirrors walls: monsters face the player correctly (except Mirror Spirits); mimics in mirrors display their X-signs correctly; player in mirror displays their X sign while previously they did not
- down arrow in menus now works opposite to the up arrow (rolls around)
- issues with racing (e.g. in band model) should be fixed
- keys are buffered correctly (no more crash when clicking help quickly)
- prevented crash when negative numbers are entered in 'view cells by distance'

2020-09-21 12:06 Update 11.3Å¼:

- fixed the issues with Orb of Yendor
- fixed a bug in S2xE, and choosing cells in sphere
- fixed Friendly Ghosts

2020-11-02 00:08 Update 11.4:

* Panini perspective projection (allows wider vision -- configurable in 3d config -> FOV)
* Changed the default texture_step to 4
* An option to hide the flat projection in hyperboloid
* improved plain floor shapes in arbitrary tessellations
* fixed the Asonov cat geometry
* Five new projections: Poor Man (hyperbolic only), Panini, retroazimuthal: Craig, Hammer, Littrow (retro-Hammer buggy on sphere)
* Various fixes related to product spaces, especially product+inverse
* Fixed the navigation keys in dialogs
* fixed duals for Euclidean tessellations

Also, improvements in the Web version -- Backspace not Esc to exit dialogs, auto-resizing, raytracer is available. 
Not yet in HyperRogue online, but see: https://zenorogue.itch.io/bringris

2020-11-05 18:53 Update 11.4a:

- fixed the aura when camera angle changed
- fixed selecting large regions for copying with mouse
- messages at 30 treasures etc. should no longer appear in PTM
- fixed a bug which allowed changing the generation/game range outside of cheat mode
- fixed drawing of creatures in kill list (visible e.g. for dogs)
- the RGB/RGBA hex value color is now shown with leading 0s
- Orb of the Mind now actually kills reptiles
- Orb of Chaos is now forbidden in the Princess Quest
- highlight mode setting should be saved now
- improved the safe move checking (fixes some minor bugs especially in multiplayer)
- allies use the new safe move checking now (they now know whether attacking hedgehog warriors/pikemen is safe for them and do it if yes)
- golems and bomberbirds now pathfind correctly

2020-11-08 12:37 Update 11.4b:

- fixed projections other than perspective not working in 2.5D
- fixed the incorrect positioning with "camera angle" option on
- in 3D config, automatic TPP/FPP now appears on top, as you usually want this, not 'use 3D models'
- fixed a crash on picking up items without OpenGL
- fixed rug movement animation
- LShift+PgUp/Dn now changes the FOV in rug perspective
- fixed unstable camera problems in 2.5D
- show music volume setting when music is available

2020-11-14 15:12 Update 11.4c:
- Panini projection now works in any perspective (previously it did not work 2.5D and Hypersian rug, but it was incorrectly applied in orthogonally projected views)
- fixed shader reset on Panini configuration
- fixed the dual geometry mode
- the screenshot feature should now correctly render the dual geometry mode (and some other things)
- fixed the horosphere honeycombs (graphics)
- fixed the game freezing on the generation of binary tiling x R
- fixed the camera not rotating in Nil shmup
- fixed the numerical inaccuracy explosion problem in nonisotropic shmup

2020-11-22 17:55 Update 11.4d:
- an attempt to set DPI awareness on Windows
- a bit of Panini projection was still used even when off
- preliminary implementation of VR (see: http://roguetemple.com/z/hyper/vr-status.txt for the current status)

2020-12-31 19:18 Update 11.4e:
  Improvements to VR:
  - added VR demos
  - simplified VR controls (reusing the mouse control)
  - VR controls for shmup/racing
  - correct pointing in VR in all contexts (including rug, drawing tool in 3D geometries, etc.)
  - display various 2D and 3D models in VR
  - "single" computer screen
  - works with raycasting now

  Other improvements:
  - Orb of Slaying is now marked useful in Eclectic and Brownian
  - Princess is now able to open the doors if she cannot reach the player
  - Princess hug animation
  - fixed potential crashes on Ivy errors
  - fixed a crash bug when collecting an Orb of Safety via Orb of Space with Orb of Impact active
  - fixed a crash bug when collecting an Orb of Safety via Orb of Water
  - shmup: fixed redundant and incorrect revival of mirror spirits
  - fixed more possible crashes

2021-02-07 21:13 Update 11.4f:
VR updates:
- minor optimizations
- pseudo-raycasting in equidistant mode
- changed the defaults
- fixed auto-vertical orientation in product spaces
- items are better at facing the player

Menu improvements:
- keys '1234' no longer change the projection -- instead, '1' shows a small menu of projections, which also includes other nice options
- this menu of projections is also used for "models & projections" (some new players explore too much weird projections and are confused)
- the following menus have been redesigned: sightrange, resolution, vector graphics, sightrange
- highlights in special modes
- filename for history band can be changed now
- [WIP] a menu which lists (automatically or manually) recently changed settings
- nicer slider-dialog

Game bugfixes:
- fixed the game not determining the land correctly for Orb generation purposes in Haunted Woods border, mercury river bridges, and Warped Sea
- fixed the 4xStabber and Princess achievements
- trying to generate wall lines in non-standard Euclidean geometry no longer crashes the game

Other improvements:
- fixed bugs when switching FPP in E2 torus
- drawing tool and shape editor can now be used with texture mode enabled
- improved the wall/floor textures in 3D modes

Bringris:
- nicer "pentagons" geometry
- flashes option
- fixed disabling the raycaster
- adapted to VR

2021-03-09 16:13 Update 11.4g:
VR improvements:
- 'frustum culling' optimization is now used in 3D geometries in VR
- if 'holonomy' or 'reference' is used in 2D, assume 'model_viewing' instead
- optimized raycasting (raycast_map called just once per frame)
- cool fog and sky should now work correctly in 2.5D
- fixed the formula checking whether we are pointing at something in the UI
- characters displayed on map are now drawn correctly (e.g., when in ASCII mode or for the bubbles)
- added border between font letters to avoid rendering artifacts

Gameplay:
- fixed a revert-related bug which could cause a non-collected key to be considered collected
- fixed reverse condition: allies' plague spreading worked only if you had no empathy
- fixed generating treasure (Wetlands, Blizzard) and enemies (Wetland) in Safety; also made Wetlands easier to exit
- Orb of Safety now prevents wandering monsters (for 7 turns)
- in multiplayer, there should be no more crashes when a player leaves the game 
- fixed the highlight/hardcore key conflict

Projections & geometries:
- fixed animations breaking
- fixed a reverse_direction crash in kite-and-darts (happened e.g. in Hunting Ground)
- field quotient can generate more manifolds (for example all three in the first Hurwitz triplet)
- threepoint equidistant projection
- 'reset special modes' disables dual geometry

General:
- sky rendering is optimized 
- fixed a crash when trying to set some options

2021-04-15 19:29 Update 11.4h:

Improvements to the ASCII mode:
- PC/monster movement is animated
- ASCII items & monsters are now available in 3D graphical modes
- ASCII displayed for terracotta warriors

Improvements to 3D modes:
- improved the fog effect in 3D modes (non-black fog did not interact correctly with black textures)
- fixed the mirrors
- fixed a possible black screen on firstperson mode change
- fixed incorrect clipping in H2xE, and clipping planes affecting 2D geometries
- stereographic projection added (as another way to obtain larger FOV)

General:
- you can now explicitly select the land structure (standard / chaos / single land / etc.) instead of having it determined by the land
- knight names updated
- new achievement Lovasz conjecture (see "highlights & achievements")
- don't reopen the window needlessly

2021-04-23 21:04 Update 11.4i:

Fixed some issues with the "single land" mode (including PTM):
- Camelot was not infinite
- Crossroads (all types) generated correctly, also single-land Crossroads V is now available
- fixed the Warped Coast
- fixed the Elemental Planes
- fixed the equidistant-based lands
- fixed the Brown Islands
- 'land structure' selector now displays OFF if the default structure is selected
- fixed a crash trying to generate nowalls e.g. in {3,7}
- fixed the Highlights & Achievements menu to set the correct land structure

2021-04-25 11:53 Update 11.4j:

- in Irradiated Fields monsters and generated outside of the vision and they did not make spawn sounds when entering vision -- this is fixed
- fixed the Princess Challenge and some horocycle generation
- fixed Crossroads II
- clearing in the binary tiling variant (rather easy)
- fixed ASCII display outside of OpenGL

2021-05-01 14:10 Update 11.4k:

more fixes to "land structure"hanging:
- Prairie is no longer a trap in no walls mode
- Crossroads II and V are no longer generated in nowalls mode
- fixed Camelot having inside lands in some land structure modes, and also made it more likely to appear in nowalls (although still unlikely)
- fixed "reset special mode" to reset correctly
- starting in horocyclic lands in multi-land binary-like geometries works (it is the only horocycle in the world though)
- in multi-land hybrid geometries, fixed the starting land
- standard walls work again in hybrid geometries

other fixes:
- fixed "draw underlying space" in E2xE and other product geometries
- Orb of Earth no longer marked useless in the Warped Coast
- fixed the E2xE raycaster
- added faraway monster highlight as in @still-flow's pull request
- fixed the Temple of Cthulhu in bin44 so that it works like in https://www.youtube.com/watch?v=625ZwpjtWZU again

2021-05-31 15:54 Update 12.0:

Gameplay:
- new lands: Cursed Canyon, Dice Reserve
- casual mode
- fixed the Caribbean Yendor Chalenge
- Raging Bulls generated from Herd Bulls crashing into walls offscreen no longer permanently block the way when offscreen
- Bulls crashing into rock formations now reduce their height, and ones falling from Rock III increase the height when they fall
- rosescent no longer spreads into gravity lands, and rosephase is now reset to 0 on safety
- no longer push statues through halfvines

UI:
- two new music tracks by Lincoln Domina
- PL/CZ translations updated
- 'plain' button shown in the inventory screen
- no more world overview in Yendor Challenge
- newbie-friendliness: explain how to get Safety
- land selection (PTM, land structure) is now searchable
- YASC codes
- corner HUD now displays the active special modes

Geometries:
- fixed weird rotation of the orthographic view in shmup
- fixed GP on Crystal
- improved tree rules for more honeycombs
- improved the raytracer so that it works with many tile shapes

VR: 
- fixed ASCII orientation
- Panini/stereo projection now works in the 'single' VR screen (didn't work correctly) but not on the eyes (did work)
- fixed the 'thurston racing' option
- controllers are now shown on the desktop screen

2021-06-06 10:54 Update 12.0a:

- fixed a bug which caused the dice numbers not to be drawn sometimes
- Orb of Earth no longer marked useless in Cursed Canyon (also it works in a more interesting way there)
- Canyon Hag's attack now has a sound effect and an animation
- the bug with android crashes should be fixed
- fixed spurious messages about slashing the Shadow with the energy sword

2021-06-17 09:52 Update 12.0b:

Mostly Bugfixes:
- fixed going thru vines
- item graphics were not editable
- fixed the first-person perspective for ideal 2D tessellations (also implemented previously missing sky)
- 'edit cell values' option now visible in the map editor
- Orb of Change no longer can produce Hunter Dogs and Zombies (who have special properties)
- fixed 'inv' displayed incorrectly in the HUD mode line
- full_geometry_name now displays the Archimedean symbol
- dice:: numbers now shown outside of the OpenGL mode
- dice:: Orb of Chaos works correctly now
- dice:: now work correctly in non-orientable spaces
- dice values are now editable in Shift+G
- fixed the direction setup by Orb of Chaos
- fixed the remaining spurious shadow messages

2021-07-04 11:23 Update 12.0c:

Mostly bugfixes:
- Archimedean: fixed the possible crash on deleting arcms with large cells, because of the confusion of cdata
- items in water no longer can burn
- Overview cheats: arrow keys no longer make treasure/orb counts negative
- Orb of Time now preserves Orb of Plague properly
- Orb of Safety excludes more monsters
- More fixes for Russian translation
- Flash Witches no longer avoid killing the player's allies
- Yellow Frogs no longer phase into the player's sword
- Resolve conflict between 'Galápagos shading' and 'teleport'
- Fix HUD kill list in 'items only' mode
- Wandering rocksnakes no longer appear on hepts
- Add wiki links to land help
- Mention the Cursed Canyon in the Shadow's description
- cheat Teleporting to Haunted Woods no longer puts you infinitely deep
- Orb of Change no longer produces Jiangshi or Desert Man
- Fix extra Viziers when walking around the Palace with 12 treasures
- Help for Mutant Sapling no longer claims that it unlocks Orb of Luck globally
- Orb of Slaying can now appear in hub lands
- Orb of the Woods now only appears in lands where it is potentially useful (and in hubs)
- Orb of Luck no longer appears in Free Fall
- Orb of Friendship no longer appears in Terracotta Army
- The Orb of Beauty now lifts rose-scent restrictions on targeting of ranged orbs
- fixed a memory leak when drawing text

2021-07-13 22:24 Update 12.0d:

New features:
- variations are now supported for regular honeycombs
- better handling of 3D honeycombs (e.g. minesweeper with vertex adjacency now should work correctly everywhere, reflective raytracers works in more cases, etc.)

Bugfixes:
- Copy wparam when copying wall
- prevent slime from duplicating dice
- Orb of Lava no longer intimidates allies
- Fix typo in Windy Plains description
- some fixes to the Russian translation
- Fix array indexing in totalbulldistance
- Fix crash by disallowing statue-dice swaps
- Ivy to Vine no longer overwrites Round Table
- Reversing the Curse of Water now gives bonus Orb of Winter (as intended)
- Fix some messages when using Orb of the Warp
- Cave transformation is fairer to players
- Prairie no longer appears on Crossroads IV
- Raging Bull can no longer push Princess onto player's cell
- Only show chasm trails in special modes
- Orb of Air can no longer push sharks
- Dice can now be pushed onto items
- Fix crash after using Orb of Domination
- Fix 'nowhere to blow' message for happy dice
- Curse of Weakness no longer allows pushing parts of multitile monsters
- Orb of shield/shell no longer bypasses 'kraken will destroy boat' warning
- Fix checkmate check when standing on an Orb of Speed
- Irradiated Field: bull generation no longer breaks ivy
- Fix several Friendly Ivy interactions

2021-08-01 11:19 Update 12.0e:

New features:
* better land boundaries in all (hyperbolic) 2D geometries, including Great Walls-like ones
* improved CR4 and Camelot generation
* tes files now support aperiodic (tree-based) tessellations and some other features, see "horotiling.tes" in samples
* HyperRogue is now able to generate strict tree-based rules to generate periodic tessellations 
  (including tes files and Archimedean, which previously were generated using other methods).
  This way of generation avoids numerical precision errors and lets us understand the growth patterns
  (experiment with geometry -> size of the world) and generate horocycles and Camelot. This
  is currently disabled by default, but can be enabled in experiment with geometry -> size of the world -> strict.
* Dice hover map now indicates hardness with color (thanks to @jruderman)
* minor Russian translation updates (thanks to blargdag)

Bugfixes:
* fixed some issues with sky rendering in FPP (better stars and Palace ceiling)
* fixed incorrect graphics in binary tilings
* fixed bugs with moving the key with boats
* Princess Quest no longer shows fail screen merely due to the princess being in peril

2021-08-05 13:23 Update 12.0f:

* fixed fake geometry with 2D tessellations (many fixes)
* fractal landscapes for strict tree-based rules
* improved the memory performance of strict tree rules generator (see 12.0e)
* crossing Great Walls (CR3/Elemental Planes) for all 2D tessellations, fixed some bugs with Great Walls
* fixed switching places (message shown correctly, can't switch with saved tortoises and dice in peace mode)
* fixed possible bugs with Brownian colors, snake colors, interactions of arrow traps and terracotta warriors (thanks to @jruderman)
* fixed 3-dimensional elliptic space
* tes files: fixed a bug with 'ended at wrong edge determining vertex_valence'

2021-09-30 17:55 Update 12.0g:

Geometries/projections:
* new manifold (projective Bring surface)
* fixed the interesting dodecahedral quotient spaces (535c, 535s, 533s)
* fixed rotation spaces
* fixed a possible crash in Crystal
* fixes to the tree rule generator
* some Euclidean lands are now available only in single land mode
* two-sided display of hyperbolic disk with -1<projection<0
* load maps with intra-geometric portals

Gameplay bugfixes:
* Erase rosemap entries for deleted cells
* Orb of Trickery messages no longer reveal underwater items
* Add Orb error messages for Phasing and Vaulting
* improved ranged Orb error messages
* warning protection no longer evokes Flash/Lightning
* no more fatigue cost checking when the Curse is gone
* cleaned up where summoned creature appears for Orb of Life and Orb of Friendship

Other fixes:
* fixed PAGEDOWN rotating in the same direction as PAGEUP
* wall shadows no longer drawn with noshadow
* an option to disable sky drawing
* improved the CLI option to set the resolution
* mimics now destroyed correctly in the map editor
* parallel linepattern is now configurable
* fixed message about 9 treasure types in casual

2021-10-10 01:13 Update 12.0h:
  - improvements to intra portals
  - Solv maps and subdivided 3D maps are now saved correctly
  - fixed a crash when generating daily, also Dice Reserve, Cursed Canyon, and the new walls should appear soon
  - do not switch variation to pure when switching to Archimedean product
  - fixed Archimedean dual product
  - raycaster now works correctly in binary products
  - binary product spaces now use curved shapes
  - fixed some formulas in binary spaces, and made the default width equal to Solv

2021-12-12 23:06 Update 12.0i:

Gameplay:
- Hyperbugs now ignore the player in peace mode
- fixed the Nature + movement orb combo, without Empathy
- fixed the Nature + Slaying + Empathy combo
- Krakens no longer destroy player boats in peaceful mode
- fixed allies affecting Terracotta Warriors without actually moving next to them
- fixed reporting the Gardener achievement

Other:
- fixed grammar error 'Orb of the Love'
- fixed a bug in parsing unary -
- perf/edit setting in intra-geometric portals
- do not remove faraway treasures in 3D geometries (they are not that far away...)
- reduced the other land range for currentLocalTreasure in 3D geometries
- fixed openplains in nowalls mode
- fixed raycaster in 2dim geometries crashing
- the problem of moving in Cat geometry should be fixed
- stop crashing in Solv if coordinates are NAN
- fixed weird colors in coxeter
- fixes to rulegen
- refer to color by HTML name in commandline arguments, and an option to allocate more colors via CLI
- pseudohedral display mode in 2.5D
- TES files: a feature to add commandline options, and stars

2021-12-13 22:32 Update 12.0j:
- fixed the victory leaderboards (turns/time to Orb of Yendor/Hyperstones)
- fixed the starting land selection feature for equidistant-based lands

2022-02-03 01:07 Update 12.0k:
Orb-related fixes:
- Lazurite Figurines no longer appear immediately after using an Orb of Safety
- Orb of Chaos is now forbidden in the Dungeon
- Stunning from the Orb of Chaos now destroys birds/shadows just like the other sources of stunning
- Shadows are now affected by the Orb of Beauty
- Stunning the Shadow now temporarily destroys it
- draining Orb of Choice now happens after gaining the Purity extras
- Orb of Slaying now works against big trees
- draw fishtails on friends with empathy

Achievement fixes:
- fixed racing (official tracks are generated again and acknowledged)
- Princess Challenge and Heptagonal Knight achievements should be fixed

Geometry:
- more distinct colors in 'eight domains'
- improvements to tree rule generator
- Goldberg-Coxeter improvements (larger limits supported, warn if outside of the supported limits, some are fixed)
- fixed fat edges in some H3 honeycombs
- fixed some bugs with Multi-dimensional Crystal quotient space

2022-03-01 09:39 Update 12.0l:
Orb-related fixes:
- Curse of Repulsion now correctly marked when used
- when having Orb of Freedom + Orb of Time, other orbs are no longer drained by Freedom checks
- Valentine's Easter Egg: Add +1 extra charge to Orb of Love

Geometry:
- fixed VR in product geometries
- portals between geometries: fixed some formulas, walking mode
- fixed dark lines in binary tiling x R raycasting which happened when we got a=0 in quadratic equation
- made Yendor/Haunted sight radius consistent when the tiling is changed
- infinite generation for single-land Camelot now only happens in hyperbolic geometry (also fixes the missing Grail in Crystal)
- additions and fixes to RogueViz

Other:
- fixed Crossroads wiki links
- fixed some settings incorrectly showing a warning on editing (this also brings back the 'play music when out of focus' option)

2022-03-27 20:51 Update 12.0m:

Improvements to multiplayer:
- "split screen mode" can now be set explicitly (don't lose the other player, and don't tell the other player to go right, holonomy matters ;)
- an option to automatically adjust dual-focus projections to focus on both players (try it with inverted Joukowsky, two-point equidistant/azimuthal and band projections)
- an option to toggle friendly fire and self-hits in wrapped spaces
- an option to toggle player-vs-player (this disables limited lives)
- fixed the radar and cool fog in splitscreen

New options thanks to lottieratworld:
- idle animation option
- extra canvas-specific options (map editor->settings)

Other new features:
- mouse snapping feature in shape editor -- can be used to precisely measure distances and angles (press 'o' to select the point to measure from)
- when the player is hidden (e.g. in RogueViz visualizations) and the user tries to use WASD, display a hint that they should be using arrow keys instead
- prevent a crash when entering '(0,0)' in Archimedean

Rendering fixes:
- fixed levellines in hyperbolic
- in non-fake 2.5D the raycaster is now disabled by default
- fixed scale_at for cylindrical projections
- fixed the orientation of two-point azimuthal and two-point hybrid

Gameplay fixes:
- fixed the Orb of Safety not disappearing upon use in shmup+OSM
- fixed the displayed unlock rule for Crossroads III in Casual

2022-04-26 16:19 Update 12.0n:

Gameplay:
- Viziers were immune to some attacks in illogical circumstances -- this is no longer the case
- mirrors and non-orientable spaces now flip Alchemist Lab colors
- slime spills should now have deterministic effect when a cell is hit with slimes of both color simultaneously
- fixed Zebra-patterned lands in Zebra quotient space
- fixed Prairie in field quotient space

Graphical/writing bugfixes:
- the hyperboloid model of S2 (as an anolog of the hemisphere model of H2)
- fixed hadoken missiles not displaying correctly in shmup 3D
- fixed some floors scaled incorrectly when 'creature scale' is changed
- floating bubbles now should work correctly for Mirror Shards, Elemental Gems and Ancient Jewelry
- fixed the dice layering issue
- paper model designer and spiral renderer could crash because they were implemented without OpenGL -- should be fixed now
- "run away from the lava"
- Hell is no longer "the Hell"

Tes file format:
- repeat can now be declared before conway or c
- (unit)tile now accepts the last argument written as "*x", which copies the list x times and also automatically sets repeat (see regular.tes)
- as a special case, "*inf" produces apeirogonal or pseudogonal tiles with hidden splitting edges (regular.tes, pseudogons.tes, fake-inf-polygon.tes)
- arcmedge accepts "x:^q" which means that x can be repeated q times. Both x and q can be real, and x can be infinite (see regular.tes)
- new geometry definition "c2(v)" which automatically selects geometry based on the sign of v -- also arcmcurv command which produces appropriate v (see regular.tes)
- ideal vertices can now be with the bracket format (see inf.tes or ultratriangle.tes)
- min, max, ifz (if zero) functions and inf, MAX_EDGE, MAX_VALENCE constants in the parser
- integer sliders: change the integer values of sliders in the 'experiment with geometry' menu (contrary to real-value sliders, this resets the map) (see e.g. regular.tes)

CLI options:
- -animformula [formula] to change the timing of an animation
- -canvasfloor [f] sets the canvas floor type
- -keys [key list] simulates a list of keypresses

2022-04-28 00:03 Update 12.0o:

Fixed some bugs in the new features for tes, and also fixed spherical geometry.

2022-05-10 08:55 Update 12.0p:

- draw the side walls between shallow water and chasms
- the smooth movement option now works in the map editor (and some other special screens)
- "movement along geodesics" off now means that the movement is based on the Lie group exponentials (e.g. straight lines in simple view in rotiationally symmetric model of Nil)
- buggy window resizing should be fixed
- simplified display option for tes tilings with apeirogons
- RogueViz: fixed the VR for the portal demo, and some improvements to the impossibility presentation

2022-05-21 17:16 Update 12.0q:
- In 'experiments with geometry', added an option to play on a disk. This lets you use the "bounded space" rules on infinite manifolds. Especially useful with Minefield and Halloween.
- also improved the Halloween generation (outside of spheres)
- teleportation in bounded minesweeper no longer follows the limited range rule
- you can now display Minefield clues as numbers (right-click minefield to get its help screen where you can change this option)
- new projections mostly for Solv: Lie perspective and Lie orthogonal

2022-06-17 12:17 Update 12.0r:

Gameplay:
- ghosts prioritize attacking players over attacking allies
- fixed some Orbs not affecting slime
- Orb of the Sword can now kill yourself through mirror or topology
- sword attacks reflect in mirrors
- swords in mirrors are now displayed correctly
- mimic movements are now affected by Empathy, and no longer can reverse slime colors by going through mirror
- Woods+Time: do not waste charge on attacking monsters in trees
- fixed help for life Orbs in the shmup mode
- Halloween:: fixed the jack-o-lantern
- the Racing mode now loads pre-generated files instead of trusting the track will be generated in the same way
- you can also edit the Racing tracks and save them ()
- Hall of Mirror maps should now be saved correctly
- fixed a crash bug in computing minefield neighborhoods in some tilings
- fixed sl2 rendering

Menu improvements:
- unified the quest status (previously ESC) and main menu (previously V) into a single screen ("game menu")
- 'creative mode' is moved to the game menu
- a cleanup to some menus (special modes, highlights, peace&exploration)
- dual geometry puzzle removed (will still be available in RogueViz)
- switching shmup mode no longer invokes keyboard configuration

2022-06-23 10:50 Update 12.0s:

- fixed Minesweeper in the highlights menu
- fixed the racers keeping their speed when restarting
- when generating strict tree maps for Archimedean/regular tessellation, you now have an option to have all the symmetries of the tessellation taken into account (to minimize the tree)
- tes files with tree data (tessellations/sample/horotiling.tes) and star tes files (tessellations/sample/star-7-72.tes) should load correctly again
- show treasure bubbles in the Dice Reserve
- Shift+A key leaves the map editor, also all options are now displayed in the cheat menu (some obsolete ones are removed)

2022-07-05 14:12 Update 12.0t:
  Tranlations and bugfixes:
  - French translation by 3raven (42% complete and untested yet)
  - fixed the Polish translation of the description of False Princess
  - a bug where some racing times are set to 0 should now be fixed

  Menu improvements:
  - fixed the help button in the pause menu
  - you can now configure by how much you want to darken the background in the menu
  - menu display should be more consistent now
  - in sidescreen menus, the background under the menu is now darkened
  - start animations now can be disabled
  - nicer sliders and color selectors (unless the ASCII mode is on)

2022-07-12 14:47 Update 12.0u:
  - honeycomb tree rules for 345 and 355 (better performance, variations work)
  - some fixes to the French translation
  - options to show less items/kills in the portrait/landscape mode
  - an option to have menus centered even in widescreen
  - mobile fixes: fixed an incorrect button shown in the mobile game menu, and items/kills going over buttons

2022-07-17 14:47 Update 12.0v:
  - fixes for new Android
  - preliminary work on tree structures for 3D honeycombs
  - auto-rotation (Ivory Tower etc.) now works on devices who know their orientation
  - nicer "pipes" (fat grid lines) in 3D
  - fixed some crash bugs related to the memory saving mode

2022-08-07 03:03 Update 12.0w:
- fixed a bug with 'world overview' breaking ESC menu
- racing fixed (hopefully)
- minor changes to HyperRogue help: now directly offered when displaying context help; do not suggest to try the Guided Tour if already in the Guided Tour
- made the RogueViz presentations which contain no HyperRogue PC easier to control (control the camera by using the keys which usually move the PC)
- added some more demos to RogueViz

2022-08-07 15:01 Update 12.0x:
- yet another fix to racing
- fixed a crash when deleting 3-sphere maps

2022-08-26 13:46 Update 12.0y:
  - new implemenatation of hyperbolic honeycombs in action
  - field quotients in 3D now finds more honeycombs
  - variations now work for Euclidean cube tiling
  - tessellation, texture, etc. files can now be found via HYPERPATH
  - fixed the Slaying+side attack combo
  - Pearls now use the Disk graphics
  - Added some land incompatibilities
  - updates to French translation
  - fixes to stereographic projection (as a way to get high FOV)

2022-09-06 14:20 Update 12.0z:
- various fixes related to 'orb used' rollback
- fixed Sol geometry (a bug caused the map to change incorrectly when moving)
- fixed variations of hyperbolic honeycombs (when a ruleset was available only for the pure honeycomb, loading it would reset variation to pure)

2022-09-15 12:40 Update 12.1:
- documentation for TES files added
- an option to select the savefile on startup (settings -> other settings)
- fixed missing 'too far' messages on Frog-like orbs
- fixed Teleport and Illusion draining Aether etc on mousing (disregarding Time)
- fixed a crash problem with tes files in 2.5D
- fixed a possible crash in raytracer
- when tes files are loaded, football-colorability is now detected (and used to improve the graphics and gameplay)
- GPU glitches when rendering long bands should be no more
- fixed the loading of tessellations/affine/affine-square.tes
- fixed the crash on converting regular/Archimedean tilings to tes format and generating tree rules
- improvements to line patterns
- fixed a possible crash when saving images

2022-09-17 12:12 Update 12.1a:
- fixed Orb of Teleport/Illusion thinking that they are unusable
- Orb of Earth no longer marked useless in Wetland
- some fixes for the treasure/kill list: fixed the Onyx graphics; made some icons larger; dark stuff have their text brightened (or use the auxiliary orb color)
- the monster movement order is more random now (no preference for clockwise)

2022-10-06 13:13 Update 12.1b:
- Orb icons thanks to Jacob Mandelson. (Can be disabled in general settings)
- hostile dice are highlighted
- racing mode fixes: the menu shows whether an official track is on; the settings are set correctly, and land structure is ignored for the achievement
- Orb of Choice now works with Orb of Safety
- an option to arbitrarily change the width of tile boundaries (in 'patterns' menu)
- the option to debug tile/edge/vertexs IDs in the 'experiments with geometry' menu (if a tes file is on, but it works in general)
- tes format now supports declaring a tile as having a mirror symmetry
- tile-type display now displays mirror images as the same color (or slightly different colors, depending on settings)
- tile-type display no longer assigns different colors depending on football type
- when editing color tables, it is now possible to add more colors
- Crystal World and Snake Nest were legal in some tilings but they did not actually appear -- should be fixed
- vertical strafe in walkingmode no longer brings eye level below 0

2022-10-08 02:14 Update 12.1c:
- some improvements to tes file support. Mirrored tiles should now work for apeirogons. Valence check and thus football colorability should now work with affine/star tessellations. 
- also included more tes samples

2022-10-27 15:53 Update 12.1d:
- Various menus displaying lists now use a nicer list widget (including the file dialog and map editor selection).
- Map editor improvements:
- - "building mode", which allows Minecraft-style building in 3D geometries
- - shift-clicking in the map editor now deletes stuff
- - improvements to portal spaces, including easier creation (convert to portal space from the map editor -> settings, then you can add new worlds from save files)
- improvements to SL(2,R) and similar:
- - nonisotropic range parameters now work in all perspective modes
- - Panini in all perspective modes
- - more projections possible for SL(2,R)
- - fixed the 'penrose staircases' on wall blocks in rotation spaces
- 'load from file' appears directly in the geometry menu in 'experiments with geometry'
- achievements disabled in ineligible starting lands
- limit on pauses in the racing mode
- fixed the ogg files

2022-11-04 23:58 Update 12.1e:
- fixed some bugs with editing portal spaces
- some fixes in help text
- page buttons in PTM are back
- layout in Yendor should be improved
- fixed buggy generation when setting Elemental Wall as cheat destination
- file dialog improvements (more options, automatically set position, search mode)
- fixes to the shmup mode:
- - Gadflies no longer appear forever with high Spinel counts
- - pause count is no longer displayed in non-racing; also reset to 0
- - fixed pink tortoises appearing in Galápagos
- - Bulls now correctly destroy walls they crash into
- - fixed wrong time used in some places (running time instead of game time)
- - fixed the Flail Guards

2022-12-09 02:38 Update 12.1f:

- WIP: In '3d settings' menu for 2D maps, you can now select the way how the 2D map will be embedded into a 3D space (space of the same curvature as flat/concave/convex eequidistant, space of lower curvature, product space). 
  The basic functionality should work, but there are probably some bugs and lots of missing features (to do: shmup, raycasting, fog, radar, more intuitive menu, better default settings, embedding into nonisotropic geometries).
  On the way also some bugs with 2.5D should be fixed ("draw sky" disabled now also disables Euclidean sky; correct movement if the surface the camera moves on is not flat; fixed sky colors; fixed the radar transform computation in 2.5D which also affected fog rendering).
- fixed: inventory glyphs were missing outlines due to a bug
- improved the display in OSM when using orb icons
- Give the Plane of Fire a redder floor than CR4 (thanks to jlm)
- Draw mimics with sword in left hand if PC's sword in left hand (thanks to jlm)

2022-12-18 00:59 Update 12.1g:

Further improvements to the "3D style" (embed 2D in a 3D geometry) feature:
- more intuitive settings
- kite-and-dart and tes should now work correctly
- Lower and Much Lower curvature settings are now respected even if it was already hyperbolic
- pure regular Euclidean hex/square tilings can now be embedded in Nil and Sol/NIH
- binary tiling and similar can now be embedded in Nil and Sol/NIH
- shmup should work now
- fixed sky over irregular map
- fixed slime size

There are still some bugs to fix, but it should mostly work now. And there are more embeddings coming :)

Other bugfixes:
- fixed coloring of info items
- fixed centering on reset
- disabling geodesic movement in Sol/Nil now also assumes that light moves along Lie lines, and shmup monsters move correctly too
- fixed grid drawing for binary variants


2023-01-08 00:59 Update 12.1h:

Bug fixes:
- fixed context help getting stuck in corner stats mode
- fixed Princess AI using boat
- shallow water is no longer glitched when the 3D settings are illegal

Further improvements to the "3D style" (embed 2D in a 3D geometry) feature:
- four new embeddings of Euclidean space: Clifford torus (S3), product space (H2xR, S2xR), and SL2
- Hypersian Rug options are now linked in 3D settings
- fixed movement animations
- better diagnostics when an embedding does not work
- fixed a bug rendering band model without shader

2023-02-05 11:27 Update 12.1i:

Further improvements to the "3D style" (embed 2D in a 3D geometry) feature:
- Overall better design fixes various small errors, including nicer floor shapes, radar, shmup, and 3D models.
- Six new embeddings of the Euclidean cylinder.
- Hints how to change settings if the current embedding does not work.
- some crashes have been fixed (in Zebra/ Reptiles, thanks to Masala for the report; also crashes related to possible missing shadow models)

Also fixed a bug generating Dice in some tessellations.

2023-02-22 00:31 Update 12.1j:

Further fixes and improvements to the "3d style" (embed 2D in a 3D geometry) feature:
- more settings (regarding altitudes) are now configurable
- fixed VR (correct gravity alignment and eye position computation), also added new headset setting "holonomy Z" for embedded planes (also fixed a bug causing spinning in VR)
- fixed some minor bugs with "same curvature" and "product" embeddings
- fixed "SL(2,R) cylinder" (it was not actually implemented)
- full floors now used by default (also floor shape setting has other options now)
- when you change the settings, the engine now tries to keep as much as possible (e.g., remap the camera position)
- no shadow option now disables monster shadows
- fixed a bug with Goldberg embeddings

Other fixes:
- fixed key conflict for the cell boundaries option
- fixed an error computing distances in bitruncated {5,4} causing crashes
- when you die in the racing mode, you just die without obtaining etherality (possible when you change the land e.g. to Rose Garden or Land of Storms)
- fixed single tile pattern for texture mode in spherical geometry; also changing the pattern in texture mode no longer affects map editor pattern

2023-03-23 09:34 Update 12.1k:
Aperiodic tilings:
- "Aperiodic Hat" tiling [ https://arxiv.org/pdf/2303.10798.pdf ]
- adjacency rule (for Minefield) now changeable in aperiodic tilings
- patched chaos now works in aperiodic tilings
- nicer tile borders in aperiodic tilings

New projections:
- nicer Conformal Square projection (with transition and shader, and all 2D geometries)
- horocyclic equal-area projection
- change axe angle in axial-like projections

Line patterns:
- more configuration for meridian/parallel patterns
- new linepattern "tessellation walls"

Other:
- better fog color in 3D ball model

2023-03-25 09:28 Update 12.1l:
Improvements to the "aperiodic hat":
- better centering
- fixed a bug creating bad tiles
- "hat parameter" transforms continuously (as in Section 6 of https://arxiv.org/pdf/2303.10798.pdf)
- better pseudo-heptagon assignment (for Graveyard/RRV/etc)
- improved Jungle, Land of Storms, Palace
- "fake curvature" works with hat now

Other fixes:
- do not display relativistic modes in model list
- an option to not display default help (in "basic interface")

2023-03-26 09:41 Update 12.1m:
- Fixed some crashes when changing the hat parameter, embedding hat, while embedding tessellation from file, using hat with fake geometry. Also fake geometry now appears in the menu for hat.

2023-03-28 22:58 Update 12.1n:
- Aperiodic Hat fixes:
- - fixed Frog Park (jump rules and graphics)
- - fixed the Terracotta display (lines displayed, but they are not accurate, so cells are marked too)
- - interesting values of the hat parameter are displayed in hat parameter config
- - special welcome message

- fixed crashes and floor graphics in Zebra in some geometries (hat, kite-and-dart)
- Swap the Red Troll's hair & fur colors (thanks to @jlmjlm)
- Experimental fractal geometries (experiment with geometry -> Euclidean)
- fixed Terracotta in Euclidean disk

2023-03-29 09:10 Update 12.1o:
- fixed the orientation in the hat tiling
- fixed bugs when regenerating a map in the hat tiling + embedding
- fixed variation not showing in some geometries

2023-05-19 01:15 Update 12.1p:
Mostly embedding-related improvements:
- embedding scale parameter now works in "lower curvature" (horospher) embedding (redundant, but useful)
- better wall shading in EuclidSquare embeddings
- many embedding-related fixes
- "Non-Euclidean Third Dimension" demo (of embeddings) in RogueViz
(also, the "imaginary" hat parameter)

2023-05-31 02:18 Update 12.1q:
- Aperiodic Spectre tiling [https://arxiv.org/abs/2305.17743]
- fixed embeddings of Archimedean tilings
- Berger sphere should now work correctly with subdivided cells
- new options mostly for 3D visualizations: circumscribed pseudohedra (a new option in 'make the tiles flat' in 3D config), use plain non-textured floors with alpha transparency (not in menus, find setting 'draw_plain_floors' and 'floor_alpha'); 'big triangular grid' line pattern should now work in Euclidean "Goldberg"
